/* ------------------------------------------------------------------------ *\
 * $Id: partmn.vs,v 1.19 93/09/07 14:37:12 pras Stab $
 * Partitioner Menu Land
 *
 * Created 11/92 by Bob D. acc to recommendations by Dave A. with
 * modifications from all sorts of other sources.
 * 
 * Copyright (c) 1992 by Viewlogic Systems, Inc.
 * ---- change log ommitted ----
\* ------------------------------------------------------------------------ */

setup_technology_menu :=
    vcWv.MakeMenu("setup_technology",
                  list("Act-1",       "techpkg a1000"),
                  list("Act-2",       "techpkg a1200"),
                  list("Xilinx 3000", "techpkg x3000"),
                  list("Xilinx 4000", "techpkg x4000"));

setup_device_menu := vcWv.MakeMenu("setup_device",
                                   list("Technology", setup_technology_menu),
                                   list("Package",    package_pick_cmd));

setup_system_wide_nets_menu :=
    vcWv.MakeMenu("setup system-wide nets",
                  vcWv.Pin(),
                  list("List Nets", list_system_wide_nets_cmd),
                  list("Add", add_system_wide_net_cmd),
                  list("Delete", delete_system_wide_net_cmd),
                  list("Set Threshold", set_pin_count_threshold_cmd),
                  list("About", about_SW_nets_cmd));

/* top level entries */
setup_menu := vcWv.MakeMenu("setup",
                            list("Device", setup_device_menu),
                            list("Auto Group Threshold", auto_group_cmd),
                            list("Utilization", utilization_cmd),
                            list("Goal Num Partitions", setup_goal_cmd),
                            list("System-wide Nets",
                                 setup_system_wide_nets_menu),
                            list("SoftMacros", soft_macros_cmd),
                            list("Load User TechFile", load_user_macro_cmd),
                            list("Preferences", vcWin.PrefsCmd),
                            vcWv.Separator(),
                            list("List Setup", setup_list_cmd));

file_menu := vcWv.MakeMenu("file",
                           list("Load Design", load_design_cmd),
                           list("Write Netlists", write_wirelists_cmd),
                           list("Write To", write_to_cmd),
                           list("Write Report", write_report_cmd));

info_menu := vcWv.MakeMenu("info",
                           list("Find Component", find_component_cmd),
                           list("Net Connections", net_connections_cmd),
                           list("User Groups", show_user_groups_cmd),
                           list("Auto Groups",
                                show_auto_groups_cmd),
                           /*list("System-Wide Nets", show_SW_nets_cmd),*/
                           /*list("Status", show_status_cmd),*/
                           list("Summary", show_summary_cmd),
                           list("Total", show_total_cmd));
/*                           list("Graphics", info_graphics_cmd)); */

change_menu := vcWv.MakeMenu("change",
                             list("Move Component", move_component_cmd),
                             list("Scatter Partition",
                                  scatter_partition_cmd),
                             list("Scatter All", scatter_all_cmd),
                             list("Lock Partition", lock_partition_cmd),
                             /*list("What If", what_if_cmd),*/
                             list("About", about_change_cmd));

main_menu := vcWv.MakeMenu("vpart",
                           vcWin.RedSquareEntry,
                           list("Setup", setup_menu),
                           list("File", file_menu),
                           list("Partition", partition_cmd),
                           list("Change", change_menu),
                           list("Info", info_menu));

vcFac.set_menus(fac, main_menu);
