/* $Header: /import/RCS/50RCS/./afe/vstate/RCS/types.h,v 1.1 93/11/03 12:34:51 dahan Stab $ */
/*
 *	file name   :	$Source  : /import/RCS/50RCS/./afe/vstate/RCS/types.h,v $
 *	file version:	$Revision: 1.1 $
 *
 *	purpose:	
 *
 *	author(s):	
 *	date started:	
 *	date changed:	$Date    : 93/11/03 12:34:51 $
 *	last change by:	$Author  : dahan $
 *
 *	(c) Copyright i-Logix Inc., 1991
 */

/*    types definition */

typedef char     boolean;
typedef boolean  event;
typedef boolean  condition;
typedef char     *string;
typedef double   real;
typedef char     *genptr;
typedef unsigned bit_array;
typedef unsigned bit;
  
#define TRUE            1
#define FALSE           0
  
typedef enum {nonactive, active, hanging, frozen} activity_enum;

typedef activity_enum  activity;

typedef enum { operating, terminated } scope_status;

/* time units */

#define PS   1.0/1000000000000.0
#define NS   1.0/1000000000.0
#define US   1.0/1000000.0
#define MS   1.0/1000.0
#define SEC  1.0
#define MINUTE  60.0
#define HR   3600.0


/* std macros and functions definition */

#define ABS(x)         ((x>0)?x:-(x))
#define MAX(x,y)       ((x>y)?x:y)
#define MIN(x,y)       ((x<y)?x:y)
#define MOD(x,y)       (x % y)
#define ROUND(f)       ((f>0) ? (int)(f + 0.5) : (int)(f - 0.5))
#define TRUNC(f)       ((int)f)
#define SINE(x)        sin(x)
#define COSINE(x)      cos(x)
#define TANGENT(x)     tan(x)
#define LSHR(x,n)      ((unsigned) ((unsigned) (x) >> n ))
#define LSHL(x,n,len)  ((unsigned) ( ((unsigned) (x) << n) & LSHR(~0, 32-len)))
#define ASHL(x,n,len)  LSHL(x,n,len)
#define SIGNED(x,len)\
      ((getbits(x, len-1, len-1,0))?(x | ~LSHR(~0, 32-len) ): (x))

#define BITS_OF(x,from,to)\
        ((from>to)?getbits(x, from, to, 0):getbits(x, 31-from, 31-to,0))

#define ASHR(x,n,len)  ( getbits(SIGNED(LSHR(x,n), (len-n)), len-1,0,0) )

extern double RANDOM(), RAND_EXPONENTIAL(), RAND_UNIFORM(), RAND_SNORMAL(),
              RAND_NORMAL(), pow();

/*
 * $Log:	types.h,v $
 * Revision 1.1  93/11/03  12:34:51  dahan
 * Initial revision
 * 
 * Revision 1.8  92/08/16  10:41:22  ronen
 * added the low parameter for all the appearences of getbits
 * 
 * Revision 1.7  92/08/06  09:49:48  smadar
 * Fix lshl
 * 
 * Revision 1.6  92/08/03  17:43:36  ronen
 * added the low parameter always 0 forr getbits
 * 
 * Revision 1.5  92/05/03  10:10:36  smadar
 * *** empty log message ***
 * 
 * Revision 1.4  92/03/18  14:35:07  smadar
 * *** empty log message ***
 * 
 * Revision 1.3  92/03/03  06:51:03  smadar
 * *** empty log message ***
 * 
 * Revision 1.2  92/02/11  14:37:39  smadar
 * First phase
 * 
 * Revision 1.1  92/01/19  14:51:56  smadar
 * Initial revision
 * 
 */
