/*
 * Name: VDRAW2.VS (Part 2 of Vdraw.vs)
 *
 * Facility: VDRAW
 * 
 * Functional Description: 
 *    Viewscript file for Viewdraw.  (Copied initially from vplace.vs)
 *
 * Environment:
 *     SunOS 4.1 & CORE 5.0
 *     
 * Author:  
 *     Ron Maxwell, February 12, 1991  (vplace.vs)
 *
 * Modified by: 
 * Who            Version   When      What
 * PJS
 * VFE            5.13      10-12-93  Added database error verbose mode.
 * 
 * (c) Copyright 1991, 1992 by Viewlogic Systems, Inc.
 */

/* ************************************************************************ */
/* MODE commands.  Use defines as above or viewdraw.ini keyword as 1st arg. */
/* ************************************************************************ */

bon_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Border, ON);
                  vrefresh (d);
              }, "bon");

boff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Border, OFF);
                  vrefresh (d);
              }, "boff");
non_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Names, ON);
                  vrefresh (d);
              }, "non");
noff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Names, OFF);
                  vrefresh (d);
              }, "noff");
cton_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Comptext, ON);
                  vrefresh (d);
              }, "cton");
ctoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Comptext, OFF);
                  vrefresh (d);
              }, "ctoff");

ton_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setobjvis (vqObject.Text, ON);
                  vrefresh (d);
              }, "ton");
toff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setobjvis (vqObject.Text, OFF);
                  vrefresh (d);
              }, "toff");
don_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Detail, ON);
                  vrefresh (d);
              }, "don");

doff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Detail, OFF);
                  vrefresh (d);
              }, "doff");

aon_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setobjvis (vqObject.Attribute, ON);
                  vrefresh (d);
              }, "aon");
aoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setobjvis (vqObject.Attribute, OFF);
                  vrefresh (d);
              }, "aoff");

lon_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setobjvis (vqObject.Label, ON);
                  vrefresh (d);
              }, "lon");

loff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setobjvis (vqObject.Label, OFF);
                  vrefresh (d);
              }, "loff");

con_cmd :=
    vcWv.Cmd (fac, func(d, e) viewcontext (d, e);, "con");

coff_cmd :=
    vcWv.Cmd (fac, func(d, e) close_context (d, e);, "coff");

von_cmd  :=
    vcWv.Cmd (fac, func(d, e) setmode (vqMode.Values, ON);
                  /* vrefresh (d); */ /* Add curlies if uncommented */
              , "von");
voff_cmd :=
    vcWv.Cmd (fac, func(d, e) setmode (vqMode.Values, OFF);
                  /* vrefresh (d); */ /* Add curlies if uncommented */
              , "voff");
/* #if (ENH_OAT) */
oatson_cmd  :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Oats, ON);
                  enable_cmds (d); 
                  vrefresh (d);
              }, "oatson");
oatsoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Oats, OFF);
                  enable_cmds (d);
                  vrefresh (d);
              }, "oatsoff");
/* #endif (ENH_OAT) */
pon_cmd  :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.PNums, ON);
                  vrefresh (d);
              }, "pon");
poff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.PNums, OFF);
                  vrefresh (d);
              }, "poff");

dboxon_cmd  := vcWv.Cmd (fac, func(d, e);, "dboxon");
dboxoff_cmd := vcWv.Cmd (fac, func(d, e);, "dboxoff");

ron_cmd  :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.RNums, ON);
                  vrefresh (d);
              }, "ron");
roff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.RNums, OFF);
                  vrefresh (d);
              }, "roff");
sorton_cmd  :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Sort, ON);
                  vrefresh (d);
              }, "sorton");
sortoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Sort, OFF);
                  vrefresh (d);
              }, "sortoff");
uon_cmd  :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.UniqueLabel, ON);
                  vrefresh (d);
              },
              "uon");
uoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.UniqueLabel, OFF);
                  vrefresh (d);
              },
              "uoff");
unon_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Undo, ON);
                  vrefresh (d);
              }, "unon");
unoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Undo, OFF);
                  vrefresh (d);
              }, "unoff");

hon_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Header, ON);
                  vrefresh (d);
              }, "hon");

hoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Header, OFF);
                  vrefresh (d);
              }, "hoff");

son_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.SnapToPin, ON);
                  vrefresh (d);
              }, "son");
soff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.SnapToPin, OFF);
                  vrefresh (d);
              }, "soff");

gon_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Grid, ON);
                  vrefresh (d);
              }, "gon");

goff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.Grid, OFF);
                  vrefresh (d);
              }, "goff");

dbevon_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.DBErrVerbose, ON);
                  vrefresh (d);
              }, "dbevon");

dbevoff_cmd :=
    vcWv.Cmd (fac, func(d, e)
              {
                  setmode (vqMode.DBErrVerbose, OFF);
                  vrefresh (d);
              }, "dbevoff");


/* ************************************************************************ */
/* VALUE commands.  Use defines as above or viewdraw.ini keyword as 1st arg.*/
/* ************************************************************************ */

/* Maybe the vrefresh (d) should be a call to the "full" command instead. */

asize_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                           blocksheet (d, e, vqSheetSize.Asize);
                           full (d, e);
                       }), "asize");

bsize_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                           blocksheet (d, e, vqSheetSize.Bsize);
                           full (d, e);
                       }), "bsize");

csize_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                           blocksheet (d, e, vqSheetSize.Csize);
                           full (d, e);
                       }), "csize");
dsize_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                           blocksheet (d, e, vqSheetSize.Dsize);
                           full (d, e);
                       }), "dsize");

esize_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                           blocksheet(d, e, vqSheetSize.Esize);
                           full (d, e);
                       }), "esize");

a4_size_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                             blocksheet (d, e, vqSheetSize.A4size);
                             full (d, e);
                         }), "a4size");

a3_size_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)  {
                             blocksheet (d, e, vqSheetSize.A3size);
                             full (d, e);
                         }), "a3size");

a2_size_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                             blocksheet (d, e, vqSheetSize.A2size);
                             full (d, e);
                         }), "a2size");

a1_size_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                             blocksheet (d, e, vqSheetSize.A1size);
                             full (d, e);
                         }), "a1size");

a0_size_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) {
                             blocksheet (d, e, vqSheetSize.A0size);
                             full (d, e);
                         }), "a0size");

function get_block_width(display)
{
    declare llx, lly, urx, ury;

    getbb (display, &llx, &lly, &urx, &ury);

    urx - llx;

} /* function get_block_width */


function get_block_height(display)
{
    declare llx, lly, urx, ury;

    getbb (display, &llx, &lly, &urx, &ury);

    ury - lly;

} /* function get_block_height */


zsize_cmd := vcWv.Cmd (fac, FILE_CHECK2 (func(d, e, w, h) {
                           blockzsheet (d, e, w, h);
                           full (d, e);
                       }),
                       "zsize", "ZSize",
                       vcWv.Param ("Width", vqBlockWidthVT,
                                   DYNAMIC, get_block_width),
                       vcWv.Param ("Height", vqBlockHeightVT,
                                   DYNAMIC, get_block_height));

/* TEXT ORIGIN command */
origin_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func (d, e, p1) torigin (d, e, p1);),
                        "origin", "TextOrigin",
                        vcWv.Param ("Text Origin",
                                    vqOriginVT,
                                    DYNAMIC, getorigin));

o1_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "1");), "o1");
o2_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "2");), "o2");
o3_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "3");), "o3");
o4_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "4");), "o4");
o5_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "5");), "o5");
o6_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "6");), "o6");
o7_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "7");), "o7");
o8_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "8");), "o8");
o9_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e) torigin (d, e, "9");), "o9");

/* TEXT SIZE command */
size_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func (d, e, p1) tsize (d, e, p1);), 
                      "size", "TextSize",
                      vcWv.Param ("Text Size",
                                  vlPositiveIntVT,
                                  DYNAMIC, get_valuei ("tsize")));

/* ---------------------------------------------------------------------- */

_tstring_cmd := vcWv.Cmd (fac, 
                          FILE_CHECK4 (func (d, e, p1, p2, p3, p4) 
                                       tstring (d, e, p1, p2, p3, p4);),
                          "_string", "Change string",
                          vcWv.Param ("Object type", vqObjectVT,
                                      STICKY, vqObject.String),
                          vcWv.Param ("Expand", vlYesNoVT, CONSTANT, "yes"),
                          vcWv.Param ("If strings run out",
                                      vqApplyStringModeVT,
                                      STICKY, "Apply_Full_String"),
                          vcWv.Param ("String", vlStringRestOfLine1VT,
                                      CONSTANT, ""));

function chgstring(display, event, str, obj_type)
{
    declare count;

    function prompt_expand2(display, event, expand, cycle)
        vcCmd.Run (_tstring_cmd, display, event,
                   list (obj_type, expand, cycle, str), TRUE);

    prompt_expand2_cmd := vcWv.Cmd (fac, prompt_expand2,
                                    nil, "Expand string",
                                    vcWv.Param ("Expand String",
                                                vlYesNoVT, CONSTANT, "yes"),
                                    vcWv.Param ("If strings run out",
                                                vqApplyStringModeVT,
                                                STICKY, "Apply_Full_String"));

    function prompt_expand(display, event, expand)
        vcCmd.Run (_tstring_cmd, display, event,
                   list (obj_type, expand, "End_Command", str), TRUE);

    prompt_expand_cmd := vcWv.Cmd (fac, prompt_expand,
                                   nil, "Expand string",
                                   vcWv.Param ("Expand String",
                                               vlYesNoVT, CONSTANT, "yes"));

    if (obj_type == vqObject.Label) {

        bind_middle_button (chglab_kbd_cmd);
        count = numselobj (display, vqObject.Label);
    }
    else if (obj_type == vqObject.Attribute) {

        bind_middle_button (chgattr_kbd_cmd);
        count = numselobj (display, vqObject.Attribute);
    }
    else if (obj_type == vqObject.Oattribute) {

        bind_middle_button (chgoattr_kbd_cmd);
        numsel = numselobj (display, vqObject.Oattribute);
    }
    else if (obj_type == vqObject.Text) {

        bind_middle_button (chgtext_kbd_cmd);
        count = numselobj (display, vqObject.Text);
    }
    else { /* if (obj_type == vqObject.String) */

        bind_middle_button (chgstring_kbd_cmd);
        count = numselobj (display, vqObject.String);
    }

    if (labelwidth (display, str) > 1) {

        if (count > 1)
            vcCmd.Run (prompt_expand2_cmd, display, event, nil, FALSE);
        else
            vcCmd.Run (prompt_expand_cmd, display, event, nil, FALSE);
    }
    else
        vcCmd.Run (_tstring_cmd, display, event,
                   list (obj_type, "no", "End_Command", str), TRUE);
}
chglabstring_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, str)
                                   chgstring (d, e, str, vqObject.Label);),
                              "chglabel", "Change Label",
                              vcWv.Param ("Label", vlStringRestOfLine1VT,
                                          DYNAMIC,
                                          get_string (vqObject.Label)));
   
vcCmd.EnableMacro (chglabstring_cmd, FALSE);

chglabel_from_buffer_cmd := vcWv.Cmd (fac, FILE_CHECK0 (nextstring));

function kbd_chglabel(display, event)
{
    if (   emptystring (display, "chg-label")
        || !canapplystring (display, "chg-label"))

        vcCmd.Run (chglabstring_cmd, display, event, nil, TRUE);
    else
        vcCmd.Run (chglabel_from_buffer_cmd, display, event, nil, TRUE);

} /* function kbd_chglabel */

chglab_kbd_cmd := vcWv.Cmd (fac, FILE_CHECK0 (kbd_chglabel), 
                            "next-label-string");
vcCmd.EnableMacro (chglab_kbd_cmd, FALSE);


chgattrstring_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, str)
                                   chgstring (d, e, str, vqObject.AnyAttr);),
                               "chgattr", "Change Attribute",
                               vcWv.Param ("Attribute", vlStringRestOfLine1VT,
                                           DYNAMIC,
                                           get_string (vqObject.AnyAttr)));

vcCmd.EnableMacro (chgattrstring_cmd, FALSE);

chgattr_from_buffer_cmd := vcWv.Cmd (fac, FILE_CHECK0 (nextstring));

function kbd_chgattr(display, event)
{
    if (   emptystring (display, "chg-attr")
        || !canapplystring (display, "chg-attr"))

        vcCmd.Run (chgattrstring_cmd, display, event, nil, TRUE);
    else
        vcCmd.Run (chgattr_from_buffer_cmd, display, event, nil, TRUE);

} /* function kbd_chgattr */

chgattr_kbd_cmd := vcWv.Cmd (fac, FILE_CHECK0 (kbd_chgattr), "next-attr-string");
vcCmd.EnableMacro (chgattr_kbd_cmd, FALSE);


/* #if (ENH_OAT) */

chgoattrstring_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, str)
                               chgstring (d, e, str, vqObject.Oattribute);),
                               "chgoattr", "Change Oat",
                               vcWv.Param ("Attribute", vlStringRestOfLine1VT,
                                           DYNAMIC,
                                           get_string (vqObject.Oattribute)));

vcCmd.EnableMacro (chgoattrstring_cmd, FALSE);

chgoattr_from_buffer_cmd := vcWv.Cmd (fac, FILE_CHECK0 (nextstring));

function kbd_chgoattr(display, event)
{
    if (   emptystring (display, "chg-oattr")
        || !canapplystring (display, "chg-oattr"))

        vcCmd.Run (chgoattrstring_cmd, display, event, nil, TRUE);
    else
        vcCmd.Run (chgoattr_from_buffer_cmd, display, event, nil, TRUE);

} /* function kbd_chgoattr */

chgoattr_kbd_cmd := vcWv.Cmd (fac, FILE_CHECK0 (kbd_chgoattr), "next-oattr-string");
vcCmd.EnableMacro (chgoattr_kbd_cmd, FALSE);


/* #endif */

chgtextstring_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, str)
                                   chgstring (d, e, str, vqObject.Text);),
                               "chgtext", "Change Text",
                               vcWv.Param ("Text", vlStringRestOfLine1VT,
                                           DYNAMIC,
                                           get_string (vqObject.Text)));

vcCmd.EnableMacro (chgtextstring_cmd, FALSE);

/* Allow for editing of Japanese text by calling kanji editor */
if (vcWv.OS (wv) == vcOs.Unix) {
    chgkanjistring_cmd := vcWv.Cmd (fac, FILE_CHECK1 (kstring), 
                               "chgkanji", "Change Japanese Text",
                               vcWv.Param ("", vlStringRestOfLine1VT,
                                           DYNAMIC, 
                                           get_kanji_string (),
                                           vjEditor.fac));
    vcCmd.EnableMacro (chgkanjistring_cmd, FALSE);
}


chgtext_from_buffer_cmd := vcWv.Cmd (fac, FILE_CHECK0 (nextstring));

function kbd_chgtext(display, event)
{
    if (   emptystring (display, "chg-text")
        || !canapplystring (display, "chg-text"))

        vcCmd.Run (chgtextstring_cmd, display, event, nil, TRUE);
    else
        vcCmd.Run (chgtext_from_buffer_cmd, display, event, nil, TRUE);

} /* function kbd_chgtext */

chgtext_kbd_cmd := vcWv.Cmd (fac, FILE_CHECK0 (kbd_chgtext), "next-text-string");
vcCmd.EnableMacro (chgtext_kbd_cmd, FALSE);


function chgstring4(display, event, str, obj_type)
{
    function prompt_expand(display, event, expand)
        vcCmd.Run (_tstring_cmd, display, event,
                   list (obj_type, expand, "Apply_Full_String", str), TRUE);

    prompt_expand_cmd := vcWv.Cmd (fac, prompt_expand,
                                   nil, "Expand string",
                                   vcWv.Param ("Expand String",
                                               vlYesNoVT, CONSTANT, "yes"));

    bind_middle_button (chgstring_kbd_cmd);

    if ((labelwidth (display, str) > 1) && (obj_type != vqObject.Text))
        vcCmd.Run (prompt_expand_cmd, display, event, nil, FALSE);
    else
        vcCmd.Run (_tstring_cmd, display, event,
                   list (obj_type, "no", "Apply_Full_String", str), TRUE);
}
string_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, str)
                            chgstring4 (d, e, str, vqObject.String);),
                        "string", "Change String",
                        vcWv.Param ("String", vlStringRestOfLine1VT,
                                    DYNAMIC, 
                                    get_string (vqObject.String)));

vcCmd.EnableMacro (string_cmd, FALSE);

chgstring_from_buffer_cmd := vcWv.Cmd (fac, FILE_CHECK0 (nextstring));

function kbd_chgstring(display, event)
{
    if (   emptystring (display, "chg-string")
        || !canapplystring (display, "chg-string"))

        vcCmd.Run (string_cmd, display, event, nil, TRUE);
    else
        vcCmd.Run (chgstring_from_buffer_cmd, display, event, nil, TRUE);

} /* function kbd_chgstring */

chgstring_kbd_cmd := vcWv.Cmd (fac, FILE_CHECK0 (kbd_chgstring), "next-string");
vcCmd.EnableMacro (chgstring_kbd_cmd, FALSE);


/* ---------------------------------------------------------------------- */

sed_cmd := vcWv.Cmd (fac, FILE_CHECK2 (sedstring), 
                     "sed", "Edit using Regular Expression",
                     vcWv.Param ("RegExp", vlStringRestOfLine1VT,
                                 DYNAMIC, get_string (vqObject.String)),
                     vcWv.Param ("Replacement", vlStringRestOfLine1VT,
                                 DYNAMIC, get_string (vqObject.String)));

/* Change Attribute NAME */
name_cmd := vcWv.Cmd (fac, FILE_CHECK1 (name), "name", "Attribute Name",
                      vcWv.Param ("Attribute", string, DYNAMIC, getattrname));

/* Change Attribute VALUE */
value_cmd := vcWv.Cmd (fac, FILE_CHECK1 (value), "value", "Attribute Value",
                       vcWv.Param ("Attribute value",
                                   string, DYNAMIC, getattrvalue));

/* Change component command */
chgcomp_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, name)
                             nccomp (name);),
                         "_ccomp", "Change Component",
                         vcWv.Param ("Component", string,
                                     DYNAMIC, getcomp));

function chg_comp(display, event, name)
{
    if (string_eq (name, "") || contains_wildcards (name))
        build_ccomp_dialog (display, vcEvent.Window (event), 
                            getcomp (display));
    else
        vcCmd.Run (chgcomp_cmd, display, event, list (name), TRUE);
}
ccomp_cmd := vcWv.Cmd (fac, FILE_CHECK1 (chg_comp), 
                       "ccomp", "Change Component",
                       vcWv.Param ("Component name",
                                   vlStringRestOfLineVT, STICKY, ""));

vcCmd.EnableMacro (ccomp_cmd, FALSE);

ccomp_menu_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                                chg_comp (d, e, "");)
                            /* No name.  Not meant to be typed */);

/* Attribute VISIBILITY command */
attrvis_cmd := vcWv.Cmd (fac, FILE_CHECK3 (avis), 
                         "avisibility", "Attribute Visibility",
                         vcWv.Param ("Attribute text string",
                                     string, CONSTANT, "*"),
                         vcWv.Param ("Visibility", vqAttrVisibilityVT,
                                     STICKY, "Invisible"),
                         vcWv.Param ("All or Selected", vqAllOrSelectedVT,
                                     STICKY, "All"));

/* These are the old attribute visibility commands */

avis_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, n)
                          avis (d, e, n, "Visible", "All");),
                      "avis",
                      "Make Attribute Visible",
                      vcWv.Param ("Attribute text string",
                                  string, CONSTANT, "*"));

anvis_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, n)
                           avis (d, e, n, "Name", "All");),
                       "anvis",
                       "Make Attribute Invisible",
                       vcWv.Param ("Attribute text string",
                                   string, CONSTANT, "*"));

avvis_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, n)
                           avis (d, e, n, "Value", "All");),
                       "avvis",
                       "Make Attribute Value Visible",
                       vcWv.Param ("Attribute text string",
                                   string, CONSTANT, "*"));

ainvis_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, n)
                            avis (d, e, n, "Invisible", "All");),
                        "ainvis",
                        "Make Attribute Name Visible",
                        vcWv.Param ("Attribute text string",
                                    string, CONSTANT, "*"));

nattrvis_cmd := vcWv.Cmd (fac, navis, "navisibility",
                          "New Attribute Visibility",
                          vcWv.Param ("Visibility", vqAttrVisibilityVT,
                                      STICKY, "Value"));

/* These are the 4.1 new attribute visibility commands */

navis_cmd   := vcWv.Cmd (fac, func(d, e) navis (d, e, "Visible");, "navis");
nanvis_cmd  := vcWv.Cmd (fac, func(d, e) navis (d, e, "Name");, "nanvis");
navvis_cmd  := vcWv.Cmd (fac, func(d, e) navis (d, e, "Value");, "navvis");
nainvis_cmd := vcWv.Cmd (fac, func(d, e)navis (d, e, "Invisible");, "nainvis");

/* Label VISIBILITY command */
labelvis_cmd := vcWv.Cmd (fac, FILE_CHECK3 (lvis), 
                          "lvisibility", "Label Visibility",
                          vcWv.Param ("Label text string",
                                      string, CONSTANT, "*"),
                          vcWv.Param ("Visibility", vqLabelVisibilityVT,
                                      STICKY, "Invisible"),
                          vcWv.Param ("All or Selected", vqAllOrSelectedVT,
                                      STICKY, "All"));

/* These are the 4.1 label visibility commands */
lvis_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, n)
                          lvis (d, e, n, "Visible", "All");),
                      "lvis",
                      "Make Label Visible",
                      vcWv.Param ("Label text string",
                                  string, CONSTANT, "*"));

linvis_cmd := vcWv.Cmd (fac, FILE_CHECK1 (func(d, e, n)
                            lvis (d, e, n, "Invisible", "All");),
                        "linvis",
                        "Make Label Invisible",
                        vcWv.Param ("Label text string",
                                    string, CONSTANT, "*"));

lscope_cmd := vcWv.Cmd (fac, FILE_CHECK1 (lscope),
                        "lscope",
                        "Label Scope",
                        vcWv.Param ("Scope",
                                    vqLabelScopeVT, STICKY, "Local"));

local_cmd :=
    vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                   vcCmd.Run (lscope_cmd, d, e, list ("Local"), FALSE);),
              "local");

global_cmd :=
    vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                   vcCmd.Run (lscope_cmd, d, e, list ("Global"), FALSE);),
              "global");


/* ********************************************************************** */
/* Select commands */
/* ********************************************************************** */

selcomp_cmd := vcWv.Cmd (fac, func(d, e, name, soption)
                         {
                             nscomp (name, soption);
                             enable_cmds (d);
                         },
                         "_scomp", "Select Component",
                         vcWv.Param ("Component", string, STICKY, ""),
                         vcWv.Param ("Option", vqSelectOptionVT,
                                     STICKY, vqSelectOption.Select));

function sel_comp(display, event, str)
{
    /* if (string_eq (str, "") || contains_wildcards (str)) */
    if (string_eq (str, ""))
        build_scomp_dialog (vcEvent.Window (event));
    else
        vcCmd.Run (selcomp_cmd, display, event,
                   list (str, vqSelectOption.Select), TRUE);
}
scomp_cmd := vcWv.Cmd (fac, sel_comp, "scomp", "Select Component",
                       vcWv.Param ("Component",
                                   vlStringRestOfLineVT, STICKY, ""));

vcCmd.EnableMacro (scomp_cmd, FALSE);

scomp_menu_cmd := vcWv.Cmd (fac, func(d, e)
                                   sel_comp (d, e, "*", vqSelectOption.Select);
                            /* Unnamed Command.  NOT meant to be typed! */);

sname_cmd  := vcWv.Cmd (fac, func(d, e, name)
                        {
                            sname (d, e, name);
                            enable_cmds (d);
                        },
                        "sname",
                        "Select Name All",
                        vcWv.Param ("Label", string, CONSTANT, ""));

sfastname_cmd  := vcWv.Cmd (fac, func(d, e, name)
                        {
                            sfastname (d, e, name);
                            enable_cmds (d);
                        },
                        "sfastname",
                        "Select Name Fast",
                        vcWv.Param ("Label", string, CONSTANT, ""));

spinname_cmd  := vcWv.Cmd (fac, func(d, e, name)
                        {
                            spinname (d, e, name);
                            enable_cmds (d);
                        },
                        "spinname",
                        "Select Pin",
                        vcWv.Param ("Label", string, CONSTANT, ""));

svalue_cmd := vcWv.Cmd (fac, func(d, e, value, which)
                        {
                            svalue (d, e, value, which);
                            enable_cmds (d);
                        },
                        "svalue",
                        "Select Value",
                        vcWv.Param ("Attribute value string",
                                    string, CONSTANT, ""),
                        vcWv.Param ("All or Selected", vqAllOrSelectedVT,
                                    STICKY, "All"));

stext_cmd  := vcWv.Cmd (fac, func(d, e, str, which)
                        {
                            stext (d, e, str, "text", which);
                            enable_cmds (d);
                        },
                        "stext",
                        "Select Text",
                        vcWv.Param ("Text string", string, CONSTANT, "*"),
                        vcWv.Param ("All or Selected", vqAllOrSelectedVT,
                                    STICKY, "All"));

sattr_cmd  := vcWv.Cmd (fac, func(d, e, attr, which)
                        {
                            stext (d, e, attr, "attribute", which);
                            enable_cmds (d);
                        },
                        "sattr",
                        "Select Attribute",
                        vcWv.Param ("Attribute text string",
                                    string, CONSTANT, "*"),
                        vcWv.Param ("All or Selected", vqAllOrSelectedVT,
                                    STICKY, "All"));

slabel_cmd  := vcWv.Cmd (fac, func(d, e, label, which)
                         {
                             stext (d, e, label, "label", which);
                             enable_cmds (d);
                         },
                         "slabel",
                         "Select Label",
                         vcWv.Param ("Label", string, CONSTANT, "*"),
                         vcWv.Param ("All or Selected", vqAllOrSelectedVT,
                                     STICKY, "All"));

/* #if (ENH_OAT) */
sarray_cmd := vcWv.Cmd (fac, func(d, e, c, r)
                       {
                            sarray (d, e, c, r);
                            enable_cmds (d);
                       },
                       "sarray", "Select Array",
                       vcWv.Param ("Column", vlPositiveIntVT, STICKY, 1),
                       vcWv.Param ("Row", vlPositiveIntVT, STICKY, 1));

/*
sarray_cmd  := vcWv.Cmd (fac, func(d, e, index_string)
                        {
                            sarray (d, e, index_string);
                            enable_cmds (d);
                        },
                        "sarray",
                        "Select Array",
                        vcWv.Param ("Index", string, CONSTANT, ""));
*/
sparray_cmd  := vcWv.Cmd (fac, func(d, e)
                        {
                            sparray (d, e);
                            bind_middle_button (sparray_cmd);
                            enable_cmds (d);
                        },
                        "prev-array");

snarray_cmd  := vcWv.Cmd (fac, func(d, e)
                        {
                            snarray (d, e);
                            bind_middle_button (snarray_cmd);
                            enable_cmds (d);
                        },
                        "next-array");

/* #endif */

/*-*/

/* FONT command */
font_cmd := vcWv.Cmd (fac, FILE_CHECK1 (font), "font", "Font",
                      vcWv.Param ("Font", vgStkVT, STICKY, "Fixed"));

/* COLOR command */
color_cmd := vcWv.Cmd (fac, FILE_CHECK1 (color), "color", "Color",
                       vcWv.Param ("Color", vgColorVT, DYNAMIC, getobjcolor));

/* FSTYLE command */
fstyle_cmd := vcWv.Cmd (fac, FILE_CHECK1 (fstyle), "fstyle", "Fill Style",
                        vcWv.Param ("Fill Style",
                                    vgFillVT, DYNAMIC, getobjfstyle));

/* LSTYLE command */
lstyle_cmd := vcWv.Cmd (fac, FILE_CHECK1 (lstyle), "lstyle", "Line Style",
                        vcWv.Param ("Line Pattern",
                                    vgLinePatternVT, DYNAMIC, getobjlstyle));

vcCmd.EnableApply (font_cmd,   TRUE);
vcCmd.EnableApply (color_cmd,  TRUE);
vcCmd.EnableApply (fstyle_cmd, TRUE);
vcCmd.EnableApply (lstyle_cmd, TRUE);

sdist_cmd := vcWv.Cmd (fac, sdistance, "sdistance", "Selection Distance",
                       vcWv.Param ("Selection Distance", vlPositiveIntVT,
                                   DYNAMIC, get_value ("Selection")));

adist_cmd := vcWv.Cmd (fac, adistance, "adistance", "Avoidance Distance",
                       vcWv.Param ("Avoidance Distance", vlPositiveIntVT,
                                   DYNAMIC, get_value ("adistance")));

typed_delete_cmd :=
    vcWv.Cmd (fac, FILE_CHECK1 (func(display, event, arg)
              {
                  delete (display, event, arg);
                  enable_cmds (display);
              }), "delete", "Delete",
              vcWv.Param ("Cmdline", vlStringRestOfLineVT, STICKY, ""));

delete_cmd :=
    vcWv.Cmd (fac, FILE_CHECK0 (func(display, event)
              {
                  delete (display, event, "");
                  enable_cmds (display);
              }), "_delete");

undo_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                      {
                          undo (d, e);
                          enable_cmds (d);
                      }),
                      "undo");

redo_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                      {
                          redo (d, e);
                          enable_cmds (d);
                      }),
                      "redo");

clrundo_cmd := vcWv.Cmd (fac, FILE_CHECK0 (clrundo), "clrundo");


/* Builds and displays the dialog box giving options for handling missing
 * lock file problem during the reading of schematic or symbols.  Each
 * option is presented in a button which executes the desired command
 */
function read_filelock_options(display, event, cmd, reread)
{
    declare libcompext_name;
    declare popup;

    data_type := getblockdatatype (display);
    blkname := getblkfullname (display);

    if (data_type == vqDataType.Schematic)
        prompt := " Schematic ";
    else
        prompt := " Symbol ";


    str := "You do not have a lock for " + prompt + blkname + "

";

    table := vcTable.Create (cmd, 2, 1);
    vcTable.Add (table, text := vcRegion.Create1 ("msg", vcStaticText.fac, str, nil));

    buttons := vcRegion.Create ("Buttons", vcButnRow.fac,
                        list (list ("WriteTo", "WriteTo",
                                    func() {
                                        vcWin.Close (popup);
                                        vcCmd.Run (_writeto_cmd, display,
                                                   event, nil, TRUE);
                                    },
                                    nil),
                              list ("Overwrite", "Overwrite existing file",
                                    func() {
                                        lockfile (display);
                                        vcCmd.Run (_write_cmd, display, 
                                                   event, nil, TRUE);
                                        vcWin.Close (popup);
                                    },
                                    nil),
                              list ("Discard", "Discard changes and reread",
                                    func() {
                                        lockfile (display);
                                        if (reread == TRUE)
                                            vcCmd.Run (_read2_cmd, display, 
                                                       event, nil, TRUE);
                                        else
                                            vcCmd.Run (_read_cmd, display, 
                                                       event, nil, TRUE);
                                        vcWin.Close (popup);
                                    },
                                    nil),
                              list ("Cancel", "Cancel",
                                    func() {
                                        vcCmd.Run (vcWin.wclose,
                                                   popup,
/*                                                   vcEvent.Window (event), */
                                                   event, nil, TRUE);
                                    },
                                    nil)));

    vcTable.Add (table, buttons);
    popup = vcWin.Popup (vcEvent.Window (event), table, text, 7);

} /* read_filelock_options */

/* This function reads a block without refreshing the display. */
function do_read2(display, event) 
    read2 (display, event);
_read2_cmd := vcWv.Cmd (fac, do_read2, "_read2");

/* This function reads a block and refreshes the display (the refresh
 * is in the C callback).  If there is no lockfile for the given file, 
 * a lock is created and the read is redone.
 */
function do_read(display, event)
{
    vcWin.Busy (vcEvent.Window (event), TRUE);

    if (!read (display, event)) {
        lockfile (display);
        read (display, event);
    }

    vcWin.Busy (vcEvent.Window (event), FALSE);
};
_read_cmd := vcWv.Cmd (fac, do_read, "_read");

/* This function reads a block but checks to see if it is modified.
 * If modified, the user is presented options.  If no lock file 
 * exists, the user is presented options. 
 */
function read_block(display, event)
{
    if (blkmodified (display) == 1) {

        /* if no lock exists for this file, give user appropriate options */
        if (!islocked (display))  {
            vcWin.Busy (vcEvent.Window (event), TRUE);
            read_filelock_options (display, event, "Read", FALSE);
            vcWin.Busy (vcEvent.Window (event), FALSE);
        }
        else {
            if (getblockdatatype (display) == vqDataType.Schematic)
                prompt := " Schematic ";
            else
                prompt := " Symbol ";
            
            prompt = prompt + convert (string, getblkfullname (display))
                + " has been modified.  Are you sure?" ;
            
            maybe_run_cmd ("OK to read?", prompt,
                           _read_cmd, display, event, nil);
        }
    }
    else
        vcCmd.Run (_read_cmd, display, event, nil, TRUE);
}
read_cmd := vcWv.Cmd (fac, read_block, "read");
vcCmd.EnableMacro (read_cmd, FALSE);


_restore_cmd := vcWv.Cmd (fac, func(display, event)
                          {
                              vcWin.Busy (vcEvent.Window (event), TRUE);
                              restore (display, event);
                              vcWin.Busy (vcEvent.Window (event), FALSE);
                          }, "_restore");

function restore_from_backup(display, event)
{
    /* But what if there is no backup? */

    if (blkmodified (display) == 1) {

        if (getblockdatatype (display) == vqDataType.Schematic)
            prompt := " Schematic ";
        else
            prompt := " Symbol ";

        prompt = prompt + convert (string, getblkfullname (display))
            + " has been modified.  Are you sure?" ;
        
        maybe_run_cmd ("OK to discard changes?", prompt,
                       _restore_cmd, display, event, nil);
    }
    else
        vcCmd.Run (_restore_cmd, display, event, nil, TRUE);

} /* function restore_from_backup */

restore_cmd := vcWv.Cmd (fac, FILE_CHECK0 (restore_from_backup), "restore");
vcCmd.EnableMacro (restore_cmd, FALSE);


/* Read the file without refreshing the screen.  This is used for
 * sheets which are loaded but not currently displayed.  If no
 * lockfile exists for the file, one is created and the read is redone.
 */
function reread3(display, event)
{

    if (!islocked (display))
        lockfile (display);
    
    read2 (display, event);
}

/* Walk all the currently loaded blocks and reread them.  If a 
 * block is modified and not saved, give the user the option to
 * abort (the entire command).  Display the number of blocks
 * reread.
 */
function reread2(display, event, unmodified)
{
    declare blkname, str;
    read_count := 0;

    foreach (blkname; blocks ()) {
        if (unmodified == 1) {
            if (blkmodified (display) == 0) {
                read2 (display, event);
                read_count = read_count + 1;
            }
        }
        else {
            read2 (display, event);
            read_count = read_count + 1;
        }
    }

    if (read_count == 1)
        status_msg (vcEvent.Window (event), 
                    sprintf ("%s schematic reread", read_count));
    else
        status_msg (vcEvent.Window (event), 
                    sprintf ("%s schematics reread", read_count));
}

/* Builds and displays the dialog box giving options for handling
 * modified schematics during the reread command.  Each option is 
 * presented in a button which executes the desired command.
 */
function all_or_unmodified(display, event)
{
    declare popup;

    str := "
  One or more schematics are modified.  Do you wish to reread

";

    table := vcTable.Create ("Reread", 2, 1);
    vcTable.Add (table, vcRegion.Create1 ("msg", vcStaticText.fac, str, nil));

    buttons := vcTable.Create ("table", 1, 3);
    vcTable.Add (buttons,
                 default :=
                 vcLabel.ButtonCreate ("unmodified",
                                       "Unmodified schematics only",
                                       func() {
                                           reread2 (display, event, 1);
                                           vcWin.Close (popup);
                                       },
                                       nil));
    vcTable.Add (buttons,
                 vcLabel.ButtonCreate ("all",
                                       "All schematics",
                                       func() {
                                           reread2 (display, event, 0);
                                           vcWin.Close (popup);
                                       },
                                       nil));
    vcTable.Add (buttons,
                 vcLabel.ButtonCreate ("cancel",
                                       "No schematics.  Cancel command",
                                       func()
                                           vcWin.Close (popup);
                                       , nil));

    vcTable.Add (table, buttons);
    popup = vcWin.Popup (vcEvent.Window (event), table, default, 7);

} /* all_or_unmodified */

/* Check for modified schematics.  Continue if none are modified.
 * Give user options if modified schematics exist.
 */
function maybe_reread_schematics(display, event)
{
    if (modified (display, event, vqDataType.Schematic) == 1)
        all_or_unmodified (display, event);
    else
        reread2 (display, event, 0);
}
reread_cmd := vcWv.Cmd (fac, maybe_reread_schematics, "reread");


/* Free all currently loaded schematics and symbols and replace 
 * them with the specified one.  Checks for modified blocks and,
 * if found, gives user the option of aborting or continuing.
 */
function readreplace(display, event, name)
{
    blklist := "";

    foreach (blkname; lswinblocks (vcEvent.Window (event), 0))
        blklist = blklist + "      " + blkname + "\n";

    if (!string_eq (blklist, "")) {

        str := "
 The following Schematics and Symbols have been edited.

" + blklist + "
 You may discard edits now and read the new schematic or 
 symbol, or you may cancel the request and go back and
 write your changes to disk.

";
        table := vcTable.Create ("Replace?", 2, 1);
        vcTable.Add (table, vcRegion.Create ("msg", vcStaticText.fac, str));

        buttons := vcTable.Create ("buttons", 1, 2);

        default_button := vcWv.LabelButtonCreate ("cancel",
                                                  "Cancel, do NOT discard",
                                                  nil, func();,
                                                  list (macro_on <- TRUE,
                                                        close_window <- TRUE));
        vcTable.Add (buttons, default_button);

        close_button := vcWv.LabelButtonCreate ("close",
                                                "Discard changes, then Read",
                                                nil,
                                                func() {

                                  vcWin.Busy (vcEvent.Window (event), TRUE);
                                  readrep (display, event, name);
                                  vcWin.Busy (vcEvent.Window (event), FALSE);
                              },
                                                list (macro_on <- TRUE,
                                                      close_window <- TRUE));
        vcTable.Add (buttons, close_button);
        
        vcTable.Add (table, buttons);
        vcWin.Popup (vcEvent.Window (event), table, default_button,
                     vcWin.NoMenus + vcWin.NoCmdline + vcWin.NoStatus);
    }
    else {

        vcWin.Busy (vcEvent.Window (event), TRUE);
        readrep (display, event, name);
        vcWin.Busy (vcEvent.Window (event), FALSE);
    }
}
readreplace_cmd := vcWv.Cmd (fac, readreplace, 
                             "readreplace", nil,
                             vcWv.Param ("Name", string, CONSTANT, ""));

/* These routines are similar to the "FILE_CHECKn" and "file_mod_options"
 * functions in vdraw.vs, but are used exclusively with file write/save
 * commands.  The only thing they do different is to NOT do the save 
 * before executing the given procedure.  These are needed so that the
 * save is not done twice.
 */
function save_file_mod_options (display, event, proc)
{
    declare popup;

    str := file_mod_str (display, event);

    table := vcTable.Create ("File Modified", 2, 1);
    vcTable.Add (table, text := vcRegion.Create1 ("msg", vcStaticText.fac, str, nil));

    buttons := vcRegion.Create ("Buttons", vcButnRow.fac,
                        list (list ("Read", "Read file from disk",
                                    func() {
                                        vcCmd.Run (_read_cmd, display, 
                                                   event, nil, TRUE);
                                        vcWin.Close (popup);
                                    },
                                    nil),
                              list ("Continue", "Overwrite file on disk",
                                    func() {
                                        lockfile (display);
                                        proc (display, event);
                                        vcWin.Close (popup);
                                    },
                                    nil),
                              list ("Cancel", "Cancel",
                                    func()
                                        vcWin.Close (popup);
                                    , list (macro_on <- TRUE,
                                          close_window <- TRUE))));

    vcTable.Add (table, buttons);
    popup = vcWin.Popup (vcEvent.Window (event), table, text, 7);

} /* save_file_mod_options */

function SAVE_FILE_CHECK0 (proc)
{
    tmp := func (d, e)
           {
               if (!islocked (d))
                   lockfile (d);

               if (islocked (d) && !ismylock (d))
                   file_lock_options (d, e, PROC0 (proc));
               else if (filemodified (d))
                   save_file_mod_options (d, e, PROC0 (proc));
               else 
                   proc (d, e);
           };

    return (tmp);
}

function SAVE_FILE_CHECK1 (proc)
{
    tmp := func (d, e, p1)
           {
               if (!islocked (d))
                   lockfile (d);

               if (islocked (d) && !ismylock (d))
                   file_lock_options (d, e, PROC1 (proc, p1));
               else if (filemodified (d))
                   save_file_mod_options (d, e, PROC1 (proc, p1));
               else 
                   proc (d, e);
           };

    return (tmp);
}


_writeto_cmd := vcWv.Cmd (fac, func(display, event, newname)
                          {
                              vcWin.Busy (vcEvent.Window (event), TRUE);
                              writeto (display, event, newname);
                              vcWin.Busy (vcEvent.Window (event), FALSE);
                          },
                          "_writeto", "WriteTo",
                          vcWv.Param ("Name",
/*                                      string, DYNAMIC, getblkfullname));*/
                                      string, STICKY, ""));

/* This callback determines whether the file for the block exists or not
 * and then invokes the appropriate command.
 */
function maybe_writeto(display, event, newname)
{
    data_type := getblockdatatype (display);
    status    := vqfexists (display, data_type, newname);

    if (status == 1) {

        if (data_type == vqDataType.Schematic)
            prompt := " Schematic ";
        else
            prompt := " Symbol ";

        prompt = prompt + newname + " exists.  Are you sure? ";

        maybe_run_cmd ("OK to overwrite file?", prompt,
                       _writeto_cmd, display, event, list (newname));
    }
    else if (status == -1)
        ;  /* Error of some sort. */

    else
        vcCmd.Run (_writeto_cmd, display, event, list (newname), TRUE);

} /* function maybe_writeto */

writeto_cmd := vcWv.Cmd (fac, maybe_writeto, 
                         "writeto", "Write To",
                         vcWv.Param ("Name", string,
/*                                     DYNAMIC, getblkfullname)); */
                                     STICKY, ""));

vcCmd.EnableMacro (writeto_cmd, FALSE);


/* This callback determines whether the file for the block exists or not
 * and then invokes the appropriate command.
 */

_writenew_cmd := vcWv.Cmd (fac,func(display, event, newname)
                           {
                               vcWin.Busy (vcEvent.Window (event), TRUE);
                               writenew (display, event, newname);
                               vcWin.Busy (vcEvent.Window (event), FALSE);

                           }, "_writenew", "Write new file",
                           vcWv.Param ("File name",
                                       string, DYNAMIC, getblkpath));

function maybe_writenew(display, event, newname)
{
    status := wrnewfexists (display, newname);

    if (status == 1) {

        prompt := " File " + newname + " exists.  Are you sure? ";

        maybe_run_cmd ("OK to overwrite file?", prompt,
                       _writenew_cmd, display, event, list (newname));
    }
    else if (status < 0)
        ;

    else
        vcCmd.Run (_writenew_cmd, display, event, list (newname), TRUE);

} /* function maybe_writenew */

writenew_cmd := vcWv.Cmd (fac, maybe_writenew, 
                          "writenew", "Write new file",
                          vcWv.Param ("File name",
                                      string, DYNAMIC, getblkpath));

vcCmd.EnableMacro (writeto_cmd, FALSE);

savepin_cmd := vcWv.Cmd (fac, func(display, event)
                         {
                             vcWin.Busy (vcEvent.Window (event), TRUE);
                             savepin (display);
                             vcWin.Busy (vcEvent.Window (event), FALSE);
                         }, "savepin");

/* Builds and displays the dialog box giving options for handling missing
 * lock file problem during the writing of schematic or symbols.  Each
 * option is presented in a button which executes the desired command
 */
function write_filelock_options(display, event, cmd)
{
    declare libcompext_name;
    declare popup;

    data_type := getblockdatatype (display);
    blkname := getblkfullname (display);
    fspec := getblkfspec (display);

    if (data_type == vqDataType.Schematic)
        prompt := " Schematic ";
    else
        prompt := " Symbol ";


    /* Also check for a problem in opening the file for the desired mode */
    if (!isfileopen (display))
       str := "A problem was detected in opening/locking the file for " + prompt + blkname + "

Check file permissions for " + fspec + "

";
    else
       str := "You do not have a lock for " + prompt + blkname + "

";

    table := vcTable.Create (cmd, 2, 1);
    vcTable.Add (table, text := vcRegion.Create1 ("msg", vcStaticText.fac, str, nil));

    buttons := vcRegion.Create ("Buttons", vcButnRow.fac,
                        list (list ("WriteTo", "WriteTo",
                                    func() {
                                        vcWin.Close (popup);
                                        vcCmd.Run (_writeto_cmd, display,
                                                   event, nil, TRUE);
                                    },
                                    nil),
                              list ("Overwrite", "Overwrite existing file",
                                    func() {
                                        lockfile (display);
					vcWin.Busy (vcEvent.Window (event), TRUE);
					if (!write (display, event)) {
					    vcWin.Busy (vcEvent.Window (event), FALSE);
					    error("Unable to overwrite existing design", blkname);
					} /* if */
					vcWin.Busy (vcEvent.Window (event), FALSE);
                                    },
                                    nil),
                              list ("Discard", "Discard changes and reread",
                                    func() {
                                        lockfile (display);
                                        vcCmd.Run (_read_cmd, display, 
                                                   event, nil, TRUE);
                                        vcWin.Close (popup);
                                    },
                                    nil),
                              list ("Cancel", "Cancel",
                                    func()
                                        vcWin.Close (popup);
                                    , list (macro_on <- TRUE,
                                          close_window <- TRUE))));

    vcTable.Add (table, buttons);
    popup = vcWin.Popup (vcEvent.Window (event), table, text, 7);

} /* write_filelock_options */

/* This function writes a block.  If there is no lockfile for the 
 * given file, the user is given the appropriate options.
 */
function do_write(display, event)
{
    vcWin.Busy (vcEvent.Window (event), TRUE);

    if (!write (display, event))

        /* if no lock exists for this file, give user appropriate options */
        if (!islocked (display))
            write_filelock_options (display, event, "Write");

    vcWin.Busy (vcEvent.Window (event), FALSE);
};

write_cmd := vcWv.Cmd (fac, SAVE_FILE_CHECK0 (do_write), "write");

_write_cmd := vcWv.Cmd (fac, func(display, event)
                          {
                              vcWin.Busy (vcEvent.Window (event), TRUE);
                              write (display, event);
                              vcWin.Busy (vcEvent.Window (event), FALSE);
                          },
                          "_write");

check_cmd := vcWv.Cmd (fac, func(display, event)
                       {
                           vcWin.Busy (vcEvent.Window (event), TRUE);
                           check (display, event);
                           vcWin.Busy (vcEvent.Window (event), FALSE);
                       }, "check");


/* This function saves a block.  If there is no lockfile for the 
 * given file, the user is given the appropriate options.
 */
function do_save(display, event)
{
    vcWin.Busy (vcEvent.Window (event), TRUE);

    if (!save (display, event))

        /* if no lock exists for this file, give user appropriate options */
        if (!islocked (display))
            write_filelock_options (display, event, "Save");

    vcWin.Busy (vcEvent.Window (event), FALSE);
};

save_cmd := vcWv.Cmd (fac, SAVE_FILE_CHECK0 (do_save), "save");

_save_cmd  := vcWv.Cmd (fac, func(display, event)
                       {
                           vcWin.Busy (vcEvent.Window (event), TRUE);
                           do_save (display, event);
                           vcWin.Busy (vcEvent.Window (event), FALSE);
                       }, "_save");

/* Miscellaneous commands */
psense_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                        {
                            pinsense (d, e);
                            enable_cmds (d);
                        }), "psense");

lsense_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                        {
                            labelsense (d, e);
                            enable_cmds (d);
                        }), "lsense");

cleanup_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                         {
                             clean_up (d, e);
                             enable_cmds (d);
                         }), "cleanup");


/* Need a function to take current sheet (getsheet) and add 1 instead
 * of using this kludge function - nextsheet.
 */

function nextsheet(display)
{
    getblksheet (display) + 1;

} /* function nextsheet */

function push_sheet(display, event, str)
{
    declare sheet;

    if (string_eq (str, ""))
        sheet = nextsheet (display);
    else
        sheet = convert (integer, str);

    pushsheet (display, event, sheet);
}
psheet_cmd := vcWv.Cmd (fac, func(d, e, i)
                        {
                            push_sheet (d, e, i);
                            enable_cmds (d);
                        }, "psheet", "Push Sheet",
                        vcWv.Param ("Sheet Number",
                                    vlStringRestOfLineVT, DYNAMIC, nextsheet));

psym_cmd := vcWv.Cmd (fac, func(d, e)
                      {
                          pushblock (d, "Symbol");
                          enable_cmds (d);
                          bind_popups (d);
                      },
                      "psym");

_psch_cmd := vcWv.Cmd (fac, func(d, e)
                          pushblock (d, "Schematic");
                      , "_psch", "Psch");

function maybe_psch(display, event)
{
    if (oatbufexist (display)) {

        prompt := "OATs exist in buffer.  Are you sure?";

        maybe_run_cmd ("OK to Push Schematic?", prompt,
                           _psch_cmd, display, event, nil);
    }
    else
        vcCmd.Run (_psch_cmd, display, event, nil, TRUE);

    enable_cmds (display);
    bind_popups (display);

} /* function maybe_psch */
psch_cmd := vcWv.Cmd (fac, maybe_psch, "psch", "Psch");

vcCmd.EnableMacro (psch_cmd, FALSE);

_pop_cmd := vcWv.Cmd (fac, func(display, event, popcount)
                          popblock (display, popcount);
                      , "_pop", "Pop",
                      vcWv.Param ("Pop count",
                                  vlPositiveIntVT, CONSTANT, "1"));

function maybe_pop(display, event, str)
{
    declare request;

    if (toplevel (display))
        status_msg (vcEvent.Window (event), "Cannot pop any further");

    else {

        if (string_eq (str, ""))
            request = 1;
        else
            request = convert (integer, str);

        /* If popping only 1 level, from symbol to schematic, do not test
         * for modified data (same as 4.1).  If popping > 1 or current
         * block is a schematic, check for modified data on current block.
         */

        if (   (   (getblockdatatype (display) == vqDataType.Symbol)
                && (request == 1))
            || (blkmodified (display) != 1)) {

            if (oatbufexist (display)) {
                prompt := "OATs exist in buffer.  Are you sure?";

                maybe_run_cmd ("OK to Pop?", prompt,
                           _pop_cmd, display, event, list (request));
            }
            else
                vcCmd.Run (_pop_cmd, display, event, list (request), TRUE);
        }
        else {

            fname  := getblkfullname (display);

            if (oatbufexist (display))
                prompt := fname + " has been modified and OATs exist in buffer.  Are you sure?";
            else 
                prompt := fname + " has been modified.  Are you sure?";

            request = 1;

            maybe_run_cmd ("OK to Pop?", prompt,
                           _pop_cmd, display, event, list (request));
        }

        enable_cmds (display);
        bind_popups (display);
    }

} /* function maybe_pop */
pop_cmd := vcWv.Cmd (fac, maybe_pop, "pop", "Pop",
                     vcWv.Param ("Pop count",
                                 vlStringRestOfLineVT, CONSTANT, "1"));

vcCmd.EnableMacro (pop_cmd, FALSE);

navigate_cmd := vcWv.Cmd (fac, func (d, e, str) navigate (str);, 
                          "navigate", "Navigate",
                          vcWv.Param ("Path", vlStringRestOfLine1VT, 
                                      CONSTANT, ""));

array_cmd :=
    vcWv.Cmd (fac, FILE_CHECK5 (func(display, event, rows, cols, 
                                     rspace, cspace, absrel)
              {
                  vcWin.Busy (vcEvent.Window (event), TRUE);
                  array (display, event, rows, cols, rspace, cspace, absrel);
                  vcWin.Busy (vcEvent.Window (event), FALSE);
              }), "array",
              "Array",
              vcWv.Param ("Rows",           vlPositiveIntVT, STICKY, 1),
              vcWv.Param ("Columns",        vlPositiveIntVT, STICKY, 1),
              vcWv.Param ("Row Spacing",    integer,   STICKY, 10),
              vcWv.Param ("Column Spacing", integer,   STICKY, 10),
              vcWv.Param ("Spacing",        vqAbsRelVT, STICKY, "Absolute"));

function get_bb_coord(display, coord)
{
    declare llx, lly, urx, ury;

    getbb (display, &llx, &lly, &urx, &ury);

    /*
     * Note: the return value of this func is the last statement executed 
     */
    if (coord == 0)
        llx;
    else if (coord == 1)
        lly;
    else if (coord == 2)
        urx;
    else
        ury;

    /* DON'T ADD ANYTHING HERE */

} /* function get_bb_coord */


function get_bb(coord) 
    func(display) get_bb_coord (display, coord);;

bb_cmd := vcWv.Cmd (fac, FILE_CHECK4 (func(d, e, w, x, y, z)
                        bb (d, e, w, x, y, z);),
                    "bb", "Set Bounding Box",
                    vcWv.Param ("LLX", vqBlockWidthVT,  DYNAMIC, get_bb (0)),
                    vcWv.Param ("LLY", vqBlockHeightVT, DYNAMIC, get_bb (1)),
                    vcWv.Param ("URX", vqBlockWidthVT,  DYNAMIC, get_bb (2)),
                    vcWv.Param ("URY", vqBlockHeightVT, DYNAMIC, get_bb (3)));

/* ZREGION could just store LL and UR corners in q_carea and call zoom
 * if there was callback access to q_carea.  For now (5.1.91) call new
 * procedure - zregion
 */
zregion_cmd := vcWv.Cmd (fac, func(d, e, w, x, y, z)
                             zregion (d, e, w, x, y, z);,
                         "zregion", "Zoom to Area",
                         vcWv.Param ("LLX", vqBlockWidthVT,  STICKY, 0),
                         vcWv.Param ("LLY", vqBlockHeightVT, STICKY, 0),
                         vcWv.Param ("URX", vqBlockWidthVT,  STICKY, 100),
                         vcWv.Param ("URY", vqBlockHeightVT, STICKY, 100));

function zoom_to_area(display, event)
{
    r  := vcEvent.Rect (event);
    vp := getviewport (display);
    
    vgU.PixelToUserRect (vp, r);

    vcCmd.Run (zregion_cmd, display, event, list (vgRect.Xmin (r),
                                                  vgRect.Ymin (r),
                                                  vgRect.Xmax (r),
                                                  vgRect.Ymax (r)), TRUE);
}
zoom_to_area_cmd := vcWv.Cmd (fac, zoom_to_area);

slot_cmd := vcWv.Cmd (fac, FILE_CHECK1 (slot), "slot", "Slot",
                      vcWv.Param ("Slot", vlUnsignedIntVT, STICKY, 1));

cinst_cmd := vcWv.Cmd (fac, FILE_CHECK1 (cinst), "cinst", "Instance",
                       vcWv.Param ("Slot", vlUnsignedIntVT, STICKY, 1));

writinit_cmd    := vcWv.Cmd (fac, writinit, "writinit");
setmodified_cmd := vcWv.Cmd (fac, setmodified, "setmodified");

function clrmode_command(d, e)
    bind_middle_button (noopmode_cmd);

clrmode_cmd := vcWv.Cmd (fac, clrmode_command, "clrmode");


function get_node_fname(display)
    /* No library name allowed. */
    getblkname (display) + ".nod";
 /* function get_node_fname */


/* File spec should be DYNAMIC, not STICKY.  Default is block name. */
wrnodes_cmd := vcWv.Cmd (fac, wrnodes, "wrnodes", "Write Nodes",
                         vcWv.Param ("File", string, DYNAMIC, get_node_fname),
                         vcWv.Param ("Mode", vqOpenOutputModeVT,
                                     STICKY, "Append"));

/* File spec should be DYNAMIC, not STICKY.  Default is block name. */
wrattrs_cmd := vcWv.Cmd (fac, wrattrs, "wrattrs", "Write Attributes",
                         vcWv.Param ("File", string, DYNAMIC, get_node_fname),
                         vcWv.Param ("Mode", vqOpenOutputModeVT,
                                     STICKY, "Append"));

function get_anno_fname(display)
    /* No library name allowed. */
    getdesignname (display) + ".ann";
 /* function get_anno_fname */

annoon_cmd := vcWv.Cmd (fac, annoon, "annoon", "Annotation On",
                        vcWv.Param ("File", string, DYNAMIC, get_anno_fname));

annoinit_cmd := vcWv.Cmd (fac, annoinit, "annoinit", "Annotation Init",
                          vcWv.Param ("File", string,
                                      DYNAMIC, get_anno_fname));

annostep_cmd    := vcWv.Cmd (fac, annostep,    "annostep");
annooff_cmd     := vcWv.Cmd (fac, annooff,     "annooff");
annoclear_cmd   := vcWv.Cmd (fac, annoclear,   "annoclear");
annorefresh_cmd := vcWv.Cmd (fac, annorefresh, "annorefresh");
strace_cmd      := vcWv.Cmd (fac, strace,      "strace");

simtrace_cmd  := vcWv.Cmd (fac, simtrace,    "simtrace", "Trace signals",
                           vcWv.Param ("SimTrace", vlOnOffVT, STICKY, "off"));

/***
* This function extract the name portion from a full file specification
***/
function extract_name(fname)
{
    /* find the last slash character, if none then start at first character */

    start := rindex (fname, '/');

    if (!start) 
        start = 0;
    else
        start = start + 1;
       
    /* find last dot character, if none then end at last character */
    end := rindex (fname, '.');

    if (!end) 
        end = string_length (fname);

    /* return the extracted substring for the name */
    substring (fname, start, end);

} /* extract_name */


/*
 * This function creates a component when a file is dropped in a viewdraw
 * window.
 */

function drop(display,event)
{
    if (comp (display, event, extract_name (vcEvent.String (event))) == 0) {

        enable_cmds (display);
        move_created_object (display, event);
    }
} /* drop */

/*-*/


/* This function enables and disables commands based on the current window's
 * block data type (schematic or symbol), what data is selected, if any,
 * and other more specific conditions.
 */

function enable_cmds(display)
{
    declare schematic_only, symbol_only;
    declare something_selected, num_selected, strings_selected;
    /* Bob D 10/92 Added writable var to reflect readonly state */
    declare writable;

    if (getblockdatatype (display) == vqDataType.Schematic) {

        schematic_only = ON;
        symbol_only    = OFF;
    }
    else {

        schematic_only = OFF;
        symbol_only    = ON;        
    }
    if (read_only()) {
        writable = vlOnOff.Off;

        /* specifically disable these */
        vcCmd.Enable (write_cmd, vlOnOff.Off);
        vcCmd.Enable (writeto_cmd, vlOnOff.Off);
        vcCmd.Enable (restore_cmd, vlOnOff.Off);
        vcCmd.Enable (attrvis_cmd, vlOnOff.Off);
        vcCmd.Enable (name_cmd, vlOnOff.Off);
        vcCmd.Enable (value_cmd, vlOnOff.Off);
        vcCmd.Enable (btype_cmd, vlOnOff.Off);
        vcCmd.Enable (name_cmd, vlOnOff.Off);
        vcCmd.Enable (value_cmd, vlOnOff.Off);
        vcCmd.Enable (chgoattrstring_cmd, vlOnOff.Off);
        vcCmd.Enable (chgkanjistring_cmd, vlOnOff.Off);
        vcCmd.Enable (oattr_cmd, vlOnOff.Off);
        vcCmd.Enable (arc_cmd, vlOnOff.Off);
        vcCmd.Enable (box_cmd, vlOnOff.Off);
        vcCmd.Enable (circle_cmd, vlOnOff.Off);
        vcCmd.Enable (ktext_cmd, vlOnOff.Off);
        vcCmd.Enable (line_cmd, vlOnOff.Off);
        vcCmd.Enable (text_cmd, vlOnOff.Off);
        vcCmd.Enable (cmodes_cmd, vlOnOff.Off);
        vcCmd.Enable (cvalues_cmd, vlOnOff.Off);
        vcCmd.Enable (check_cmd, vlOnOff.Off);
        vcCmd.Enable (edit_font_cmd, vlOnOff.Off);
        vcCmd.Enable (compile_font_cmd, vlOnOff.Off);

/*
    | Analog | various    "analog"
    |        | other...   open_sym_dbox

      | OatCheck   "mex oatcheck"
      |
*/
    } /* if */
    else
        writable = vlOnOff.On;

    /* Schematic only commands */

    /* vcCmd.Enable (typed_comp_cmd, schematic_only); */
    vcCmd.Enable (analog_cmd,     schematic_only && writable);
    vcCmd.Enable (comp_cmd,       schematic_only && writable);
    vcCmd.Enable (do_comp_cmd,    schematic_only && writable);
    
    vcCmd.Enable (net_cmd,        schematic_only && writable);
    vcCmd.Enable (bus_cmd,        schematic_only && writable);

    /* symbol only commands */

    vcCmd.Enable (spin_cmd,       symbol_only && writable);
    vcCmd.Enable (pin_cmd,        symbol_only && writable);
    
    vcCmd.Enable (btype_cmd,      symbol_only && writable);
    vcCmd.Enable (bcomposite_cmd, symbol_only && writable);
    vcCmd.Enable (bmodule_cmd,    symbol_only && writable);
    vcCmd.Enable (bannotate_cmd,  symbol_only && writable);
    vcCmd.Enable (bpin_cmd,       symbol_only && writable);

    vcCmd.Enable (savepin_cmd,    symbol_only && writable);

    /* if (numsel (display) > 0) */

    if (isnumselobj (display, vqObject.Any,
                     vqObjectCount.AtLeastOne) == vlTrueFalse.True)

        something_selected = ON;
    else
        something_selected = OFF;

    if (something_selected == OFF) {

        /* Some commands cannot be run if nothing is selected no matter
         * which block data type the current window contains.
         */

        vcCmd.Enable (refdes_cmd, OFF);
        vcCmd.Enable (pinnum_cmd, OFF);
        vcCmd.Enable (cinst_cmd,  OFF);
        vcCmd.Enable (slot_cmd,   OFF);
        vcCmd.Enable (psense_cmd, OFF);

        vcCmd.Enable (font_cmd,   OFF);
        vcCmd.Enable (color_cmd,  OFF);
        vcCmd.Enable (fstyle_cmd, OFF);
        vcCmd.Enable (lstyle_cmd, OFF);

        vcCmd.Enable (ccomp_cmd,      OFF);
        vcCmd.Enable (ccomp_menu_cmd, OFF);

        vcCmd.Enable (label_cmd,             OFF);
        vcCmd.Enable (label_kbd_cmd,         OFF);
        vcCmd.Enable (label_from_buffer_cmd, OFF);

        vcCmd.Enable (sarray_cmd,       OFF);
        vcCmd.Enable (sparray_cmd,      OFF);
        vcCmd.Enable (snarray_cmd,      OFF);
    }
    else {

        /* Some commands require a selected object (or objects) and a
         * specific block data type.
         */

        /* Should only be enabled if a COMPONENT is selected. */

        if (isnumselobj (display, vqObject.Component,
                         vqObjectCount.AtLeastOne)) {

            vcCmd.Enable (ccomp_cmd,      ON && writable);
            vcCmd.Enable (ccomp_menu_cmd, ON && writable);

            vcCmd.Enable (refdes_cmd,     ON && writable);
            vcCmd.Enable (pinnum_cmd,     ON && writable);
            vcCmd.Enable (cinst_cmd,      ON && writable);
            vcCmd.Enable (slot_cmd,       ON && writable);

            if (isnumselobj (display, vqObject.Component, vqObjectCount.One)) {
                if (getmode(vqMode.Oats)) {
                    if (oataryexist (display)) {
                        vcCmd.Enable (sarray_cmd,       ON);
                        vcCmd.Enable (sparray_cmd,      ON);
                        vcCmd.Enable (snarray_cmd,      ON);
                    }
                }
            }
        }

        /* Should be enabled only if a PIN is selected. */

        if (isnumselobj (display, vqObject.Pin, vqObjectCount.AtLeastOne))

            vcCmd.Enable (psense_cmd, ON && writable);

        /* Some commands require even more specialized conditions to be met. */

        if (oktorun (display, "label", FALSE) == 0) {

            vcCmd.Enable (label_cmd,             ON && writable);
            vcCmd.Enable (label_kbd_cmd,         ON && writable);
            /* vcCmd.Enable (label_menu_cmd,        ON); */
            /* vcCmd.Enable (label_full_cmd,        ON); */
            vcCmd.Enable (label_from_buffer_cmd, ON && writable);
        }

        if (oktorun (display, "font", FALSE) == 0)
            vcCmd.Enable (font_cmd,   ON && writable);

        if (oktorun (display, "color", FALSE) == 0)
            vcCmd.Enable (color_cmd,  ON && writable);

        if (oktorun (display, "fstyle", FALSE) == 0)
            vcCmd.Enable (fstyle_cmd, ON && writable);

        if (oktorun (display, "lstyle", FALSE) == 0)
            vcCmd.Enable (lstyle_cmd, ON && writable);
    }

    strings_selected := OFF;

    if (isnumselobj (display, vqObject.String, vqObjectCount.AtLeastOne))

        strings_selected = ON;

    vcCmd.Enable (string_cmd, strings_selected && writable);
    vcCmd.Enable (origin_cmd, strings_selected && writable);
    vcCmd.Enable (size_cmd,   strings_selected && writable);
    vcCmd.Enable (sed_cmd,    strings_selected && writable);
    
    vcCmd.Enable (o1_cmd,     strings_selected && writable);
    vcCmd.Enable (o2_cmd,     strings_selected && writable);
    vcCmd.Enable (o3_cmd,     strings_selected && writable);
    vcCmd.Enable (o4_cmd,     strings_selected && writable);
    vcCmd.Enable (o5_cmd,     strings_selected && writable);
    vcCmd.Enable (o6_cmd,     strings_selected && writable);
    vcCmd.Enable (o7_cmd,     strings_selected && writable);
    vcCmd.Enable (o8_cmd,     strings_selected && writable);
    vcCmd.Enable (o9_cmd,     strings_selected && writable);

    if (isnumselobj (display, vqObject.Label,
                     vqObjectCount.AtLeastOne)) {

        vcCmd.Enable (chglabstring_cmd, ON && writable);
        vcCmd.Enable (lscope_cmd,       ON && writable);
        vcCmd.Enable (lsense_cmd,       ON && writable);
    }
    else {

        vcCmd.Enable (chglabstring_cmd, OFF);
        vcCmd.Enable (lscope_cmd,       OFF);
        vcCmd.Enable (lsense_cmd,       OFF);
    }

    if (isnumselobj (display, vqObject.Attribute, vqObjectCount.AtLeastOne))
        vcCmd.Enable (chgattrstring_cmd, ON && writable);
    else if (isnumselobj (display, vqObject.Oattribute,
                          vqObjectCount.AtLeastOne))
        vcCmd.Enable (chgattrstring_cmd, ON && writable);
    else
        vcCmd.Enable (chgattrstring_cmd, OFF);

    if (isnumselobj (display, vqObject.Text, vqObjectCount.AtLeastOne))
        vcCmd.Enable (chgtextstring_cmd, ON && writable);
    else
        vcCmd.Enable (chgtextstring_cmd, OFF);

    if (isnumobj (display, vqObject.Label, vqObjectCount.AtLeastOne)) {

        vcCmd.Enable (labelvis_cmd, ON && writable);
        vcCmd.Enable (lvis_cmd,     ON && writable);
        vcCmd.Enable (linvis_cmd,   ON && writable);
    }
    else {

        vcCmd.Enable (labelvis_cmd, OFF);
        vcCmd.Enable (lvis_cmd,     OFF);
        vcCmd.Enable (linvis_cmd,   OFF);
    }

    /* Should be enabled only if execution can be done. */
    /* e. g. can't move, copy or delete a selected component PIN. */

    vcCmd.Enable (move_cmd,    something_selected && writable);
    vcCmd.Enable (copy_cmd,    something_selected && writable);
    vcCmd.Enable (delete_cmd,  something_selected && writable);
    vcCmd.Enable (stretch_cmd, something_selected && writable);
    vcCmd.Enable (array_cmd,   something_selected && writable);

    vcCmd.Enable (reflect_cmd, something_selected && writable);
    vcCmd.Enable (rotate_cmd,  something_selected && writable);
    vcCmd.Enable (scale_cmd,   something_selected && writable);

    vcCmd.Enable (bcut_cmd,    something_selected && writable);
    vcCmd.Enable (bcopy_cmd,   something_selected && writable);
    vcCmd.Enable (bappend_cmd, something_selected && writable);

    if (add_attr_check (display) != -1)
        vcCmd.Enable (attr_cmd, ON && writable);
    else
        vcCmd.Enable (attr_cmd, OFF);

    if (oktorun (display, "undo", FALSE) == 0)
        vcCmd.Enable (undo_cmd, ON && writable);
    else
        vcCmd.Enable (undo_cmd, OFF);

    if (oktorun (display, "redo", FALSE) == 0)
        vcCmd.Enable (redo_cmd, ON && writable);
    else
        vcCmd.Enable (redo_cmd, OFF);

    if (oktorun (display, "bpaste", FALSE) == 0) {

        vcCmd.Enable (bpaste_cmd, ON && writable);
        vcCmd.Enable (bclear_cmd, ON && writable);
    }
    else {

        vcCmd.Enable (bpaste_cmd, OFF);
        vcCmd.Enable (bclear_cmd, OFF);
    }

    if (oktorun (display, "read", FALSE) == 0)
        vcCmd.Enable (read_cmd, ON && writable);
    else
        vcCmd.Enable (read_cmd, OFF);

    if (toplevel (display))
        vcCmd.Enable (pop_cmd,  OFF);
    else
        vcCmd.Enable (pop_cmd,  ON);

    /* RSM - 12/31/91 */
    vcWin.UpdateMenus (getwindow (display));

    if (getmode(vqMode.Oats))
        vcCmd.Enable (oattr_cmd, ON);
    else
        vcCmd.Enable (oattr_cmd, OFF);

    0;
} /* function enable_cmds */


function bind_shiftright_button(cmd) 
    vcBind.Set (bindings, '\#\rightdown', cmd);
 /* bind_shiftright_button */


function bind_popups(display)
{
    /* Bob Davis 10/92
     * Additional test added for VIEWONLY support.
     * Normal viewdraw works same as before.
     */
    if (!read_only()) {
        if (getblockdatatype (display) == vqDataType.Schematic) {
            bind_right_button (sch_popup_cmd);
            bind_shiftright_button (shft_sch_popup_cmd);
        }
        else {
            bind_right_button (sym_popup_cmd);
            bind_shiftright_button (shft_sym_popup_cmd);
        }
    }
    else {
        bind_right_button (VO_popup_cmd);
        bind_shiftright_button (VO_popup_cmd);
    }
} /* bind_popups */


/* This function is called whenever the cursor enters a window */
function _FocusIn(display, event)
{
/*    print ("_FocusIn"); */

    /* enable appropriate commands for current display */
    enable_cmds (display); 

    /* bind appropriate pop-up menu based on type of block */
    bind_popups (display);

    if (   (comp_to_add != nil)
        && (getblockdatatype (display) == vqDataType.Schematic)) {

        add_comp (display, event);
        comp_to_add = nil;

        if (w != nil)
            vcWin.ClearStatus (w);   /* w is component dialog box window */
    }

} /* _FocusIn */


/* This function scrolls when the cursor gets to the edge */
function auto_scroll(display, event)
{
    declare scroll_distance;

    if (auto_scroll_enabled) {
        
        x := vcEvent.X (event);
        y := vcEvent.Y (event);

        r := vgU.Region (getviewport (display));

        if (   (x - vgRect.Xmin (r)) < 10
            || (vgRect.Xmax (r) - x) < 10
            || (y - vgRect.Ymin (r)) < 10
            || (vgRect.Ymax (r) - y) < 10) {

            zoom_factor := getzfactor (display);

            vp := getviewport (display);
            vgU.PixelToUser (vp, &x, &y);

            /* Get magnification and adjust scroll factor accordingly. */

            if (zoom_factor < 1.5)
                scroll_distance = 0.33;
            else
                scroll_distance = 0.25;

            if (scroll (display, event, scroll_distance, FALSE)) {

                vgU.MoveCursor (vp, x, y);
                vrefresh (display);
            }
        }
    }
} /* auto_scroll */

function fast_draw(display, event)
{
    cont := 1;

    if (numsel (display) > 0) {

        /* If there is already something selected AND mouse is within the
         * bounding box of the selected objects, do move command.
         */

        mbb := mbb_selected (display);
        vp  := getviewport (display);

        vgU.UserToPixelRect (vp, mbb);

        if (   (vcEvent.X (event) >= vgRect.Xmin (mbb))
            && (vcEvent.X (event) <= vgRect.Xmax (mbb))
            && (vcEvent.Y (event) >= vgRect.Ymin (mbb))
            && (vcEvent.Y (event) <= vgRect.Ymax (mbb))) {

            vcCmd.Run (move_cmd, display, event, nil, TRUE);
            cont = 0;
        }
    }

    if (cont == 1) {

        if (   (nearpin (display, event) == 1)
            || (nearnet (display, event, 1) == 1)    /* 1 == dangling joint */
            || (nearnet (display, event, 2) == 1))   /* 2 == corner joint   */

            vcCmd.Run (net_cmd, display, event, nil, TRUE);

        else {

            vp := getviewport (display);

            x := vcEvent.X (event);
            y := vcEvent.Y (event);

            vgU.PixelToUser (vp, &x, &y);

            if (setarea (display, x, y, x, y) == 0)
                vcCmd.Run (selectarea_cmd, display, event,
                           list (x, y, x, y, "off"), TRUE);

            enable_cmds (display);

            if (numsel (display) == 0)
                vcCmd.Run (do_comp_cmd, display, event, nil, FALSE);
            else
                vcCmd.Run (move_cmd, display, event, nil, TRUE);
        }
    }
}
do_fast_draw_cmd := vcWv.Cmd(fac, fast_draw, "FastDraw");
vcCmd.EnableMacro (do_fast_draw_cmd, FALSE);


function bind_fast_draw(display, event)
    /* fast_draw_mode = 1; */
    bind_middle_button (do_fast_draw_cmd);

fast_draw_cmd := vcWv.Cmd(fac, bind_fast_draw);


mem_llx := 0;
mem_lly := 0;
mem_urx := 0;
mem_ury := 0;

function store_region(display, event)
    getwextents (display, &mem_llx, &mem_lly, &mem_urx, &mem_ury);
 /* function store_region */

store_region_cmd := vcWv.Cmd (fac, store_region, "storeregion");


function recall_region(display, event)
    zregion (display, event, mem_llx, mem_lly, mem_urx, mem_ury);
 /* function recall_region */

recall_region_cmd := vcWv.Cmd(fac, recall_region, "recallregion");

annoaddstr_cmd := vcWv.Cmd (fac, annoaddstr, "annoaddstr", "AnnoAddStr",
                            vcWv.Param ("String", string, STICKY, ""));

cmodes_cmd  := vcWv.Cmd (fac, cmodes,  "cmodes");
cvalues_cmd := vcWv.Cmd (fac, cvalues, "cvalues");

VO_cmodes_cmd  := vcWv.Cmd (fac, VOcmodes,  "VOcmodes");

cattr_cmd   := vcWv.Cmd (fac, FILE_CHECK1 (cattr), 
                         "cattr", "Change Attributes",
                         vcWv.Param ("Filter", vlStringRestOfLineVT,
                                     CONSTANT, ""));

cattr_all_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                               cattr (d, e, "");),
                           "_cattr_all");

cattr_pcb_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                               cattr (d, e, "pcb.flt");),
                           "_cattr_pcb");

cattr_spice_cmd := vcWv.Cmd (fac, FILE_CHECK0 (func(d, e)
                               cattr (d, e, "spice.flt");),
                             "_cattr_spice");

/* Delete block (schematic w/ WIR file or symbol) */
/* delblock_cmd := vcWv.Cmd(fac, delblock, "deleteblock"); */

brdcst_sel_cmd := vcWv.Cmd (fac, brdcstsel, "bcastselect", "On/Off",
                            vcWv.Param ("On or Off", vlOnOffVT,
                                        CONSTANT, "on"));

/*
 * Info commands.
 */

function info_cmd(display, event, fun, str)
{
    declare r, p;

    append := FALSE;
    fname  := "";
    arg    := str;

    if (str == nil)
        str = "";

    append = NO;

    /* Search backwards for '>' character */

    if ((r = rindex (str, '>')) != FALSE) {

        p = r;

        if (r != 0) {

            /* Look for second '>' immediately before the last one. */

            if (string_ref (str, (r - 1)) == '>') {

                append = YES;
                p = r - 1;
            }

            arg = substring (str, 0, p);
        }

        if (p == 0)
            arg = "";

        fname = substring (str, (r + 1), 0);
    }

    fun (display, event, arg, fname, append);
}

status_cmd :=
    vcWv.Cmd (fac, func(d, e, str)
                  info_cmd (d, e, status, str);
              , "status", "Info Status",
              vcWv.Param ("Output", vlStringRestOfLineVT, STICKY, ""));

ocount_cmd :=
    vcWv.Cmd (fac, func(d, e, str)
                  info_cmd (d, e, ocount, str);
              , "ocount",  "Info Object Count",
              vcWv.Param ("Output", vlStringRestOfLineVT, STICKY, ""));

odetail_cmd :=
    vcWv.Cmd (fac, func(d, e, str)
                  info_cmd (d, e, odetail, str);
              , "odetail", "Info Object Detail",
              vcWv.Param ("Output", vlStringRestOfLineVT, STICKY, ""));

alist_cmd :=
    vcWv.Cmd (fac, func(d, e, str)
                  info_cmd (d, e, alist, str);
              , "alist", "List Attributes",
              vcWv.Param ("Attribute String",
                          vlStringRestOfLineVT, STICKY, "*"));

llist_cmd :=
    vcWv.Cmd (fac, func(d, e, str)
                  info_cmd (d, e, llist, str);
              , "llist", "List Labels",
              vcWv.Param ("Label String",
                          vlStringRestOfLineVT, STICKY, "*"));

dir_cmd := vcWv.Cmd (fac, func(d, e, str)
                         info_cmd (d, e, dir, str);
                     , "dir", "Schematics and Symbols in Memory",
                     vcWv.Param ("Name",
                                 vlStringRestOfLineVT, STICKY, "*"));

function directory_cmd(display, event, data_type, str)
{
    declare r, p;

    append := FALSE;
    fname  := "";
    arg    := str;

    if (str == nil)
        str = "";

    append = NO;

    /* Search backwards for '>' character */

    if ((r = rindex (str, '>')) != FALSE) {

        p = r;

        if (r != 0) {

            /* Look for second '>' immediately before the last one. */

            if (string_ref (str, (r - 1)) == '>') {

                append = YES;
                p = r - 1;
            }

            arg = substring (str, 0, p);
        }

        if (p == 0)
            arg = "";

        fname = substring (str, (r + 1), 0);
    }

    dirdata (display, event, data_type, arg, fname, append);
}
dsch_cmd := vcWv.Cmd (fac, func(d, e, str)
                          directory_cmd (d, e, "Schematic", str);
                      , "dirsch", "List Schematics",
                      vcWv.Param ("Schematic Name",
                                  vlStringRestOfLineVT, STICKY, "*"));

dsym_cmd := vcWv.Cmd (fac, func(d, e, str)
                          directory_cmd (d, e, "Symbol", str);
                      , "dirsym", "List Schematics",
                      vcWv.Param ("Symbol Name",
                                  vlStringRestOfLineVT, STICKY, "*"));

function track_cursor(display, event)
{
    x := vcEvent.X (event);
    y := vcEvent.Y (event);

    vgU.PixelToUser (getviewport (display), &x, &y);
    
    status_msg (vcEvent.Window (event), sprintf ("X=%d  Y=%d", x, y));

} /* function track_cursor */
track_cursor_cmd := vcWv.Cmd (fac, track_cursor);
