/**
  *
  *    VFRAMESM.VS
  *
  *    Facility:  Viewframe
  *
  *    Functional Description: 
  *       Vframesm viewscript functions, commands
  *
  *    Environment:
  *        SUNOS 4.1.1
  *
  *    Author:
  *        Sandy Lucas - October 1992
  *
  *    Modified by:
  *    Who            Version   When     What
  *    SAL            5.2       07/07/93 Changed manage_data to call anyblocks
  *                                      to check for dm blocks
  *    Copyright (c) 1992 by Viewlogic Systems, Inc.
  *
  **/
/***************************/
/* enable datamanager commands */
/***************************/

function enable_datamanager_commands(on_off) 
{
   vcCmd.Enable(browsepf, on_off);
   vcCmd.Enable(cancelcheckoutblktype, on_off);
   vcCmd.Enable(cancelcheckoutftype, on_off);
   vcCmd.Enable(setdefault, on_off);
   vcCmd.Enable(setcurrent, on_off);
   vcCmd.Enable(checkinblktype, on_off);
   vcCmd.Enable(checkinblktype2, on_off);
   vcCmd.Enable(checkinftype, on_off);
   vcCmd.Enable(checkoutblktype, on_off);
   vcCmd.Enable(checkoutftype, on_off);
   vcCmd.Enable(fetchblktype, on_off);
   vcCmd.Enable(fetchftype, on_off);
   vcCmd.Enable(checkPoint, on_off);
   vcCmd.Enable(_checkpoint, on_off);
   vcCmd.Enable(restoreCheckPoint, on_off);
   vcCmd.Enable(_restorechkpt, on_off);
   vcCmd.Enable(listCheckPoint, on_off);
   vcCmd.Enable(_listchkpt, on_off);
   vcCmd.Enable(checkoutcmd, on_off);
   vcCmd.Enable(fetchcmd, on_off);
   vcCmd.Enable(cancelcheckoutcmd, on_off);
   vcCmd.Enable(checkincmd, on_off);
   vcCmd.Enable(setdefcmd, on_off);
   vcCmd.Enable(setcurcmd, on_off);
   vcCmd.Enable(chgwksp, on_off);
}

/***********************************/
/* Commands                        */
/***********************************/
browsepf := vcWv.Cmd(fac, BrowsePF, "browsepf");

function enable_browsepf_command(on_off) 
{
   vcCmd.Enable(browsepf, on_off);  
}

popobjcmd := vcWv.Cmd(fac, popobj, "popobj", "Pop Obj",
                vcWv.Param("Object", vfsmOidVT, vcWv.Dynamic,getnulloid));

cancelcheckoutblktype := vcWv.Cmd(fac,CancelBlkType,
                "cancelcheckoutblktype", "Cancel Checkout Block",
                vcWv.Param("Block ", vfsmOidVT, vcWv.Dynamic,getnulloid),
                vcWv.Param("File type", vfsmClassVT, vcWv.Dynamic, 
                            getnullclass),
                vcWv.Param("File op",vfsmCancelopTypeVT, vcWv.Constant, 
                           vfsmCancelopType.Keep),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block));

cancelcheckoutftype := vcWv.Cmd(fac,CancelFType,
                "cancelcheckoutftype", "Cancel Checkout File",
                vcWv.Param("File ", vfsmOidVT, vcWv.Dynamic,getnulloid),
                vcWv.Param("File op",vfsmCancelopTypeVT, vcWv.Constant, 
                           vfsmCancelopType.Keep),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block));

setdefault := vcWv.Cmd(fac, SetDefault, "setdefault", "Set Default",
              vcWv.Param("Version", vfsmOidVT, vcWv.Dynamic, getnulloid));

setcurrent := vcWv.Cmd(fac, SetCurrent, "setcurrent", "Set Current",
              vcWv.Param("Version", vfsmOidVT, vcWv.Dynamic, getnulloid));

checkinblktype := vcWv.Cmd(fac,CheckinBlkType,"checkinblktype",
               "Checkin Block",
                vcWv.Param("Library", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("Block", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("File type", vfsmClassVT, vcWv.Dynamic, getnullclass),
                vcWv.Param("Comment", vlStringVT, vcWv.Sticky, ""),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("File op",vfsmCancelopTypeVT, vcWv.Constant, 
                           vfsmCancelopType.Keep));

checkinblktype2 := vcWv.Cmd(fac,CheckinBlkType2,"checkinblktype2",
               "Checkin Block",
                vcWv.Param("Library", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("File type", vfsmClassVT, vcWv.Dynamic, getnullclass),
                vcWv.Param("New Block", vlStringVT, vcWv.Sticky, ""),
                vcWv.Param("Comment", vlStringVT, vcWv.Sticky, ""),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("File op",vfsmCancelopTypeVT, vcWv.Constant, 
                           vfsmCancelopType.Keep));

checkinftype := vcWv.Cmd(fac,CheckinFType,"checkinftype",
               "Checkin File",
                vcWv.Param("File", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("Comment", string, vcWv.Sticky, ""),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("File op",vfsmCancelopTypeVT, vcWv.Constant, 
                           vfsmCancelopType.Keep));

chkoutblktype := vcWv.Cmd(fac,ChkoutBlkType,"chkoutblktype",
                "Checkout Block",
                vcWv.Param("Blocks", vscmVT, vcWv.Constant, nil),
                vcWv.Param("File types", vscmVT, vcWv.Constant, nil),
                vcWv.Param("File op",vfsmFileopTypeVT, vcWv.Constant, 
                           vfsmFileopType.Copy),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("Query",vlOnOffVT, vcWv.Constant,vlOnOff.Off));

checkoutblktype := vcWv.Cmd(fac,CheckoutBlkType,"checkoutblktype",
                "Checkout Block",
                vcWv.Param("Block", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("File type", vfsmClassVT, vcWv.Dynamic, getnullclass),
                vcWv.Param("File op",vfsmFileopTypeVT, vcWv.Constant, 
                           vfsmFileopType.Copy),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("Query",vlOnOffVT, vcWv.Constant,vlOnOff.Off));

checkoutftype := vcWv.Cmd(fac,CheckoutFType,"checkoutftype",
                "Checkout File",
                vcWv.Param("File", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("File op",vfsmFileopTypeVT, vcWv.Constant, 
                           vfsmFileopType.Copy),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("Query",vlOnOffVT, vcWv.Constant,vlOnOff.Off));

fetchblktype := vcWv.Cmd(fac,FetchBlkType,"Fetchblktype","Fetch Block",
                vcWv.Param("Block", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("File type", vfsmClassVT, vcWv.Dynamic, getnullclass),
                vcWv.Param("File op",vfsmFetchopTypeVT, vcWv.Constant, 
                           vfsmFetchopType.Copy),
                vcWv.Param("File ver",vfsmCurrencyVT, vcWv.Constant, 
                           vfsmCurrency.Current),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("Query",vlOnOffVT, vcWv.Constant,vlOnOff.Off));

fetchftype := vcWv.Cmd(fac,FetchFType,"Fetchftype","Fetch File",
                vcWv.Param("File", vfsmOidVT, vcWv.Dynamic, getnulloid),
                vcWv.Param("File op",vfsmFetchopTypeVT, vcWv.Constant, 
                           vfsmFetchopType.Copy),
                vcWv.Param("File ver",vfsmCurrencyVT, vcWv.Constant, 
                           vfsmCurrency.Current),
                vcWv.Param("Level",vfsmLevelVT, vcWv.Constant,
                           vfsmLevel.Selected_block),
                vcWv.Param("Query",vlOnOffVT, vcWv.Constant,vlOnOff.Off));

function build_chkpt_picklist(dp,exclflag)
{
   count := 0;
   picklist := vcRegion.Create1("", vcPicklist.fac, nil,
                                list (cons (`exclusive, exclflag),
                                      cons (`rows, 5),
                                      cons (`columns, 3)));
   /* for each datapack, add it to the picklist */
   foreach (str; getcheckpoints(dp)) {
     vcPicklist.Add(picklist, str, str);
     count = count + 1;
   }
 
   return(picklist);
}

function CheckPoint(data, event)
{
  declare chkptwin,dppicklist,name,comment,lib;
  set_stdout(TRUE);
  function accept_chkpt() {

    dp := vcRegion.Get(dppicklist, vscmVT);
    if (dp == nil) {
       vcWin.ClearStatus(chkptwin);
       vcWin.AddStatus(chkptwin, "Please select design to checkpoint");
       FALSE;
    }
    else {
       chkptname := vcRegion.Get(vcTable.Get(name,0,1), vlStringVT);
       if (string_eq(chkptname,"")) {
          vcWin.ClearStatus(chkptwin);
          vcWin.AddStatus(chkptwin, "Please enter a name for the checkpoint");
          FALSE;
       }
       else {
          vcWin.Busy(chkptwin, TRUE);
          chkptcomment := vcRegion.Get(vcTable.Get(comment,0,1), vlStringVT);
          vcCmd.Run(_checkpoint, data, event, list(dp, chkptname, 
                    chkptcomment),TRUE);
          vcCmd.Run(popobjcmd, data, event, list(lib), TRUE);
          enable_changeproj_commands(nil);
          exitvplist(lib);
          vcWin.Busy(chkptwin, FALSE);
          vcWin.Close(chkptwin);
       }
     } 
  }

  if (IsCurProj()==1) {
     chkptdialog := vcTable.Create("Checkpoint",5,1);

     /* label for the entire table */
     vcTable.Add(chkptdialog, label("Select Design Block to Checkpoint"));

     /* scrollable picklist of datapacks/design blocks */
     lib = getcurlib();
     dppicklist = blockpicklist(lib,1);
     vcTable.Add(chkptdialog, create_scroll_picklist(dppicklist,2,5));

     /* cmdline for checkpoint name */
     name = label_cmd("Checkpoint Name","");
     vcTable.Add(chkptdialog, name);

     /* cmdline for checkpoint comment */
     comment = label_cmd("Checkpoint Comment","");
     vcTable.Add(chkptdialog, comment);

     /* button row */
     vcTable.Add(chkptdialog, vcRegion.Create("buttons", vcButnRow.fac,
              list (list ("Accept", "Accept",
                          func() {accept_chkpt(); },
                          nil),
                    list ("Cancel", "Cancel",
                          func() { exitvplist(lib);
                                   vcWin.Close(chkptwin);
                                   enable_changeproj_commands(nil);},
                          nil))));

     /* window for the dialog */
     chkptwin = vcWin.Popup(vcEvent.Window(event),chkptdialog,dppicklist,
                      (vcWin.NoCmdline + vcWin.NoMenus + vcWin.NoBindings));
   }
}

checkPoint := vcWv.Cmd(fac, CheckPoint, "checkPoint");
vcCmd.SetHelp(checkPoint,"Create a configuration of the selected design block");
vcCmd.EnableMacro(checkPoint, vlOnOff.Off);

_checkpoint := vcWv.Cmd(fac, ChkPoint, "_checkpoint", "Checkpoint",
               vcWv.Param("Design Block", vfsmOidVT, vcWv.Dynamic, getnulloid),
               vcWv.Param("Checkpoint Name", string, vcWv.Constant, ""),
               vcWv.Param("Checkpoint Comment", string, vcWv.Constant, ""));
vcCmd.EnableMacro(checkPoint, vlOnOff.On);

function restore(data, event, isrestore)
{
  declare rchkptwin,dppicklist,namepicklist;
  declare names_displayed, rchkptdialog;
  declare dp,lib;
  set_stdout(TRUE);

  function accept_name(chkptpick, on_off) {
    if (on_off == vlOnOff.On) {
          vcWin.Busy(rchkptwin, TRUE);

          chkptname := chkptpick;
          if (isrestore) {
             vcCmd.Run(_restorechkpt, data, event, list(dp, chkptname), TRUE);
          }
          else {
             vcCmd.Run(_listchkpt, data, event, list(dp, chkptname), TRUE);
          }
          vcCmd.Run(popobjcmd, data, event, list(lib), TRUE);

          vcWin.Close(rchkptwin);
          enable_changeproj_commands(nil);
          exitvplist(lib);
    }
  }

  function pick_rchkpt(dp_pick, on_off) {
    if (on_off == vlOnOff.On) {

      dp = dp_pick;
      if (dp == nil) {
         vcWin.ClearStatus(win := vcEvent.Window(event));
         if (isrestore)
            vcWin.AddStatus(win, "Please select design to restore checkpoint");
         else vcWin.AddStatus(win, "Please select design to list checkpoint");
      }
      else {
         vcWin.Busy(rchkptwin, TRUE);
         namedialog := vcTable.Create("Checkpoint Name", 3, 1);
         if (isrestore)
            vcTable.Add(namedialog, label("Select the Checkpoint Name you want to Restore"));
         else vcTable.Add(namedialog, label("Select the Checkpoint Name you want to List"));
         namepicklist = chkptnamespicklist(dp);
         if (namepicklist == nil) {
            vcWin.AddStatus(rchkptwin, "There are no checkpoints for selected block");
         }
         else {
            vcPicklist.Notify(namepicklist, accept_name);
            vcTable.Add(namedialog, create_scroll_picklist(namepicklist,2,5));
            /* now add this to the original dialog before the buttons */
            if (!names_displayed) {
               names_displayed = TRUE;
               vcTable.InsertRows(rchkptdialog, 2, 1);
            }
            vcTable.Set(rchkptdialog,2,0,namedialog);
            vcRegion.Reframe(rchkptdialog, vcRegion.Area(rchkptdialog));
            vcRegion.Refresh(rchkptdialog, vcRegion.Area(rchkptdialog));
        }
        vcWin.Busy(rchkptwin, FALSE);
      }
    }
  }
   
  dp = nil;
  names_displayed = FALSE;
  if (isrestore)
     rchkptdialog = vcTable.Create("RestoreCheckpoint",3,1);
  else rchkptdialog = vcTable.Create("ListCheckpoint",3,1);

  /* label for the entire table */
  if (isrestore)
     vcTable.Add(rchkptdialog, label("Select Design Block to Restore Checkpoint"));
  else vcTable.Add(rchkptdialog, label("Select Design Block to List Checkpoint"));

  /* scrollable picklist of datapacks/design blocks */
  lib = getcurlib();
  dppicklist = blockpicklist(lib,1);
  vcPicklist.Notify(dppicklist, pick_rchkpt);

  vcTable.Add(rchkptdialog, create_scroll_picklist(dppicklist,2,5));

  /* button row */
  vcTable.Add(rchkptdialog, vcRegion.Create("buttons", vcButnRow.fac,
              list (/*list ("Accept", "Accept",
                          func() { accept_name(picklist, on); },
                          nil),*/
                    list ("Cancel", "Cancel",
                          func() { vcWin.Close(rchkptwin); 
                          exitvplist(lib);
                          enable_changeproj_commands(nil); },
                          nil))));

  /* window for the dialog */
  rchkptwin = vcWin.Create(rchkptdialog,
                      (vcWin.NoCmdline + vcWin.NoMenus + vcWin.NoBindings));
  
}

function Restorecheckpoint(data, event)
{
  if (IsCurProj() == 1)
     restore(data, event, TRUE);
}
restoreCheckPoint := vcWv.Cmd(fac, Restorecheckpoint, "restoreCheckPoint");
vcCmd.SetHelp(restoreCheckPoint,
               "Restore a configuration of the selected design block");
vcCmd.EnableMacro(restoreCheckPoint, vlOnOff.Off);

_restorechkpt := vcWv.Cmd(fac, RestoreChkPt, "_restorechkpt", "RestoreCheckpoint",
               vcWv.Param("Design Block", vfsmOidVT, vcWv.Dynamic, getnulloid),
               vcWv.Param("Checkpoint Name", string, vcWv.Constant, ""));

function Listcheckpoint(data, event)
{
  if (IsCurProj() == 1)
     restore(data, event, FALSE);
}

listCheckPoint := vcWv.Cmd(fac, Listcheckpoint, "listCheckPoint");
vcCmd.SetHelp(listCheckPoint,
               "Display the contents of a checkpoint");
vcCmd.EnableMacro(listCheckPoint, vlOnOff.Off);

_listchkpt := vcWv.Cmd(fac, ListChkPt, "_listchkpt", "ListCheckpoint",
               vcWv.Param("Design Block", vfsmOidVT, vcWv.Dynamic, getnulloid),
               vcWv.Param("Checkpoint Name", string, vcWv.Constant, ""));

/**************************************************************************/
/* Dialog routines for Data Management                                    */
/**************************************************************************/

function build_curview_reg()
{
  curview := getcurview();
  wksp := getwksp();
  curview_reg := vcTable.Make("curview", 1, 4,
                              label("Workspace :"),
                              label(wksp),
                              label("Current View :"),
                              label(curview));
}

function build_enum_widget(prompt, default)
{
    t := vcTable.Create (prompt, 1, 2);

    vcTable.Add (t, vcRegion.Create ("", vcLabel.fac, prompt));
    vcTable.Add (t, vcRegion.Create ("", vcPickEnum.fac, default));

    t;
}

function typelabel(kindofmanage)
{
  if (kindofmanage==vfsmCommand.Checkout)
     label("Checkout");
  else if (kindofmanage==vfsmCommand.Fetch)
     label("Fetch");
  else if (kindofmanage==vfsmCommand.Cancelcheckout)
     label("Cancel Checkout");
  else if (kindofmanage==vfsmCommand.Checkin)
     label("Checkin");
  else if (kindofmanage==vfsmCommand.Setdefault)
     label("Set Default Version");
  else if (kindofmanage==vfsmCommand.Setcurrent)
     label("Set Current Version");
  else label("Unknown");
}

function accept_set(data,event,kindofmanage,vers) 
{
    declare ver;

    foreach(ver; vscript.list_iter(vers)) { 
      if (kindofmanage == vfsmCommand.Setdefault)
         vcCmd.Run(setdefault, data, event, list(ver), TRUE);
      else vcCmd.Run(setcurrent, data, event, list(ver), TRUE);
    }
}

function show_files(dmwin, dmdialog, kindofmanage, elementsdisplayed,
                blockreg, typereg, newblockreg, verreg, buttons, lib, vertype)
{
     declare filereg,newblock;
     set_stdout(TRUE);

     /* if the versions are already shown, remove the item and close the files*/
     if (verreg != nil) {
        vcTable.DeleteRows(dmdialog, 6, 1);

     }

     /* get the list of blocks selected */
     blocks := vcRegion.Get(blockreg, vscmVT);
     /* checkin command allows no blocks to be selected but new block name
        must be entered */
     if ((blocks == nil) && (kindofmanage!=vfsmCommand.Checkin)) {
        vcWin.ClearStatus(dmwin);
        vcWin.AddStatus(dmwin, "Please select at least one block");
     }
     else {
        /* get the list of selected types */
        types := vcRegion.Get(typereg, vscmVT);
        if (types == nil) {
           vcWin.ClearStatus(dmwin);
           vcWin.AddStatus(dmwin, "Please select at least one type");
        }
        else if ((blocks == nil) && (kindofmanage==vfsmCommand.Checkin)) {
           newblock = vcRegion.Get(newblockreg, vlStringVT);
           if (newblock == "") {
              vcWin.ClearStatus(dmwin);
              vcWin.AddStatus(dmwin, 
                  "Please select at least one block or enter a new block name");
           }
           else {
              vcWin.Busy(dmwin, TRUE);

              first := TRUE;
              foreach(type; vscript.list_iter(types)) {
                 if (first) {
                    first = FALSE;
                    filereg = newfilepicklist(nil, lib, newblock, type);
                 }    
                 else filereg = newfilepicklist(filereg, lib, newblock, type);
              }

              if (!elementsdisplayed)
                 elementsdisplayed = TRUE;
              else vcTable.DeleteRows(dmdialog, 5, 1);
              vcTable.InsertRows(dmdialog, 5, 1);

              labeltab := vcTable.Make("",2,1,label("Select File(s)"),
                                    label("(files in italics are checked out)"));
              vcTable.Row (labeltab, -1, vcTable.Border.Invisible, 10, 10, 10,
                 vgAlign.MiddleCenter);
              vcTable.Set(dmdialog,5,0,vcTable.Make("",1,2,labeltab,
                                        create_scroll_picklist(filereg,3,5)));
              vcRegion.Reframe(dmdialog, vcRegion.Area(dmdialog));
              vcRegion.Refresh(dmdialog, vcRegion.Area(dmdialog));
           }
        }
        else {
           vcWin.Busy(dmwin, TRUE);
           first := TRUE;
           filereg = fpicklist(blocks, types, kindofmanage, vertype);

           /* if it is a checkintype then also add any new block files */
           if (kindofmanage == vfsmCommand.Checkin) {
              newblock := vcRegion.Get(newblockreg, vlStringVT);
              foreach(type; vscript.list_iter(types))
                 filereg = newfilepicklist(filereg, lib, newblock, type);
           }
           if (!elementsdisplayed)
              elementsdisplayed = TRUE;
           else vcTable.DeleteRows(dmdialog, 5, 1);
           vcTable.InsertRows(dmdialog, 5, 1);

           labeltab := vcTable.Make("",2,1,label("Select File(s)"),
                                    label("(files in italics are checked out)"));
           vcTable.Row (labeltab, -1, vcTable.Border.Invisible, 10, 10, 10,
                 vgAlign.MiddleCenter);
           vcTable.Set(dmdialog,5,0,vcTable.Make("",1,2,
                                        labeltab,
                                        create_scroll_picklist(filereg,3,5)));
           vcRegion.Reframe(dmdialog, vcRegion.Area(dmdialog));
           vcRegion.Refresh(dmdialog, vcRegion.Area(dmdialog));
        }
        if (kindofmanage == vfsmCommand.Setdefault || 
            kindofmanage == vfsmCommand.Setcurrent) {
            vcRegion.Enable(vcButnRow.Get(buttons,2), TRUE, TRUE);
            vcRegion.Enable(vcButnRow.Get(buttons,3), TRUE, TRUE);
        }
     }
     vcWin.Busy(dmwin, FALSE);

  /* return the region */
  filereg;
}

function show_file_info(dmwin, filereg, event)
{
     declare file;

     files := vcRegion.Get(filereg, vscmVT);
     if (files == nil) {
        vcWin.ClearStatus(dmwin);
        vcWin.AddStatus(dmwin, "Please select at least one file");
     }
     else {
        vcWin.Busy(dmwin, TRUE);
        DisplayInfo(event, files);
        vcWin.Busy(dmwin, FALSE);
     }
}
function show_vers(dmwin, dmdialog, filereg, buttons, versdisplayed)
{
     declare file, verreg;

     files := vcRegion.Get(filereg, vscmVT);
     if (files == nil) {
        vcWin.ClearStatus(dmwin);
        vcWin.AddStatus(dmwin, "Please select at least one file");
     }
     else {
        vcWin.Busy(dmwin, TRUE);
        first := TRUE;
        foreach(file; vscript.list_iter(files)) {
           if (first) {
              first = FALSE;
              verreg = verpicklist(nil, file);
           }
           else verreg = verpicklist(verreg, file);
        }
        if (!versdisplayed)
           versdisplayed = TRUE;
        else vcTable.DeleteRows(dmdialog, 6, 1);
        vcTable.InsertRows(dmdialog, 6, 1);

        vcTable.Set(dmdialog,6,0,vcTable.Make("",1,2,
                                        label("Select Version(s)"),
                                        create_scroll_picklist(verreg,3,5)));

        vcRegion.Reframe(dmdialog, vcRegion.Area(dmdialog));
        vcRegion.Refresh(dmdialog, vcRegion.Area(dmdialog));

        /* enable the Accept button */
        vcRegion.Enable(vcButnRow.Get(buttons,0), TRUE, TRUE);
        vcWin.Busy(dmwin, FALSE);
     }
  /* return the region */
  verreg;
}

function sethelpmsg(buttons,kindofmanage)
{
  accept := vcButnRow.Get(buttons, 0);
  show_files := vcButnRow.Get(buttons,1);
  show_vers := vcButnRow.Get(buttons,2);

  if (kindofmanage == vfsmCommand.Checkout) {
     vcRegion.PrefSet(accept,
         list(help <- "Checkout files of selected types in selected blocks"));
     vcRegion.PrefSet(show_files,
         list(help <- "Displays and allows checkout of individually selected files"));
  }
  else if (kindofmanage == vfsmCommand.Checkin) {
     vcRegion.PrefSet(accept,
         list(help <- "Checkin files of selected types in selected blocks"));
     vcRegion.PrefSet(show_files,
         list(help <- "Displays and allows checkin of individually selected files"));
  }
  else if (kindofmanage == vfsmCommand.Fetch) {
     vcRegion.PrefSet(accept,
         list(help <- "Fetch files of selected types in selected blocks"));
     vcRegion.PrefSet(show_files,
         list(help <- "Displays and allows fetch of individually selected files"));
  }
  else if (kindofmanage == vfsmCommand.Cancelcheckout) {
     vcRegion.PrefSet(accept,
         list(help <- "Cancel Checkout files of selected types in selected blocks"));
     vcRegion.PrefSet(show_files,
         list(help <- "Displays and allows cancelling checkout of individually selected files"));
  }
  else if (kindofmanage == vfsmCommand.Setdefault) {
     vcRegion.PrefSet(accept,
         list(help <- "Sets default marker on selected file version"));
     vcRegion.PrefSet(show_files,
         list(help <- "Displays files in a block"));
     vcRegion.PrefSet(show_vers,
         list(help <- "Displays versions of selected files"));
  }
  else if (kindofmanage == vfsmCommand.Setcurrent) {
     vcRegion.PrefSet(accept,
         list(help <- "Sets current marker on selected file version"));
     vcRegion.PrefSet(show_files,
         list(help <- "Displays files in a block"));
     vcRegion.PrefSet(show_vers,
         list(help <- "Displays versions of selected files"));
  }

}

function disable_command(kindofmanage,on_off)
{
  ;
/*
  if (kindofmanage == vfsmCommand.Checkout) {
     vcCmd.Enable(checkoutcmd,on_off);
  }
  else if (kindofmanage == vfsmCommand.Checkin) {
     vcCmd.Enable(checkincmd,on_off);
  }
  else if (kindofmanage == vfsmCommand.Fetch) {
     vcCmd.Enable(fetchcmd,on_off);
  }
  else if (kindofmanage == vfsmCommand.Cancelcheckout) {
     vcCmd.Enable(cancelcheckoutcmd,on_off);
  }
  else if (kindofmanage == vfsmCommand.Setdefault) {
     vcCmd.Enable(setdefcmd,on_off);
  }
  else if (kindofmanage == vfsmCommand.Setcurrent) {
     vcCmd.Enable(setcurcmd,on_off);
  }
*/
}  

function managedata(data, event, kindofmanage)
{
  declare dmwin, toolreg, viewreg, libreg, typereg, blockreg, lib;
  declare fileopreg, levelreg, buttons;
  declare newblockreg, commentreg, vertypereg;
  declare elementsdisplayed, filereg;
  declare verreg, versdisplayed, vertype;
  declare vplist;

  function accept_manage() {
    declare type, block, file;
    declare fileop, files;

    set_stdout(TRUE);
    /* accept for setdefault and setcurrent */
    if (kindofmanage == vfsmCommand.Setdefault || 
        kindofmanage == vfsmCommand.Setcurrent) {
        vers := vcRegion.Get(verreg, vscmVT);
        if (vers == nil) {
           vcWin.ClearStatus(dmwin);
           vcWin.AddStatus(dmwin, "Please select at least one version");
        }
        else {
           vcWin.Busy(dmwin, TRUE);
           accept_set(data,event,kindofmanage,vers);
           vcCmd.Run(popobjcmd, data, event, list(lib), TRUE);
           disable_command(kindofmanage,TRUE);
           /* clean up the list */
           exitvplist(vplist);
           vcWin.Busy(dmwin, FALSE);
           vcWin.Close(dmwin);
        }
    }
    else {
     if (elementsdisplayed) {
        /* see if any files have been selected */
        files = vcRegion.Get(filereg, vscmVT);
     }
     blocks := vcRegion.Get(blockreg, vscmVT);
     if ((blocks == nil) && (kindofmanage != vfsmCommand.Checkin)){
        vcWin.ClearStatus(dmwin);
        vcWin.AddStatus(dmwin, "Please select at least one block");
     }
     else {
        types := vcRegion.Get(typereg, vscmVT);
        if (types == nil) {
           vcWin.ClearStatus(dmwin);
           vcWin.AddStatus(dmwin, "Please select at least one type");
        }

        /* special case for checkin with no block selected */
        else if (blocks == nil && kindofmanage==vfsmCommand.Checkin &&
                 files == nil) {
           /* if there are no selected blocks use the newblock field to checkin*/
           vcWin.Busy(dmwin, TRUE);
           level := vcRegion.Get(vcTable.Get(levelreg,0,1),vfsmLevelVT);
           newblock := vcRegion.Get(newblockreg, vlStringVT);
           comment := vcRegion.Get(commentreg, vlStringVT);
           fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmCancelopTypeVT);
           foreach(type; vscript.list_iter(types)) {
              vcCmd.Run(checkinblktype2, data, event,
                        list(lib,type,newblock,comment,level,fileop), 
                             TRUE);
           }

           vcCmd.Run(popobjcmd, data, event, list(lib), TRUE);
           disable_command(kindofmanage,TRUE);
           /* clean up the list */
           exitvplist(vplist);
           vcWin.Busy(dmwin, FALSE);
           vcWin.Close(dmwin);
        }

        /* this handles a set of selected blocks and selected types */
        else if (!elementsdisplayed || (elementsdisplayed && files==nil)) {
           vcWin.Busy(dmwin, TRUE);
           foreach(block; vscript.list_iter(blocks)) {
              first := TRUE;
              foreach(type; vscript.list_iter(types)) { 
                 /* level is used in each command */
                 level := vcRegion.Get(vcTable.Get(levelreg,0,1),vfsmLevelVT);

                 /* checkout block */
                 if (kindofmanage==vfsmCommand.Checkout) {
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmFileopTypeVT);
                    vcCmd.Run(checkoutblktype, data, event, 
                          list(block, type, fileop, level, vlOnOff.Off), TRUE);
                 }

                 /* fetch block */
                 else if (kindofmanage==vfsmCommand.Fetch) {
                    vertype = vcRegion.Get(vcTable.Get(vertypereg,0,1), 
                                          vfsmCurrencyVT);
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmFetchopTypeVT);
                    vcCmd.Run(fetchblktype, data, event,
                          list(block, type, fileop, vertype, level, 
                               vlOnOff.Off), TRUE);
                 }

                 /* cancelcheckout block */
                 else if (kindofmanage==vfsmCommand.Cancelcheckout) {
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmCancelopTypeVT);
                    vcCmd.Run(cancelcheckoutblktype, data, event,
                              list(block, type, fileop, level), TRUE);
                 }

                 /* checkin block */
                 else if (kindofmanage==vfsmCommand.Checkin) {
                    newblock := vcRegion.Get(newblockreg, vlStringVT);
                    comment := vcRegion.Get(commentreg, vlStringVT);
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmCancelopTypeVT);
                    if (first) {
                     /* had to set to 2 commands - can't have more than 6 args*/
                       vcCmd.Run(checkinblktype, data, event,
                          list(lib,block, type, comment, level, 
                               fileop), TRUE);
                       vcCmd.Run(checkinblktype2, data, event,
                          list(lib, type, newblock, comment, level, 
                               fileop), TRUE);
                    }
                    else
                       vcCmd.Run(checkinblktype, data, event,
                              list(lib,block, type, "", comment, level, fileop),
                                   TRUE);
                 }
              }
              first = FALSE;
           }
           vcCmd.Run(popobjcmd, data, event, list(lib), TRUE);

           disable_command(kindofmanage,TRUE);
           /* clean up the list */
           exitvplist(vplist);
           vcWin.Busy(dmwin, FALSE);
           vcWin.Close(dmwin);
        }

        /* this handles individually selected files */
        else if (elementsdisplayed && files!=nil) {
           vcWin.Busy(dmwin, FALSE);
           foreach(file; vscript.list_iter(files)) {
                 level := vcRegion.Get(vcTable.Get(levelreg,0,1),vfsmLevelVT);

                 /* checkout file */
                 if (kindofmanage==vfsmCommand.Checkout) {
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmFileopTypeVT);
                    vcCmd.Run(checkoutftype, data, event, 
                              list(file, fileop, level, vlOnOff.Off), TRUE);
                 }

                 /* fetch file */
                 else if (kindofmanage==vfsmCommand.Fetch) {
                    vertype = vcRegion.Get(vcTable.Get(vertypereg,0,1), 
                                          vfsmCurrencyVT);
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmFetchopTypeVT);
                    vcCmd.Run(fetchftype, data, event,
                              list(file, fileop, vertype, level, 
                                   vlOnOff.Off), TRUE);
                 }

                 /* cancelcheckout file */
                 else if (kindofmanage==vfsmCommand.Cancelcheckout) {
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmCancelopTypeVT);
                    vcCmd.Run(cancelcheckoutftype, data, event,
                              list(file, fileop, level), TRUE);
                 }

                 /* checkin file */
                 else if (kindofmanage==vfsmCommand.Checkin) {
                    newblock := vcRegion.Get(newblockreg, vlStringVT);
                    comment := vcRegion.Get(commentreg, vlStringVT);
                    fileop = vcRegion.Get(vcTable.Get(fileopreg,0,1), 
                                          vfsmCancelopTypeVT);
                    vcCmd.Run(checkinftype, data, event,
                              list(file, comment, level, fileop), 
                                   TRUE);
                 }
           }

           vcCmd.Run(popobjcmd, data, event, list(lib), TRUE);

           disable_command(kindofmanage,TRUE);
           exitvplist(vplist);
           vcWin.Busy(dmwin, FALSE);
           vcWin.Close(dmwin);
        }
     }
    }
  }

  function libselect(newlib, on_off)
  {

    if (on_off) {
       vcWin.Busy(dmwin, FALSE);
       /* if new library selected, get new blocks */
       lib = newlib;
       blockreg = blockpicklist(lib,0);

       vcTable.Set(vcTable.Get(dmdialog,3,0),0,1,
                               create_scroll_picklist(blockreg,3,5));
       if (versdisplayed) {
          /* if there are element versions displayed remove them */
          vcTable.DeleteRows(dmdialog,6,1);
          versdisplayed = TRUE;
       }
       if (elementsdisplayed) {
          /* if there are files displayed remove them */
          vcTable.DeleteRows(dmdialog,5,1);
          elementsdisplayed = FALSE;
       }
       /* if there are no blocks and it is not a checkin, disable buttons */
       if (vcPicklist.Get(blockreg,0,0)==nil &&
           kindofmanage != vfsmCommand.Checkin) {
         vcRegion.Enable(vcButnRow.Get(buttons,0), FALSE, FALSE);
         vcRegion.Enable(vcButnRow.Get(buttons,1), FALSE, FALSE);
       }
       else {
         vcRegion.Enable(vcButnRow.Get(buttons,0), TRUE, TRUE);
         vcRegion.Enable(vcButnRow.Get(buttons,1), TRUE, TRUE);
       }

       vcRegion.Reframe(dmdialog, vcRegion.Area(dmdialog));
       vcRegion.Refresh(dmdialog, vcRegion.Area(dmdialog));
       vcWin.Busy(dmwin, FALSE);

    }
    else popobj(data,event,lib);
  }

  set_stdout(TRUE);

  /*disable this command until done */
  disable_command(kindofmanage,FALSE);

  parent_win := vcEvent.Window(event);
  vcWin.Busy(parent_win, TRUE);

  elementsdisplayed = FALSE;
  versdisplayed = FALSE;

  dmdialog := vcTable.Create("Data Management",9,1);

  /* label for the entire dialog */
  vcTable.Add(dmdialog, typelabel(kindofmanage));

  /* current view region */
  curview := getcurview();
  viewreg = build_curview_reg();

  vcTable.Add(dmdialog, viewreg);

  /* get the new list */
  vplist = newvplist();

  /* picklist of libraries */
  libreg = libspicklist(vplist);
  vcPicklist.Notify(libreg, libselect);
  lib = vcRegion.Get(libreg,vfsmOidVT);
  vcTable.Add(dmdialog, vcTable.Make("",1,2,label("Library :"),libreg));

  /* picklist of blocks */
  blockreg = blockpicklist(lib,0);
  if (anyblocks(lib) == 0 && kindofmanage != vfsmCommand.Checkin) {
     exitvplist(vplist);
     vcWin.ClearStatus(parent_win);
     vcWin.AddStatus(parent_win,"No files are in data manager - command not valid");
     disable_command(kindofmanage,TRUE);
     
  }
  else {
     labtab := vcTable.Make("",2,1,label("Select Design Block(s) :"),
                                label("(already in data manager)"));
     vcTable.Row (labtab, -1, vcTable.Border.Invisible, 10, 10, 10,
                 vgAlign.MiddleCenter);
     vcTable.Add(dmdialog, vcTable.Make("",1,2,labtab,
                                create_scroll_picklist(blockreg,3,5)));
     /* picklist of types */
     typereg = typepicklist(curview,lib);
     vcTable.Add(dmdialog, vcTable.Make("",1,2,label("Select File Type(s) :"),
                                create_scroll_picklist(typereg,3,5)));

     /* fileop region or block entry region*/
     if (kindofmanage == vfsmCommand.Checkin) {
        /* create an entry region for new blocks */
        newblockreg = cmdline("newblock","");

        vcTable.Add(dmdialog, vcTable.Make("",1,2,
                 label("Enter Block Name(s)\nfor new files :"),newblockreg));
        /* create an entry region for checkin comment */
        commentreg = cmdline("comment","");
        vcTable.Add(dmdialog, vcTable.Make("",1,2,
                                label("Enter Checkin Comment :"),commentreg));
        fileopreg = build_enum_widget("File Operation :      ", 
                                   vfsmCancelopType.Keep);
        vcTable.Add(dmdialog, fileopreg);
     }
     else if (kindofmanage != vfsmCommand.Setcurrent && 
           kindofmanage != vfsmCommand.Setdefault) {
        /* for each of the other manage types there is an associated file op */
        if (kindofmanage == vfsmCommand.Fetch) {
           fileopreg = build_enum_widget("File Operation :      ", 
                                   vfsmFetchopType.Copy);
           vertypereg = build_enum_widget("Version :         ",
                                   vfsmCurrency.Current);
           vcTable.Add(dmdialog, vertypereg);
        }
        else if (kindofmanage == vfsmCommand.Cancelcheckout) 
           fileopreg = build_enum_widget("File Operation :      ", 
                                   vfsmCancelopType.Keep);
        else if (kindofmanage == vfsmCommand.Checkout)
           fileopreg = build_enum_widget("File Operation :      ", 
                                   vfsmFileopType.Copy);
     vcTable.Add(dmdialog, fileopreg);
     }

     /* level region */
     if (kindofmanage != vfsmCommand.Setdefault && 
         kindofmanage != vfsmCommand.Setcurrent) {
        levelreg = build_enum_widget("Level :              ", vfsmLevel.Selected_block);
        vcTable.Add(dmdialog, levelreg);
     }

     /* button row */
     buttons = vcRegion.Create("buttons", vcButnRow.fac,
              list (list ("Accept", "Accept",
                          func() { accept_manage(); },
                          nil),
                    list ("Show Files", "Show Files",
                          func() { 
                            vertype = vfsmCurrency.Current;
                            if (kindofmanage == vfsmCommand.Fetch)
                                vertype = vcRegion.Get(vcTable.Get(vertypereg,
                                                       0,1), vfsmCurrencyVT);
                            filereg = show_files(dmwin, dmdialog, kindofmanage,
                                       elementsdisplayed, blockreg, typereg,
                                       newblockreg, verreg, buttons, lib, 
                                       vertype);
                            if (filereg != nil)
                               elementsdisplayed = TRUE;
                            verreg = nil; 
                            versdisplayed = FALSE;
                          }, nil),
                    list ("Show Versions", "Show Versions",
                          func() { 
                            verreg = show_vers(dmwin, dmdialog, filereg, 
                                               buttons, versdisplayed);
                            if (verreg != nil) 
                               versdisplayed = TRUE;
                          }, nil),
                    list ("Show File Info", "Show File Info",
                          func() { 
                              show_file_info(dmwin, filereg, event);
                          }, nil),
                    list ("Cancel", "Cancel",
                          func() { 
                              popobj(data,event,lib);
                              disable_command(kindofmanage,TRUE);
                              exitvplist(vplist);
                              vcWin.Close(dmwin); 

                          },
                          nil)));
     /* set up help message for Accept Show Files, Show Versions */
     sethelpmsg(buttons,kindofmanage);

     vcTable.Add(dmdialog, buttons);

     /* if the command is setdefault or setcurrent disable the Accept button */
     if (kindofmanage == vfsmCommand.Setdefault || 
         kindofmanage == vfsmCommand.Setcurrent)
         vcRegion.Enable(vcButnRow.Get(buttons,0), FALSE, FALSE);

     /* disable the Show vers button - only for setdefault or setcurrent after
     show files is done */
     vcRegion.Enable(vcButnRow.Get(buttons,2), FALSE, FALSE);
     vcRegion.Enable(vcButnRow.Get(buttons,3), FALSE, FALSE);

     vcTable.Row (dmdialog, -1, vcTable.Border.Invisible, 10, 10, 10,
                 vgAlign.MiddleCenter);
     vcTable.Row (dmdialog, 2, vcTable.Border.Invisible, 5, 5, 5,
                 vgAlign.MiddleLeft);
     vcTable.Row (dmdialog, 3, vcTable.Border.Invisible, 5, 5, 5,
                 vgAlign.MiddleLeft);
     vcTable.Row (dmdialog, 4, vcTable.Border.Visible, 10, 10, 10,
                 vgAlign.MiddleCenter);
     vcTable.Row (dmdialog, 5, vcTable.Border.Visible, 10, 10, 10,
                 vgAlign.MiddleCenter);
     vcTable.Row (dmdialog, 6, vcTable.Border.Invisible, 5, 5, 5,
                 vgAlign.MiddleCenter);
     vcTable.Row (dmdialog, 7, vcTable.Border.Invisible, 5, 5, 5,
                 vgAlign.MiddleCenter);
     vcTable.Row (dmdialog, 8, vcTable.Border.Invisible, 5, 5, 5,
                 vgAlign.MiddleCenter);
     vcTable.Col (dmdialog, -1, vcTable.Border.Visible, 5, 5, 5,
                 vgAlign.MiddleCenter);

     /* window for the dialog */
     dmwin = vcWin.Popup(vcEvent.Window(event),dmdialog,blockreg,
                      (vcWin.NoCmdline + vcWin.NoMenus + vcWin.NoBindings));
  }
  vcWin.Busy(vcEvent.Window(event), FALSE);
  
}

function checkout(data, event)
{
  if (IsCurProj() == 1)
     managedata(data, event, vfsmCommand.Checkout);
}

checkoutcmd := vcWv.Cmd(fac, checkout, "checkout");
vcCmd.EnableMacro(checkoutcmd, vlOnOff.Off);

function fetch(data, event)
{
  if (IsCurProj() == 1)
     managedata(data, event, vfsmCommand.Fetch);
}

fetchcmd := vcWv.Cmd(fac, fetch, "fetch");
vcCmd.EnableMacro(fetchcmd, vlOnOff.Off);

function cancelcheckout(data, event)
{
  if (IsCurProj() == 1)
     managedata(data, event, vfsmCommand.Cancelcheckout);
}

cancelcheckoutcmd := vcWv.Cmd(fac, cancelcheckout, "cancelcheckout");
vcCmd.EnableMacro(cancelcheckoutcmd, vlOnOff.Off);

function checkin(data, event)
{
  if (IsCurProj() == 1)
     managedata(data, event, vfsmCommand.Checkin);
}

checkincmd := vcWv.Cmd(fac, checkin, "checkin");
vcCmd.EnableMacro(checkincmd, vlOnOff.Off);

function setdef(data, event)
{
  if (IsCurProj() == 1)
     managedata(data, event, vfsmCommand.Setdefault);
}

setdefcmd := vcWv.Cmd(fac, setdef, "setdef");
vcCmd.EnableMacro(setdefcmd, vlOnOff.Off);

function setcur(data, event)
{
  if (IsCurProj() == 1)
     managedata(data, event, vfsmCommand.Setcurrent);
}

setcurcmd := vcWv.Cmd(fac, setcur, "setcur");
vcCmd.EnableMacro(setcurcmd, vlOnOff.Off);

chgwksp := vcWv.Cmd(fac, changewksp, "changewksp", "Change Workspace",
         vcWv.Param("Workspace Name /<machine>/<name>",string,vcWv.Sticky,""));

dm_menu := vcWv.MakeMenu ("Data Management",
                    list ("Browse Storage Data", browsepf),
                    list ("Checkpoint", checkPoint),
                    list ("Restore Checkpoint", restoreCheckPoint),
                    list ("List Checkpoint", listCheckPoint),
                    list ("Checkout", checkoutcmd),
                    list ("Checkin", checkincmd),
                    list ("Fetch - Read Only", fetchcmd),
                    list ("Cancel Checkout", cancelcheckoutcmd),
                    list ("Set Default", setdefcmd),
                    list ("Set Current", setcurcmd),
                    list ("Change Workspace", chgwksp));

vcMenu.AppendEntry(main_menu,"Data Management", dm_menu);
