
cmd_list := list (
    "time_measurement",
    "tm",
    "log_vectors",
    "lv",
    "restart",
    "continue",
    "radix",
    "pfg",
    "report",
    "type",
    "break",
    "b",
    "help",
    "statistics",
    "stats",
    "network",
    "net",
    "check",
    "(",
    "vector",
    "v",
    "pattern",
    "pat",
    "path",
    "activity",
    "act",
    "assign",
    "a",
    "changes",
    "ch",
    "execute",
    "ex",
    "logfile",
    "log",
    "d",
    "display",
    "x",
    "h",
    "l",
    "r",
    "watch",
    "w",
    "trace",
    "t",
    "wave",
    "inputs",
    "stepsize",
    "step",
    "wfm",
    "sim",
    "s",
    "info",
    "clock",
    "ck",
    "run",
    "cycle",
    "c",
    "echo",
    "debug",
    "save",
    "restore",
    "rest",
    "delay",
    "defaults",
    "dflts",
    "print",
    "every",
    "after",
    "af",
    "loadm",
    "loadmem",
    "loads",
    "loadstate",
    "wavexfer",
    "ticksize",
    "dumpm",
    "flush",
    "exit",
    "quit",
    "q",
    "probe",
    "fault",
    "list",
    "testpoints",
    "tp",
    "toggle",
    "threshold",
    "dictionary",
    "ffs_debug",
    "sched_debug",
    "show",
    "sh",
    "strace",
    "sdisplay",
    "stop",
    "delete",
    "accel",
    "noaccel",
    "monitor",
    "activate",
    "vsimsys",
    "source");

function build_cmd(str)
    vcWv.Cmd (fac,
              func(d,e,line) SendCmd (str + " " + convert (string, line));,
              str, str,
              vcWv.Param ("", vlStringRestOfLineVT, vcWv.Constant, ""));

for (; cmd_list != nil; cmd_list = cdr (cmd_list))
    build_cmd (car (cmd_list));






declare command_text;  /* make global so we don't have to get it everytime */

function echo_cmd(cmd, event)
{
    if (command_text == nil)
       command_text = GetCmdVtx();
    
    vcTxShell.TypeIn (command_text, cmd, TRUE, event);
}




function cmd(cmdname, abbrev, params) {
    function send_strings (args...) {
        declare str, st, e, a;

        st  = car (args); args = cdr (args);
        e   = car (args); args = cdr (args);
        for (str = abbrev; !null(args); args = cdr (args)) {
            a = car (args);
	    if (istype (a, non_null_stringVT)) a = convert (string, a);
            str = string_append (str, " ",
                                 (istype (a, string) ? (a) :
                number2string (a)));
        } /* for */


        /* insert the string into the viewtext buffer */
        echo_cmd(str, e);

    }
    vcCmd.Create (fac, send_strings, cmdname, abbrev, params);
}

function del_cmd(cmdname, abbrev, params) {
    function send_strings (args...) {
        declare str;

        str = string_append (abbrev, " -", caddr (args));
        echo_cmd(str, cadr (args));
    }
    vcCmd.Create(fac, send_strings, cmdname, cmdname , params);
}
function GetNodeSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(2);

    /* RSM - 10/25/91 Then check for selected nets in Veiwdraw */
    if(string_eq(str,""))
        str = GetItcSelect();

    /* then check X cut buffer */
/*    if (string_eq(str,""))
         str = vcWv.FetchCutBuffer(wv);
*/
    return(str);
}

function make_get_wdesign(ext) {
    func(sim_data) {
        design := vscript.getenv ("WDESIGN");
        if (design == nil)
            design = GetNetName();
        if (string_eq(design, "viewsim"))
            design = "test";
        if (design == nil)
            design = "test";
        design + ext;
    };
} /* function make_get_wdesign */


function GetVariableSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(2);

    if(string_eq(str,""))
        str = GetNavSelect(6);

    /* RSM - 10/25/91 Then check for selected nets in Veiwdraw */
    if(string_eq(str,""))
        str = GetItcSelect();

    /* then check X cut buffer */
/*    if (string_eq(str,""))
         str = vcWv.FetchCutBuffer(wv);
*/
    return(str);
}

function GetSourceSelection(vs) {
    str := GetNavSelect(5);

    if(string_eq(str,""))
        str = GetNavSelect(7);

    if(string_eq(str,""))
        str = GetNavSelect(4);

    return(str);
}

function GetProcessSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(5);

    if(string_eq(str,""))
        str = GetNavSelect(7);

    return(str);
}

function GetSubprogramSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(4);

    return(str);
}


function GetBreakSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(3);

    return(str);
}






function GetSelection(vs) {
    vcWv.FetchCutBuffer(wv);

}
s_run := 	cmd ("s_run", "run", nil);
s_sim := 	cmd ("s_sim", "sim", nil);
s_cycle := 	cmd ("s_cycle", "c", nil);

s_continue := 	cmd ("s_continue", "continue", nil);

s_stop := 	vcWv.Cmd(fac, NotifyStop);

s_restart := 	cmd ("s_restart", "restart", nil);
s_activate := 	vcWv.Cmd(fac, ActivateProc);


s_sstep := 	cmd ("sim step", "sim step", nil);
s_sphase := 	cmd ("sim phase", "sim phase", nil);
s_sprocess := 	cmd ("sim process", "sim process", nil);
s_sdelta := 	cmd ("sim delta", "sim delta", nil);
s_send := 	cmd ("sim end", "sim end", nil);
s_snext := 	cmd ("sim snext", "sim next", nil);
s_sover := 	cmd ("sim over", "sim over", nil);


s_bline := 	vcWv.Cmd(fac, BreakAtLine);

s_bsubp := 	vcWv.Cmd(fac, BreakAtSubp);
s_bsignal := 	vcWv.Cmd(fac, BreakAtSignal);
s_bprocess := 	vcWv.Cmd(fac, BreakAtProcess);
s_bdelete := 	vcWv.Cmd(fac, BreakDelete);
s_bshow :=  	vcWv.Cmd(fac, BreakShow);


s_d := 		cmd ("s_display", "d", 
           		list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetVariableSelection)));
vcCmd.EnableApply(s_d, vlOnOff.On);

s_d_sch := 		cmd ("s_display_sch", "sdisplay", 
           		list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));

vcCmd.EnableApply(s_d_sch, vlOnOff.On);

s_d_all := 	cmd ("s_display_all", "d *", nil);
s_d_all_sch := 	cmd ("s_display_all_sch", "sdisplay *", nil);



s_dsource := 		cmd ("s_dsource", "source ", 
			list(	vcWv.Param("arguments:" ,string, 
					vcWv.Dynamic, GetSourceSelection)));
vcCmd.EnableApply(s_dsource, vlOnOff.On);

s_devents := 	vcWv.Cmd(fac, DisplayEvents);
s_dactives := 	vcWv.Cmd(fac, DisplayActives);
s_display := 	cmd ("s_display_", "d", nil);
s_inputs := 	cmd ("s_inputs", "inputs", nil);
s_path := 	cmd ("s_path", "path",
    			list(	vcWv.Param("Nodes/Vectors:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_path, vlOnOff.On);

s_stats := 	cmd ("s_stats", "stats", nil);
s_info := 	cmd ("s_info", "info",
    			list(vcWv.Param("Nodes/Vectors:" ,string, 
				vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_info, vlOnOff.On);

s_stepsize := 	cmd ("s_stepsize", "stepsize", nil);
s_changes := 	cmd ("s_changes", "changes",
    			list(	vcWv.Param("From Time", string,  
					vcWv.Sticky, 0),
         			vcWv.Param("To Time",string,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_changes, vlOnOff.On);

s_time := 	cmd ("s_echo", "echo Simulation time = %time", nil);
s_defaults := 	cmd ("s_defaults", "defaults", nil);
s_report := 	cmd ("s_report", "report", nil);


s_l := 		cmd ("s_l", "l", 
			list(	vcWv.Param("Nodes:" ,string, 
					vcWv.Dynamic, GetVariableSelection)));
vcCmd.EnableApply(s_l, vlOnOff.On);


s_h := 		cmd ("s_h", "h", 
			list(	vcWv.Param("Nodes:" ,string, 
					vcWv.Dynamic, GetVariableSelection)));
vcCmd.EnableApply(s_h, vlOnOff.On);

s_x := 		cmd ("s_x", "x", 
			list(	vcWv.Param("Nodes:" ,string, 
					vcWv.Dynamic, GetVariableSelection)));
vcCmd.EnableApply(s_x, vlOnOff.On);


s_assign := 	cmd ("s_assign", "a",
    			list(	vcWv.Param("Node/Vector", string,  
					vcWv.Dynamic, GetVariableSelection),
         			vcWv.Param("Value",string,  vcWv.Sticky, "")));
vcCmd.EnableApply(s_assign, vlOnOff.On);

s_r := 		cmd ("s_r", "r",  
			list(	vcWv.Param("Nodes:" ,string, 
					vcWv.Dynamic, GetVariableSelection)));

vcCmd.EnableApply(s_r, vlOnOff.On);



s_oqueue := 	vcWv.Cmd(fac,DbgQueueHandler);
s_omonitor := 	vcWv.Cmd(fac,DbgRegsHandler);
nav_cmd := 	vcWv.Cmd(fac,DbgNavHandler);
s_oanalyzer := 	vcWv.Cmd(fac, DbgAnalyzerHandler);


s_wave := 	cmd("s_wave", "wave",
    			list(	vcWv.Param("Stream:" , non_null_stringVT, 
                                      vcWv.Dynamic, make_get_wdesign (".wfm")),
         			vcWv.Param("Nodes/Vectors:" ,string,
					 vcWv.Dynamic, GetVariableSelection)));



s_setwfm := 	cmd("s_setwfm", "wfm",
    			list(	vcWv.Param("Nodes/Vectors:" ,string,
					 vcWv.Dynamic, GetNodeSelection),
				vcWv.Param("Pattern:" ,string, 
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_setwfm, vlOnOff.On);


s_trace := 	cmd("s_trace", "trace",
    			list(	vcWv.Param("Node:" ,string, 
				vcWv.Dynamic, GetVariableSelection)));
vcCmd.EnableApply(s_trace, vlOnOff.On);

s_monitor := 	cmd("s_monitor", "monitor",
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetVariableSelection)));
vcCmd.EnableApply(s_monitor, vlOnOff.On);

s_monitor_sch := 	cmd("s_monitor_sch", "strace",
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_monitor_sch, vlOnOff.On);
/* Don't change the name s_net for the net command, is referenced
   in C routine */
s_mnunet :=  	cmd("s_net", "net",
    			list(	vcWv.Param("Filename:" ,string,  
					vcWv.Dynamic, make_get_wdesign (".vsm"),
					vcFilePop.fac, filter <- "*.vsm")));
vcCmd.EnableApply(s_mnunet, vlOnOff.On);

s_cmd := 	cmd ("s_cmd", "execute", 
    			list(	vcWv.Param("Filename:" ,string,  
					vcWv.Dynamic, make_get_wdesign(".cmd"),
					vcFilePop.fac, filter <- "*.cmd")));
vcCmd.EnableApply(s_cmd, vlOnOff.On);

s_log := 	cmd ("s_log", "execute",
    			list(	vcWv.Param("Filename:" ,string,  
					vcWv.Dynamic, make_get_wdesign(".log"),
					vcFilePop.fac, filter <- "*.log")));
vcCmd.EnableApply(s_log, vlOnOff.On);

s_type := 	cmd ("s_type", "type",
    			list(	vcWv.Param("Filename:" ,string,  
					vcWv.Sticky, "",
					vcFilePop.fac, filter <- "*.log")));
vcCmd.EnableApply(s_type, vlOnOff.On);

s_help := 	cmd ("s_help", "help", 
    			list(	vcWv.Param("Topic:" ,string,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_help, vlOnOff.On);


s_dtrace := 	del_cmd ("s_dtrace", "trace",
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetVariableSelection)));
vcCmd.EnableApply(s_dtrace, vlOnOff.On);

s_dtrace_all := cmd ("s_dtrace_all", "t -*", nil);


s_brkpnt := 	cmd ("s_brkpnt", "break",
    			list(	vcWv.Param("Nodes" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_brkpnt, vlOnOff.On);

s_brkpnt_all :=	cmd ("s_brkpnt_all", "break", nil);
s_set_brkpnt :=	cmd ("s_break", "break", 
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection),
				vcWv.Param("Circuit Event:" ,string,  
					vcWv.Sticky, "?"),
				vcWv.Param("Do Commands" ,string,  
					vcWv.Sticky, " do (print)")));

vcCmd.EnableApply(s_set_brkpnt, vlOnOff.On);

s_set_brkpnt_line :=	cmd ("s_break_line", "stop at ", 
    			list(   vcWv.Param("File Name:" ,string,  
					vcWv.Sticky, ""),
				vcWv.Param("Line Number" ,string,  
					vcWv.Sticky, "")));

vcCmd.EnableApply(s_set_brkpnt_line, vlOnOff.On);


s_set_brkpnt_process :=	cmd ("s_break_process", "stop in ", 
    			list(   vcWv.Param("Process Instance Name:" ,string,  
					vcWv.Dynamic, GetProcessSelection)));

vcCmd.EnableApply(s_set_brkpnt_process, vlOnOff.On);

s_set_brkpnt_subprogram :=	cmd ("s_break_subprogram", "stop in ", 
    			list(   vcWv.Param("Subprogram Name:" ,string,  
					vcWv.Dynamic, GetSubprogramSelection)));

vcCmd.EnableApply(s_set_brkpnt_subprogram, vlOnOff.On);


s_set_brkpnt_signal :=	cmd("s_break_signal", "break", 
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection),
				vcWv.Param("Circuit Event:" ,string,  
					vcWv.Sticky, "?")));


vcCmd.EnableApply(s_set_brkpnt_signal, vlOnOff.On);





s_delete_brkpnt :=	cmd("s_delete_brkpnt", "delete", 
    			list(	vcWv.Param("Breakpoint id:" ,string,  
					vcWv.Dynamic, GetBreakSelection)));


vcCmd.EnableApply(s_delete_brkpnt, vlOnOff.On);








s_ck := 	del_cmd ("s_ck", "clock",
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_ck, vlOnOff.On);


s_ck_all :=	cmd ("s_ck_all", "clock", nil);



s_reporttiming :=	cmd ("s_reporttiming", "report timing", nil);
s_report_timing := 	cmd ("s_report-timing", "report -timing", nil);

s_reportstability :=	cmd ("reportstability", "report stability", nil);
s_report_stability := 	cmd ("report-stability", "report -stability", nil);


s_reportspikes :=	cmd ("report spikes", "report spikes", nil);
s_report_spikes := 	cmd ("report -spikes", "report -spikes", nil);

s_reportall := 		cmd ("report spikes timing stability memerrs hwmx",
			"report spikes timing stability memerrs hwmx", nil);
s_report_all := 	cmd ("report -spikes -timing -stability -memerrs -hwmx",
			"report -spikes -timing -stability -memerrs -hwmx", nil);


s_defaultbignet :=	cmd ("defaults bignet", "defaults bignet", nil);
s_default_bignet := 	cmd ("defaults -bignet", "defaults -bignet", nil);


s_defaultcmdfile :=	cmd ("defaults cmdfile", "defaults cmdfile", nil);
s_default_cmdfile := 	cmd ("defaults -cmdfile", "defaults -cmdfile", nil);

s_defaultwatch :=	cmd ("defaults watch", "defaults watch", nil);
s_default_watch := 	cmd ("defaults -watch", "defaults -watch", nil);

s_defaulttime :=	cmd ("defaults time", "defaults time", nil);
s_default_time := 	cmd ("defaults -time", "defaults -time", nil);



s_mindelay :=		cmd ("s_mindelay", "delay min", nil);
s_maxdelay :=		cmd ("s_maxdelay", "delay max", nil);
s_typdelay :=		cmd ("s_typdelay", "delay typ", nil);
s_transportdelay :=	cmd ("s_transportdelay", "delay transport", nil);
s_inertialdelay :=	cmd ("s_inertialdelay", "delay inertial", nil);
s_fixedvaldelay :=	cmd ("s_fixedvaldelay", "delay", 
    			list(	vcWv.Param("Value:" ,string,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_fixedvaldelay, vlOnOff.On);

s_scaledelay :=		cmd ("delay scale", "delay scale", 
    			list(	vcWv.Param("Value:" ,string,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_scaledelay, vlOnOff.On);

s_delay := 		cmd ("s_delay", "delay", nil);

s_v := 		cmd ("s_vector", "vector",
    			list(	vcWv.Param("Vector name:" ,non_null_stringVT, 
					vcWv.Sticky, "XXX"),
         			vcWv.Param("Nodes/Vectors:" ,string,
					 vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_v, vlOnOff.On);

s_setpat := 	cmd ("s_setpattern", "pattern",
    			list(	vcWv.Param("Node/Vector:" ,string, 
					vcWv.Dynamic, GetNodeSelection),
         			vcWv.Param("Pattern sequence:" ,string,
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_setpat, vlOnOff.On);

s_clock := 	cmd ("s_clock", "clock",
    			list(	vcWv.Param("Node/Vector:" ,string, 
					vcWv.Dynamic, GetNodeSelection),
        			vcWv.Param("Transition sequence:" ,string,
					 vcWv.Sticky, "")));
vcCmd.EnableApply(s_clock, vlOnOff.On);

s_step := 	cmd ("s_step", "stepsize",
    			list(	vcWv.Param("Stepsize:" ,string, 
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_step, vlOnOff.On);

/* HACK!  need enum here; bin, hex, oct, dec */

s_radix := 	cmd ("s_radix", "radix", 
    			list(	
				vcWv.Param("Base[hex/dec/bin/oct]" ,string,
					 vcWv.Sticky, "hex"),

				vcWv.Param("Vector:" ,string, 
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_radix, vlOnOff.On);

s_w := 		cmd ("s_w", "w",
    			list(	vcWv.Param("Nodes/Vectors:" ,string,
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_w, vlOnOff.On);

s_t :=		cmd ("s_t", "t",
    			list(	vcWv.Param("Nodes/Vectors:" ,string,
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_t, vlOnOff.On);

s_print := 	cmd ("s_print", "print", nil);
s_act := 	cmd ("s_activity", "activity",
    			list(	vcWv.Param("Start time:" ,string, 
					vcWv.Dynamic, GetNodeSelection),
         			vcWv.Param("End time:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_act, vlOnOff.On);

s_logfile := 	cmd ("s_logfile", "logfile",
    			list(	vcWv.Param("Filename:" ,string, 
					vcWv.Sticky, "",  vcFilePop.fac, filter <- "*.log")));
vcCmd.EnableApply(s_logfile, vlOnOff.On);

s_watch := 	del_cmd ("s_watch", "watch",
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_watch, vlOnOff.On);

s_watch_all := 	cmd ("s_watch_all", "w -*", nil);
s_wfm := 	cmd ("s_wfm", "wfm",
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_wfm, vlOnOff.On);

s_wfm_all := 	cmd ("s_wfm_all", "wfm", nil);
s_pat := 	cmd ("s_pat", "pattern",
    			list(	vcWv.Param("Node:" ,string, 
					vcWv.Dynamic, GetNodeSelection)));
vcCmd.EnableApply(s_pat, vlOnOff.On);

s_pattern := 	cmd ("s_pattern", "pattern", nil);

function run_vansetup(s, event) {
    vcWv.RequireFac (wv, "vansetup");
    vcWin.Create (vcRegion.Create ("vsslib.ini", vansetup.fac, "vsslib.ini"));
} /* function run_vansetup */

s_vansetup := vcWv.Cmd (fac, run_vansetup, "run_vansetup");

function run_vananalyze(s, event) {
    vcWv.RequireFac (wv, "vansetup");
    vcCmd.Run (vansetup.analyze_without_setup_cmd, vcEvent.Window (event),
               event, nil, TRUE);
} /* function run_vananalyze */

s_vananalyze := vcWv.Cmd (fac, run_vananalyze, "run_vananalyze");

load("vsimmn.vs");
load("vsimbt.vs");

function vsEnableCmds(on_off) {
    vcCmd.Enable (s_monitor, on_off);
    vcCmd.Enable (s_oqueue, on_off);
    vcCmd.Enable (s_omonitor, on_off);
    vcCmd.Enable (nav_cmd, on_off);
    vcCmd.Enable (s_oanalyzer, on_off);

    vcCmd.Enable (s_sstep, on_off);
    vcCmd.Enable (s_sphase, on_off);
    vcCmd.Enable (s_sprocess, on_off);
    vcCmd.Enable (s_sdelta, on_off);
    vcCmd.Enable (s_send, on_off);
    vcCmd.Enable (s_snext, on_off);
    vcCmd.Enable (s_sover, on_off);
    vcCmd.Enable (s_bdelete, on_off);
    vcCmd.Enable (s_bshow, on_off);
    vcCmd.Enable (s_bline, on_off);
    vcCmd.Enable (s_bsubp, on_off);
    vcCmd.Enable (s_bsignal, on_off);
    vcCmd.Enable (s_bprocess, on_off);

}

function vsEnableCmdsDesignLoaded(on_off) {
 ;
}

function vsEnableCmdsSubsetVHDLLoaded(on_off) {
    vcCmd.Enable (s_sprocess, on_off);
    vcCmd.Enable (s_send, on_off);
    vcCmd.Enable (s_sover, on_off);

    vcCmd.Enable (s_bsubp, on_off);
    vcCmd.Enable (s_bprocess, on_off);
    vcCmd.Enable (s_set_brkpnt_process, on_off);
    vcCmd.Enable (s_set_brkpnt_subprogram, on_off);

    vcCmd.Enable (s_activate, on_off);
}

function vsEnableCmdsVantageLoaded(on_off) {
    if(on_off){
        vcCmd.Enable (s_mnunet, FALSE);

    }
}
function vsEnableCmdsSchematiclessLoaded(on_off) {
    if(on_off){
        vcCmd.Enable (s_sstep, FALSE);
        vcCmd.Enable (s_sphase, FALSE);
        vcCmd.Enable (s_sdelta, FALSE);

        vcCmd.Enable (s_v, FALSE);
        vcCmd.Enable (s_pattern, FALSE);
        vcCmd.Enable (s_path, FALSE);
        vcCmd.Enable (s_act, FALSE);
        vcCmd.Enable (s_changes, FALSE);
        vcCmd.Enable (s_watch, FALSE);
        vcCmd.Enable (s_clock, FALSE);
        vcCmd.Enable (s_inputs, FALSE);

        vcCmd.Enable (s_info, FALSE);
        vcCmd.Enable (s_watch_all, FALSE);
        vcCmd.Enable (s_r, FALSE);
        vcCmd.Enable (s_pat, FALSE);
        vcCmd.Enable (s_w, FALSE);
        vcCmd.Enable (s_display, FALSE);
        vcCmd.Enable (s_ck, FALSE);
        vcCmd.Enable (s_ck_all, FALSE);

        vcCmd.Enable (s_set_brkpnt_process, FALSE);
        vcCmd.Enable (s_set_brkpnt_subprogram, FALSE);
        vcCmd.Enable (s_setpat, FALSE);
        vcCmd.Enable (s_d_sch, FALSE);
        vcCmd.Enable (s_d_all_sch, FALSE);
        vcCmd.Enable (s_devents, FALSE);

                      
    }else{
        vcCmd.Enable (s_sstep, TRUE);
        vcCmd.Enable (s_sphase, TRUE);
        vcCmd.Enable (s_sdelta, TRUE);

        vcCmd.Enable (s_radix, TRUE);
        vcCmd.Enable (s_v, TRUE);
        vcCmd.Enable (s_pattern, TRUE);
        vcCmd.Enable (s_path, TRUE);
        vcCmd.Enable (s_act, TRUE);
        vcCmd.Enable (s_changes, TRUE);
        vcCmd.Enable (s_watch, TRUE);
        vcCmd.Enable (s_clock, TRUE);
        vcCmd.Enable (s_inputs, TRUE);

        vcCmd.Enable (s_info, TRUE);
        vcCmd.Enable (s_watch_all, TRUE);
        vcCmd.Enable (s_r, TRUE);
        vcCmd.Enable (s_wfm, TRUE);
        vcCmd.Enable (s_wfm_all, TRUE);
        vcCmd.Enable (s_pat, TRUE);
        vcCmd.Enable (s_w, TRUE);
        vcCmd.Enable (s_display, TRUE);
        vcCmd.Enable (s_ck, TRUE);
        vcCmd.Enable (s_ck_all, TRUE);

        vcCmd.Enable (s_setwfm, TRUE);
        vcCmd.Enable (s_setpat, TRUE);
        vcCmd.Enable (s_d_sch, TRUE);
        vcCmd.Enable (s_d_all_sch, TRUE);
        vcCmd.Enable (s_devents, TRUE);

    }
}



load ("vsimhelp.vs");
