/*
 * $Revision: 1.6 $
 */

package vspcaps (create_caps_tab, apply_changes) {

declare dv_txt_lab, std_txt_lab, dv_arc_lab, std_arc_lab;
declare dv_cir_lab, std_cir_lab, dv_box_lab, std_box_lab;

declare txt_ovly, arc_ovly, cir_ovly, box_ovly;

declare cur_txt_ovly, cur_arc_ovly, cur_cir_ovly, cur_box_ovly;

vspSTR_TEXT := "TEXT";
vspSTR_ARC := "ARC";
vspSTR_CIR := "CIRCLE";
vspSTR_BOX := "BOX";

vspSTR_STDTXT := "STD_TXT";
vspSTR_STDARC := "STD_ARC";
vspSTR_STDCIR := "STD_CIR";
vspSTR_STDBOX := "STD_BOX";
vspSTR_DEVTXT := "DEV_TXT";
vspSTR_DEVARC := "DEV_ARC";
vspSTR_DEVCIR := "DEV_CIR";
vspSTR_DEVBOX := "DEV_BOX";

DvTxtOvlyLab := "Device Text";
StdTxtOvlyLab := "Stroke Text";
DvArcOvlyLab := "Device Arc";
StdArcOvlyLab := "Stroke Arc";
DvCirOvlyLab := "Device Circle";
StdCirOvlyLab := "Stroke Circle";
DvBoxOvlyLab := "Device Box";
StdBoxOvlyLab := "Stroke Box";

function apply_changes () {

        if (txt_ovly != nil) {
                if (cur_txt_ovly == dv_txt_lab)
                        fac_pack.sp_sapopt (string_append(vspSTR_TEXT, " ", 
                                vspSTR_DEVTXT));
                else
                        fac_pack.sp_sapopt (string_append(vspSTR_TEXT, " ",
                                vspSTR_STDTXT));
        }

        if (arc_ovly != nil) {
                if (cur_arc_ovly == dv_arc_lab)
                        fac_pack.sp_sapopt (string_append(vspSTR_ARC, " ", 
                                vspSTR_DEVARC));
                else
                        fac_pack.sp_sapopt (string_append(vspSTR_ARC, " ",
                                vspSTR_STDARC));
        }

        if (cir_ovly != nil) {
                if (cur_cir_ovly == dv_cir_lab)
                        fac_pack.sp_sapopt (string_append(vspSTR_CIR, " ", 
                                vspSTR_DEVCIR));
                else
                        fac_pack.sp_sapopt (string_append(vspSTR_CIR, " ",
                                vspSTR_STDCIR));
        }

        if (box_ovly != nil) {
                if (cur_box_ovly == dv_box_lab)
                        fac_pack.sp_sapopt (string_append(vspSTR_BOX, " ", 
                                vspSTR_DEVBOX));
                else
                        fac_pack.sp_sapopt (string_append(vspSTR_BOX, " ",
                                vspSTR_STDBOX));
        }
}

function create_labels () {

        dv_txt_lab = vcLabel.ButtonCreate(string_append (DvTxtOvlyLab, 
               ".but"), DvTxtOvlyLab, func () switch_ovlys (`txt);,
                list (macro_on <- TRUE));

        std_txt_lab = vcLabel.ButtonCreate(string_append(StdTxtOvlyLab,
                ".but"), StdTxtOvlyLab, func () switch_ovlys (`txt);,
                list (macro_on <- TRUE));

        dv_arc_lab = vcLabel.ButtonCreate(string_append (DvArcOvlyLab, 
                ".but"), DvArcOvlyLab, func () switch_ovlys (`arc);,
                list (macro_on <- TRUE));
        std_arc_lab = vcLabel.ButtonCreate(string_append(StdArcOvlyLab,
                ".but"), StdArcOvlyLab, func () switch_ovlys (`arc);,
                list (macro_on <- TRUE));
 
        dv_cir_lab = vcLabel.ButtonCreate(string_append (DvCirOvlyLab, 
                ".but"), DvCirOvlyLab, func () switch_ovlys (`cir);,
                list (macro_on <- TRUE));
        std_cir_lab = vcLabel.ButtonCreate(string_append(StdCirOvlyLab,
                ".but"), StdCirOvlyLab, func () switch_ovlys (`cir);,
                list (macro_on <- TRUE));

        dv_box_lab = vcLabel.ButtonCreate(string_append (DvBoxOvlyLab, 
                ".but"), DvBoxOvlyLab, func () switch_ovlys (`box);,
                list (macro_on <- TRUE));
        std_box_lab = vcLabel.ButtonCreate(string_append(StdBoxOvlyLab,
                ".but"), StdBoxOvlyLab, func () switch_ovlys (`box);,
                list (macro_on <- TRUE));
}

function setup_defaults () {

        cur_txt_ovly = (fac_pack.get_dev_txt ()) ? dv_txt_lab : std_txt_lab;
        cur_arc_ovly = (fac_pack.get_dev_arc ()) ? dv_arc_lab : std_arc_lab;
        cur_cir_ovly = (fac_pack.get_dev_cir ()) ? dv_cir_lab : std_cir_lab;
        cur_box_ovly = (fac_pack.get_dev_box ()) ? dv_box_lab : std_box_lab;
}

function switch_ovlys (which) {
        if (which == `txt) {
                cur_txt_ovly = (cur_txt_ovly == dv_txt_lab) ? 
                        std_txt_lab : dv_txt_lab;
                vcOverlay.SetCurrent (txt_ovly, cur_txt_ovly);
        }
        else if (which == `arc) {
                cur_arc_ovly = (cur_arc_ovly == dv_arc_lab) ? 
                        std_arc_lab : dv_arc_lab;
                vcOverlay.SetCurrent (arc_ovly, cur_arc_ovly);
        }
        else if (which == `cir) {
                cur_cir_ovly = (cur_cir_ovly == dv_cir_lab) ? std_cir_lab :
                        dv_cir_lab;
                vcOverlay.SetCurrent (cir_ovly, cur_cir_ovly);
        }
        else if (which == `box) {
                cur_box_ovly = (cur_box_ovly == dv_box_lab) ? std_box_lab :
                        dv_box_lab;
                vcOverlay.SetCurrent (box_ovly, cur_box_ovly);
        }
        set_graphics_modified ();
}

function create_toggles () {

        declare tlst;

        ttab := vcTable.Create ("caps.tab", 4, 1);

        tlst = create_toggle ("Text Cap", dv_txt_lab, std_txt_lab,
                cur_txt_ovly);
        txt_ovly = car (tlst);
        vcTable.Add (ttab, cadr(tlst));

        tlst = create_toggle ("Arc Cap", dv_arc_lab, std_arc_lab,
                cur_arc_ovly);
        arc_ovly = car (tlst);
        vcTable.Add (ttab, cadr(tlst));

        tlst = create_toggle ("Cir Cap", dv_cir_lab, std_cir_lab,
                cur_cir_ovly);
        cir_ovly = car (tlst);
        vcTable.Add (ttab, cadr(tlst));

        tlst = create_toggle ("Box Cap", dv_box_lab, std_box_lab,
                cur_box_ovly);
        box_ovly = car (tlst);
        vcTable.Add (ttab, cadr(tlst));

        if (!fac_pack.cap_applicable (vspSTR_TEXT))
                vcRegion.Enable (txt_ovly, FALSE, TRUE);

        if (!fac_pack.cap_applicable (vspSTR_ARC))
                vcRegion.Enable (arc_ovly, FALSE, TRUE);

        if (!fac_pack.cap_applicable (vspSTR_CIR))
                vcRegion.Enable (cir_ovly, FALSE, TRUE);

        if (!fac_pack.cap_applicable (vspSTR_BOX))
                vcRegion.Enable (box_ovly, FALSE, TRUE);

        return (ttab);
}
                
function create_caps_tab () {

        create_labels ();
        setup_defaults ();
        return (create_toggles ());

}
}

