/* ------------------------------------------------------------------------ *\
 * viewtrace menu hints
 *
 * <<<<Prerequisites>>>>
 * <<<<Command Definitions>>>>
 * <<<<Command-Line Bindings>>>>
 * <<<<Key Bindings>>>>
 * <<<<Menus>>>>
\* ------------------------------------------------------------------------ */

/* File sub-menu commands */
vcCmd.SetHelp(FileOpenCmd,
              "Open another Viewtrace window");
vcCmd.SetHelp(FileReadCmd,
              "Read an additional file into the window");
vcCmd.SetHelp(FileReadStreamCmd,
              "Read a file into the window in interactive mode");
vcCmd.SetHelp(FileUpdateCmd,
              "Update the contents of the window from the disk file (interactive mode)");
vcCmd.SetHelp(FileNUpdateCmd,
              "Set a timer to periodically update the window from the disk file (interactive mode)");
vcCmd.SetHelp(FileCancelUpdateCmd,
              "Cancel the update timer (interactive mode)");
vcCmd.SetHelp(FileWriteCmd,
              "Save the current waveforms in the existing file");
vcCmd.SetHelp(FileWriteToCmd,
              "Save the current waveforms in a different file");
vcCmd.SetHelp(FileRereadCfgCmd,
              "Reread the viewtrac.cfg file and update display parameters");

/* Zoom sub-menu commands */
vcCmd.SetHelp(ViewFullCmd,
              "Zoom to the full data for that region");
vcCmd.SetHelp(ViewZoomMenuCmd,
              "Zoom into a specified area");
vcCmd.SetHelp(ViewPanMenuCmd,
              "Center the window at the current mouse cursor location");
vcCmd.SetHelp(ViewScrollMenuCmd,
              "Move the mouse cursor location to the center of the window");
vcCmd.SetHelp(ViewRangeCmd,
              "Zoom to a specified range for selected axes");
vcCmd.SetHelp(ViewInCmd,
              "Zoom in at the center of the window");
/*vcCmd.SetHelp(ViewInFactorCmd,
               "Zoom in at the center of the window");*/
vcCmd.SetHelp(ViewOutCmd,
              "Zoom out from the center of the window");
/*vcCmd.SetHelp(ViewOutFactorCmd,
               "Zoom out from the center of the window");*/
vcCmd.SetHelp(ViewRefreshCmd,
              "Redisplay the Viewtrace window");
vcCmd.SetHelp(ViewSaveCmd,
              "Save the view configuration in a file");
vcCmd.SetHelp(ViewRestoreCmd,
              "Restore the view configuration from a file");

/* Edit sub-menu commands */
vcCmd.SetHelp(EditDeleteCmd,
              "Delete the selected waveform region");
/* "Delete the selected digital waveform region");*/
vcCmd.SetHelp(EditCutCmd,
              "Cut the selected waveform region into the buffer");
/* "Cut the selected digital waveform region into the buffer");*/
vcCmd.SetHelp(EditCopyCmd,
              "Copy the selected waveform region into the buffer");
/* "Copy the selected digital waveform region into the buffer");*/
vcCmd.SetHelp(EditPasteCmd,
              "Insert the waveform buffer at a point to be specified");
/* "Paste the digital waveform buffer to the seleted region");*/
vcCmd.SetHelp(EditSubstCmd,
"Replace existing waveforms for waveform buffer at a point to be specified");

/* "Replace Substitute the digital waveform buffer for the selected region");*/
vcCmd.SetHelp(EditRepeatCmd,
              "Repeat the selected waveform region");
vcCmd.SetHelp(EditCreateSignalCmd,
              "Create a new digital signal");
vcCmd.SetHelp(EditInsertTimeCmd,
              "Insert time equal to the specified waveform region");
vcCmd.SetHelp(EditClearCmd,
              "Clear transitions from the specified waveform region");
vcCmd.SetHelp(EditSetValueCmd,
              "Set the selected waveform region to a value");
vcCmd.SetHelp(EditReplaceCmd,
  "Replace values of transitions at the left of selected waveform region");
/*Overwrite the selected digital waveform region");*/
vcCmd.SetHelp(EditTimeLimitCmd,
              "Truncate (or expand) the time range of the waveform data");
vcCmd.SetHelp(EditTimeStepCmd,
              "Set the axis tick size to the desired value");

/* Change sub-menu commands */
vcCmd.SetHelp(ChangeSignalColorCmd,
              "Change the color of the selected signals");
vcCmd.SetHelp(ChangeSignalSymbolCmd,
              "Change the symbol for the selected signals");
vcCmd.SetHelp(ChangeSignalNameCmd,
              "Change the name of the selected signal");
vcCmd.SetHelp(ChangeSignalRadixCmd,
              "Change the radix of the selected digital signals");
vcCmd.SetHelp(ChangeAxisTypeCmd,
              "Change the type of the selected axes");
vcCmd.SetHelp(ChangeAxisNotationCmd,
              "Change the numeric notation for the selected axis(axes)");
vcCmd.SetHelp(ChangeAxisLabelCmd,
              "Change the label of the selected axis");
vcCmd.SetHelp(ChangeAxisGridCmd,
              "Turn the grid on or off for the selected axis(axes)");
vcCmd.SetHelp(ChangeAxisGridSpaceCmd,
              "Change the spacing of the grid");
vcCmd.SetHelp(ChangeAxisSideCmd,
    "Move the selected axis to the left or right of the waveforms region");
vcCmd.SetHelp(ChangeAxisSymbolsCmd,
              "Turn the axis symbols on or off");
vcCmd.SetHelp(ChangeValuesNotationCmd,
              "Change the numeric notation for the values region");
vcCmd.SetHelp(ChangeValuesNumDigitsCmd,
   "Change the number of significant digits for numbers in the values region");
vcCmd.SetHelp(ChangeDisplayWidthsNamesCmd,
              "Change the width of the signal names region");
vcCmd.SetHelp(ChangeDisplayWidthsValuesCmd,
              "Change the width of the values region");
vcCmd.SetHelp(ChangeDisplayWidthsVAxisCmd,
              "Change the width of the selected vertical axes");
vcCmd.SetHelp(ChangeDisplayWidthsHAxisCmd,
              "Change the width of the selected horizontal axes");
vcCmd.SetHelp(ChangeDisplayRegionBoundaryCmd,
              "Change the placement of the region boundary");
vcCmd.SetHelp(ChangeDisplayInfoCmd,
              "Turn the measurement info box on or off");
vcCmd.SetHelp(ChangeDisplayValuesCmd,
              "Turn the values region on or off");
vcCmd.SetHelp(ChangeDisplayMarkersCmd,
              "Turn the measurement markers on or off");
vcCmd.SetHelp(ChangeDisplaySymbolsCmd,
              "Turn the signal symbols on or off");
vcCmd.SetHelp(ChangeDisplayNSymbolsCmd,
              "Set the number of symbols displayed per signal");
vcCmd.SetHelp(ChangeDisplayLinesCmd,
              "Turn the signal lines on or off");
vcCmd.SetHelp(ChangeTextCreateCmd,
              "Create an annotation text string");
vcCmd.SetHelp(ChangeTextMoveMenuCmd,
              "Move the selected text string(s)");
vcCmd.SetHelp(ChangeTextMoveCmd,
              "Move the selected text string(s)");
vcCmd.SetHelp(ChangeTextDeleteCmd,
              "Delete the selected text strings(s)");
vcCmd.SetHelp(ChangeTextStringCmd,
              "Edit the selected annotation text string");
vcCmd.SetHelp(ChangeTextColorCmd,
              "Change the color of the selected annotation text");
vcCmd.SetHelp(ChangeTextOriginCmd,
              "Change the text origin of the selected annotation text");
vcCmd.SetHelp(ChangeTextSizeCmd,
              "Change the size of the selected text");
vcCmd.SetHelp(ChangeSnapModeCmd,
              "Change the cursor snap mode");
vcCmd.SetHelp(ChangeAnnotationCmd,
              "Turn values annotation to VIEWdraw on or off");

/* Select sub-menu commands */
vcCmd.SetHelp(SelectSignalCmd,
              "Select the specified signals");
vcCmd.SetHelp(SelectTextCmd,
              "Select the specified annotation text");
vcCmd.SetHelp(UnSelectSignalCmd,
              "Unselect the specified signals");
vcCmd.SetHelp(UnSelectTextCmd,
              "Unselect the specified annotation text");

/* Signal sub-menu commands */
vcCmd.SetHelp(SignalShowCmd,
              "Display the specified hidden signals");
vcCmd.SetHelp(SignalShowMenuCmd,
              "Display the specified hidden signals");
vcCmd.SetHelp(SignalHideCmd,
              "Hide the specified signals from the display");
vcCmd.SetHelp(FromSchematicCmd,
              "Select, Show, or Create signals from the Viewdraw schematic");
vcCmd.SetHelp(SignalDeleteCmd,
"Delete the specified signals from memory. `hide' removes from display only");
vcCmd.SetHelp(HomeCmd,
              "Scroll the signals to the top of the display");
vcCmd.SetHelp(PgUpCmd,
              "Scroll the signals up one page");
vcCmd.SetHelp(UpCmd,
              "Scroll the signals up one line");
vcCmd.SetHelp(DownCmd,
              "Scroll the signals down one line");
vcCmd.SetHelp(PgDnCmd,
              "Scroll the signals down one page");
vcCmd.SetHelp(EndCmd,
              "Scroll the signals to the bottom of the display");
vcCmd.SetHelp(SignalToAxisCmd,
              "Add the selected signals to the selected axis");
vcCmd.SetHelp(SignalFromAxisCmd,
              "Remove the selected signals from the selected axis");
vcCmd.SetHelp(SignalChangeAxisCmd,
              "Move the selected signals to the selected axis");
vcCmd.SetHelp(SignalMathCmd,
              "Perform calculations on signals");
vcCmd.SetHelp(SignalLogicCmd,
              "Perform Boolean operations on signals");
vcCmd.SetHelp(SignalCopyCmd,
              "Copy a digital signal");
vcCmd.SetHelp(SignalInvertCmd,
              "Invert a digital signal");
vcCmd.SetHelp(SignalBusCmd,
              "Create a bus from the selected signals");
vcCmd.SetHelp(SignalExpandCmd,
              "Expand a bus into its component signals");
vcCmd.SetHelp(SignalTShiftCmd,
              "Shift a signal by the desired amount");
vcCmd.SetHelp(SignalTScaleCmd,
              "Scale a signal by the desired amount");
vcCmd.SetHelp(SignalFFTCmd,
              "Perform a fast Fourier transform on a signal");
vcCmd.SetHelp(SignalMergeCmd,
"Combine analog data from multiple simulations (useful after `read').");

/* Axis sub-menu commands */
vcCmd.SetHelp(AxisAddCmd,
              "Create a new axis with the selected signals");
vcCmd.SetHelp(AxisSplitCmd,
 "Split selected axis into two, moving the selected signals to the new axis");
vcCmd.SetHelp(AxisJoinCmd,
              "Combine selected axes into one");
vcCmd.SetHelp(AxisXVariableCmd,
    "Make the specified signal the x axis variable (display parameter)");
vcCmd.SetHelp(AxisXVariableMenuCmd,
    "Make the specified signal the x axis variable (display parameter)");
vcCmd.SetHelp(AxisRemoveCmd,
              "Remove the selected axis and associated views of signals");

/* Unimplemented commmands */
vcCmd.SetHelp(ToBeImplementedCmd,
              "Command not yet implemented");

/* Pop-up commands not found in menus */
vcCmd.SetHelp(UnSelectAllCmd,
              "Unselect all signals and axes");
