/*
 *  $Revision: 1.8.4.1 $
 *
 *  vcTable facility.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */


/*
 * When adjusting borders, mouse movement and letting up the left mouse
 * button should interrupt the redisplay of the affected items in the
 * table.  Otherwise, we get too far behind in the refreshing and things
 * look too jittery.
 */
vcFac.AddInterrupt (fac, '\leftup');
vcFac.AddInterrupt (fac, '\move');

ALL := -1;
All := -1;

function Make(args...) {
    title := car (args);        args = cdr (args);
    if (!istype (title, vlStringVT)) {
        n_rows := title;
        title = nil;
    }
    else {
        n_rows := car (args);       args = cdr (args);
    }
    n_cols := car (args);       args = cdr (args);
    t := vcTable.Create (((title == nil) ? sprintf ("%d:%d", n_rows, n_cols) :
                          title),
                         n_rows, n_cols);
    declare r, c;
    for (r = 0; (r < n_rows) && (args != nil); ++r)
        for (c = 0; (c < n_cols) && (args != nil); ++c) {
            vcTable.Add (t, car (args));
            args = cdr (args);
        }
    t;
}
