/*
 *  $Revision: 1.9.8.1 $
 *
 *  Viewscript UI definitions for the Core vcKanji facility.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

vkeys := list ("Menu",     "Scrn",        "Cnv",         "Hira_Cnv",
               "Kata_Cnv", "Zen_Cnv",     "Han_Cnv",     "No_Cnv",
               "Code",     "Space",       "Kana_Lock",   "Cnv_Nblk",
               "Right",    "Left",        "Bs",          "Del",
               "Rom",      "Hira",        "Kata",        "Zen",
               "Han",      "Open",        "Uopen",       "Code_Cnt",
               "Llim",     "Rlim",        "Cancel",      "No_Cnv2",
               "Ctrl",     "Chr",         "Close",       "Knj",
               "Uclose",   "Canall",      "Eisuu",       "Undo",
               "Dmode",    "Caps_On",     "Caps_Off",    "Touroku",
               "Sakujyo",  "Mode",        "Rev_Space",   "Mb_Sel",
               "Lb_Sel",   "Cnv_Bblk",    "Cnv_Bkoho",   "Cnv_Nkoho",
               "Cnv_Bunl", "Cnv_Buns",    "Cnv_Bcnv");

function mapcar(fun, list)
    if (list)
        cons (fun (car (list)), mapcar (fun, cdr (list)));
    else
        nil;

    
function string_2_process_function(str)
    vcWv.Cmd (fac,
              func (k, e)
                  process (k, e, str);,
              str, TRUE);
                  

vkey_entries := mapcar (func (str)
                            list (str, string_2_process_function (str));,
                        vkeys);

function make_menu(entries)
    apply (vcWv.MakeMenu, entries);

vcFac.SetMenus (fac, make_menu (cons ("kanji", vkey_entries)));

chr_cmd := vcWv.Cmd (fac, chr, "chr", TRUE);

foreach (c; vcWv.Printable ())
    vcBind.Set (bindings, c, chr_cmd);
