;;;;
;;;;  $Revision: 1.9.2.3 $    $Date: 1995/04/24 00:22:28 $
;;;;
;;;;  Test class definitions for VDM regression testing.
;;;;
;;;;  Copyright (c) 1994,1995, by Viewlogic Systems, Inc.
;;;;



(vdm|ClassFileSetVersion class_file 1.0)



;;;
;;; pipe_emacs
;;;
;;; Attempts to execute the "emacsclient" and load the given object into an
;;; already running Emacs server.
;;;
(define (pipe_emacs obj out_proc err_proc exit_proc)
  (let* ((name (vdm|ObjGetPhysicalName obj))
         (cmd (+ "emacsclient " name)))
    (vcSys|Command cmd nil out_proc err_proc exit_proc nil)))



;;;
;;; Define a class for any file that can be edited by sending client request
;;; to an already running Emacs server.  To start the Emacs server, type
;;; M-x server-start in the Emacs process.
;;;
(define AnyFileClass (vdm|ClassCreate "vdmAnyFileClass" class_file
                          `(AttrList     . ("NAME"))
                          `(AttrFilter   . (".*"))
                          `(Editor       . ,pipe_emacs)
                          `(PhysicalTemplate . "$NAME")
                          `(Type         . ,vdmClassType|File)))



(define YoMama (vdm|ClassCreate "YoMama" class_file
                    `(AttrList          . ("ENTITY"))
                    `(AttrFilter        . (".*"))
                    `(Editor            . ,pipe_emacs)
                    `(NameTemplate      . "$ENTITY")
                    `(LogicalToPhysical . ,(lambda (obj class) "foo_e.vhd"))
                    `(PhysicalToLogical . ,(lambda (class str)
                                             '((ENTITY . "foo"))))
                    `(PhysicalTemplate  . "$ENTITY.vhd")
                    `(Type              . ,vdmClassType|File)))

(vdm|ClassSetRelation AnyFileClass "TestRelation"
     vdm|RelType|Association
     vdm|RelFan|OneToN)
(vdm|ClassAddRelative AnyFileClass "TestRelation" YoMama)
