/*
 * $Revision: 1.13.1.1 $
 *
 * Help texts for viewflow commands 
 */

edit_mode_msg := "Not in edit mode.";
edit_mode_addon := " (or not in edit mode).";
no_flow_msg := "No flow loaded.";

vcCmd.SetHelp (AddTaskCmd, "Add a new task object to the flow.");
vcCmd.SetDisabledMsg (AddTaskCmd, edit_mode_msg);
vcCmd.SetHelp (AddDataCmd, "Add a new task object to the flow.");
vcCmd.SetDisabledMsg (AddDataCmd, edit_mode_msg);
vcCmd.SetHelp (ModifySlctCmd, "Modify the selected object.");
vcCmd.SetDisabledMsg (ModifySlctCmd, 
           "Data, task or dependency not selected" + 
                                            edit_mode_addon);
vcCmd.SetHelp (CopySlctCmd, "Copy the selected object.");
vcCmd.SetDisabledMsg (CopySlctCmd, "Data or task not selected" + 
                                            edit_mode_addon);
vcCmd.SetHelp (DeleteSlctCmd, "Delete the selected object.");
vcCmd.SetDisabledMsg (DeleteSlctCmd, "Object not selected" + 
                                            edit_mode_addon);
vcCmd.SetHelp (ModifyIdCmd, "Modify the object with the given id.");
vcCmd.SetDisabledMsg (ModifyIdCmd, edit_mode_msg);
vcCmd.SetHelp (DeleteIdCmd, "Delete the object with the given id.");
vcCmd.SetDisabledMsg (DeleteIdCmd, edit_mode_msg);
vcCmd.SetHelp (ModifyCmd, "Modify the object with the given name.");
vcCmd.SetDisabledMsg (ModifyCmd, edit_mode_msg);
vcCmd.SetHelp (DeleteCmd, "Delete the object with the given name.");
vcCmd.SetDisabledMsg (DeleteCmd, edit_mode_msg);
vcCmd.SetHelp (FindIdCmd, "Find the object with the given id.");
vcCmd.SetDisabledMsg (FindIdCmd, no_flow_msg);
vcCmd.SetHelp (FindCmd, "Find the object with the given name.");
vcCmd.SetDisabledMsg (FindCmd, no_flow_msg);
vcCmd.SetHelp (EditSlctCmd, "Edit the selected data object.");
vcCmd.SetDisabledMsg (EditSlctCmd, "Data or subflow not selected.");
vcCmd.SetHelp (EditIdCmd, "Edit the data object with the given id.");
vcCmd.SetDisabledMsg (EditIdCmd, no_flow_msg);
vcCmd.SetHelp (EditCmd, "Edit the data object with the given name.");
vcCmd.SetDisabledMsg (EditCmd, no_flow_msg);
vcCmd.SetHelp (ManageSlctCmd, "Manage the selected data object.");
vcCmd.SetDisabledMsg (ManageSlctCmd, "Data object not selected.");
vcCmd.SetHelp (ManageIdCmd, "Manage the data object with the given id.");
vcCmd.SetDisabledMsg (ManageIdCmd, no_flow_msg);
vcCmd.SetHelp (ManageCmd, "Manage the data object with the given name.");
vcCmd.SetDisabledMsg (ManageCmd, no_flow_msg);
vcCmd.SetHelp (UpdateSlctCmd, "Update the selected task object.");
vcCmd.SetDisabledMsg (UpdateSlctCmd, "Task object not selected.");
vcCmd.SetHelp (UpdateIdCmd, "Update the task object with the given id.");
vcCmd.SetDisabledMsg (UpdateIdCmd, no_flow_msg);
vcCmd.SetHelp (UpdateCmd, "Update the task object with the given name.");
vcCmd.SetDisabledMsg (UpdateCmd, no_flow_msg);
vcCmd.SetHelp (ResetSlctCmd, "Reset the selected task/data object.");
vcCmd.SetDisabledMsg (ResetSlctCmd, "Task or data object not selected.");
vcCmd.SetHelp (ResetIdCmd, "Reset the task/data object with the given id.");
vcCmd.SetDisabledMsg (ResetIdCmd, no_flow_msg);
vcCmd.SetHelp (ResetCmd, "Reset the task/data object with the given name.");
vcCmd.SetDisabledMsg (ResetCmd, no_flow_msg);

vcCmd.SetHelp (AddLineCmd, "Begin drawing a dependency.");
vcCmd.SetDisabledMsg (AddLineCmd, edit_mode_msg);
vcCmd.SetHelp (DepModeCmd, "Enter/leave continuous dependency drawing mode.");
vcCmd.SetDisabledMsg (DepModeCmd, edit_mode_msg);
vcCmd.SetHelp (AttachFromCmd, "Attach a dependency from the selected object.");
vcCmd.SetDisabledMsg (AttachFromCmd, "Object not selected" + edit_mode_addon);
vcCmd.SetHelp (AttachToCmd, "Attach a dependency to the selected object.");
vcCmd.SetDisabledMsg (AttachToCmd, "Object not selected" + edit_mode_addon);
vcCmd.SetHelp (StretchCmd, "Stretch a dependency.");
vcCmd.SetDisabledMsg (StretchCmd, edit_mode_msg);
vcCmd.SetHelp (CurvedDependCmd, "Toggle between straight " + 
                                    "and curved dependencies.");
vcCmd.SetHelp (OverviewCmd, "See overview of entire flow in separate window.");
vcCmd.SetDisabledMsg (OverviewCmd, no_flow_msg);
vcCmd.SetHelp (GlobalSymbolCmd, "Edit global symbols.");
vcCmd.SetDisabledMsg (GlobalSymbolCmd, no_flow_msg);
vcCmd.SetHelp (LogWindowCmd, "See the task log window.");
vcCmd.SetDisabledMsg (LogWindowCmd, "No log window is available.");
vcCmd.SetHelp (ViewdataCmd, "Use ViewData to perform data management.");

vcCmd.SetHelp (RunSlctCmd, "Run the selected task.");
vcCmd.SetDisabledMsg (RunSlctCmd, "Task object not selected.");
vcCmd.SetHelp (UpdateAllCmd, "Update all tasks in the flow.");
vcCmd.SetDisabledMsg (UpdateAllCmd, no_flow_msg);
vcCmd.SetHelp (ResetAllCmd, "Reset the entire flow.");
vcCmd.SetDisabledMsg (ResetAllCmd, no_flow_msg);
vcCmd.SetHelp (MakeCmd, "Make the flow.");
vcCmd.SetDisabledMsg (MakeCmd, "Make in progress, or no flow loaded.");
vcCmd.SetHelp (CancelMakeCmd, "Cancel a make in progress.");
vcCmd.SetDisabledMsg (CancelMakeCmd, "Make not currently in progress.");
vcCmd.SetHelp (CheckCmd, "Check the flow for errors.");
vcCmd.SetDisabledMsg (CheckCmd, edit_mode_msg);

vcCmd.SetHelp (FlowListCmd, "Examine/modify list of flows.");
vcCmd.SetDisabledMsg (FlowListCmd, no_flow_msg);

/* buttons in the flow-list dialog */
vcCmd.SetHelp (SwitchFlowCmd, "Switch to this flow.");
vcCmd.SetHelp (SwitchFlowByeWindowCmd, "Switch to this flow.");
vcCmd.SetHelp (OverviewFlowCmd, "See overview of this flow.");
vcCmd.SetHelp (SwitchmodeFlowCmd, "Change the mode of this flow.");
vcCmd.SetHelp (RemoveFlowCmd, "Remove this flow from the list.");
vcCmd.SetHelp (SaveFlowCmd, "Save this flow.");
vcCmd.SetHelp (SaveAllCmd, "Save all flows.");
vcCmd.SetHelp (ManageFlowCmd, "Perform data management on the flow object.");

/* typein commands corresponding to flow-list dialog commands */
vcCmd.SetHelp (SwitchCmd, "Switch to a different flow.");
vcCmd.SetHelp (ViewCmd, "View a flow.");
vcCmd.SetHelp (ModeCmd, "Change the mode of a flow.");
vcCmd.SetHelp (RemoveCmd, "Remove a command from flow list.");

/* stuff for the global symbols dialog box */
vcCmd.SetHelp (SetGlSymCmd, "Set the global symbols.");


