/* Compose Function for Pcb Dictionary Collection.
 * 
 * A compose function creates objects that go into a collection and returns
 * them in a list.
 */
function PcbDictColComposeFunc(cntx, obj) {
    /* get some data that is always useful */
    design := vdm.ObjGetName(obj);
    location := vdm.ObjGetLocation(obj);

    net_dict_class := vdm.CntxFindClass(cntx, "NetDictionary");
    fnc_dict_class := vdm.CntxFindClass(cntx, "FunctionDictionary");

    /* create the objects */
    net_dict := vdm.ObjCreate(design, 
                             vdm.VersLatest, net_dict_class, 
                             location, cntx, list(cons(`NAME, design)));

    fnc_dict := vdm.ObjCreate(design, 
                              vdm.VersLatest, fnc_dict_class, 
                              location, cntx, list(cons(`NAME, design)));

    list(net_dict, fnc_dict);
}

