
vdm.ClassFileSetVersion (class_file, 1.0);
vdm.ClassCreate ("Yam", class_file,
           AttrList <- list ("SPAM", "EGGS", "BACON", "SAUSAGE", "MOLLUSCS"),
           AttrFilter <- list ("Y[A-Z]+", ".*", ".*", ".*", ".*"),
           PhysicalTemplate <- list ("$NAM.yam.$EGGS.$BACON.$SAUSAGE.$MOLLUSCS"),
           Type <- vdmClassType.File);

vdm.ClassCreate ("Spam", class_file,
           AttrList <- list ("NAM", "NUM"),
           AttrFilter <- list ("[A-Za-z]+", "[1-9]"),
           PhysicalTemplate <- list ("$NAM.spam.$NUM"),
           Type <- vdmClassType.File);

function edit_vflFlow(obj, output, error, exit) {
    /* first look for a vflow region in our executable */
    declare vflow_rgn;
    if (isbound (`vflow, nil))
        foreach (w; vcWin.Loop ())
            if (vflow_rgn == nil)
                vflow_rgn = vcRegion.FindFac (vcWin.OwnerRegion (w), 
                                              vflow.fac);

    if (vflow_rgn == nil)
        vcSys.Command ("viewflow -mode edit " + vdm.ObjGetName (obj),
                        nil, output, error, exit, nil);
    else {
        /* this part here assumes that the vflow facility is defined */
        catch (vlEx.FAILURE) {
            ev := vcEvent.Create (0, 0, ' ', nil, 
                        vcRegion.Window (vflow_rgn), vflow_rgn, nil);
            vcCmd.Run (vflow.OpenCmd, vcRegion.GetData (vflow_rgn),
                          ev, list (vdm.ObjGetName (obj),
                     vpm.LocationGetAlias (vdm.ObjGetLocation (obj)), 
                                 vflowMode.Edit), FALSE);
            exit (vcSysMode.Exited, 0);
        } exception {
            vlErr.Out (nil, vlErr.CurrentError ());
            exit (vcSysMode.Signalled, 0);
        }
    }
}
                         
vdm.ClassCreate ("vflFlow", class_file,
           AttrList <- list ("NAME"),
           AttrFilter <- list (".*"),
           PhysicalTemplate <- "$NAME.vfl",
           Type <- vdmClassType.File,
           Editor <- edit_vflFlow);

