declare   vdes2_win;
declare   fac;
declare   region;
sec_code := "vhdldes";

declare vdestmp_file;
declare sec_file;
declare ssec_file;
declare pins_file;
declare spins_file;
declare pack_file;
declare spack_file;
declare cons_file;
declare scons_file;
declare primary_path;
declare vdraw_path;
declare vdraw_alias;
declare writable_alias;

new_number := 1;
function get_new_number() {

    new_number = new_number + 1;
    return( new_number );
}

function unique_filename ( path ) {
 
    declare str, filename, temp_file, fp; 

    str =convert( string,  get_new_number());
    filename = "vdes" + str;
    temp_file = vscript.vsMerge( "", path, filename, "tmp");
    while( fexists( temp_file)) {
         str =convert( string,  get_new_number());
         filename = "vdes" + str;
         temp_file = vscript.vsMerge( "", path, filename, "tmp");
    }
    fp = fopen( temp_file, "w");
    fclose( fp );
   
    vdestmp_file = temp_file;
    pins_file = vscript.vsMerge( "", path, filename, "pi" );
    pack_file = vscript.vsMerge( "", path, filename, "pa" );
    cons_file = vscript.vsMerge( "", path, filename, "co" );
}
 
function read_vdrawini() {

    function append1(list1, item) {
         return (reverse(cons(item,reverse(list1)))); }
    /* end jrs */


    primary_path = nil;
    vdraw_path = nil;
    vdraw_alias = nil;
    writable_alias = nil;
    vdrawini := fopen (vscript.vsGetini ("viewdraw.ini"), "r");
    if( vdrawini == nil ) return( 1 );
    for (s := fgetline (vdrawini); s != nil; s = fgetline (vdrawini)) {

        /*
         * If it's a directory line, "DIR [r] /pathname/...."
         * parse it and add it to the path list.
         */
        if (((s = string_token (s, &cmd, " \t")) != nil) &&
            (string_eqi (cmd, "dir")) &&
            ((s = string_token (s, &ignore, " \t")) != nil) &&
            ((s = string_token (s, &path, " \t\n")) != nil)) {
            if( (primary_path == nil) &&
                ( lindex( ignore, 'p') ||
                 lindex( ignore, 'P' )))
                primary_path = string_copy( path );
            string_token(s, &alias, " ()\t\n");
            vdraw_path =  append1( vdraw_path, vscript.vsAbsPath (path) );
            vdraw_alias = append1( vdraw_alias, alias );
            if( (alias != nil ) && 
                (lindex( ignore, 'p' ) ||
                 lindex( ignore, 'P' ) ||
                 lindex( ignore, 'w' ) ||
                 lindex( ignore, 'W' ))) 
                 writable_alias = append1( writable_alias, alias );
         } 

    } /* for */
    fclose (vdrawini);
    if( primary_path == nil ) {
        set_stdout( TRUE );
        printf("ERROR: must specify primary directory in viewdraw.ini\n");
        return(1);
    }
    return( 0 );
} /* end of read_vdrawini */



function start_gui() {
  
     vcFac.Create ("test", vscmVT);
     vcFac.Create ("p2", vscmVT);
     vcFac.Create ("vdes3", vscmVT);
     vcFac.Create ("vdes4", vscmVT);
     fac = vcFac.Create ("v2", vscmVT);
     if (args == nil)
         path := "/import/viewtools/workview/v50/demo/";
     else {
         path := car (args);
         if (!string_eq (substring (path, 0, 1), "/"))
         path = path + "/";
     } /* else */


      /* Vhdldes is the string that will appear in the icon */
     region = vcRegion.Create1 ("ViewSynthesis 2.4.1", fac, path, nil);
     /* Create a main window with no "bindings" area */
     vcWin.SetProgramName ("viewsynthesis");
     vdes2_win = vcWin.Create(region, vcWin.NoBindings);
}

unique_filename( "/tmp" );
if( read_vdrawini() == 0 )
    start_gui();


         
