/*
 * $Header: /import/build/532_latest/src/pcbint/standard/RCS/sae.vs,v 1.7 1995/05/12 19:46:03 sathe Stab $
 */

sae_help_no_help :=
"
Sorry. No help has been provided 
for this attribute.
";

function sae_check_no_check(string, arg_list)
{
/*    printf("check_no_check: %s\n",string); */
    return (TRUE); 
}  


adk_help_default :=
"
This is the default help string.
";


function check_default(string, arg_list)
{
/*    printf("check_default: %s\n",string);  */
    return (TRUE); 
}  







/****************************************************************/
set_stdout(TRUE);  

/* global var holding the attr ed window. 
   used to detect multiple attr ed invoactions.
   */
cpa_window := nil;

/* var holding the name of the last selected category.
   global since it must persist across attr editor invocations
   within a viewdraw session.
   */
sae_selected_category := nil; 

sae_attr_categories := make_vector(0);

function find_and_load (file_name, must)
{
    found := FALSE;
    foreach (dir; vscript.wdir_path ())
    {
        if (fexists (path := dir + "/"+file_name))
        {
            load (path);
            found = TRUE;
            break;
        }
    }
    if (found != TRUE)
    {
        failed_to_find_string := "Failed to find "+ file_name + " in WDIR";
        if (must == TRUE)
            vlEx.Throw2(vlEx.FAILURE, "Attribute Editor", 
                        vlErrSev.Error, 
                        failed_to_find_string);
        else
            printf("Note: %s\n", failed_to_find_string);
    }
}



find_and_load ("saeview.cfg", FALSE);
find_and_load ("saeuser.cfg", FALSE);



top_level_update := TRUE;    
sae_hash_slots := 53;
sae_attr_details_table := vlSym.StrCreate (sae_hash_slots);

function hash_attr_if_absent(attr_vector)
{
    foreach (attr; vscript.vect_iter(attr_vector[1]))
    {
        attr_details := vlSym.Fetch (sae_attr_details_table,
                                     attr[0]);
        if (attr_details == nil)
            vlSym.Store (sae_attr_details_table, 
                         attr[0], attr);
    }
}

foreach (entry_attr_vector; vscript.vect_iter (sae_attr_categories))
    hash_attr_if_absent(entry_attr_vector);
    
/* for some reason the variable 'selected_objects' has to be global
   in order for the procedure registered in the vdraw.CallOnSelect
   to get the correct current value of 'selected_objects' rather than
   it's value on the first call. 
   */
declare selected_objects;
    
function check_selection (display, event)
{
    /* 
       the check_selection action function first checks for the existence of
       a smart attribute editor window. if one exists it doesn't allow
       another one to be popped up. this is because ^A works this way and
       multiple editors may cause confusion.
       */
    if (cpa_window != nil)
        vlEx.Throw2(vlEx.FAILURE, "Attribute Editor", 
                    vlErrSev.Error, 
                    "Dialog box for attributes already exists");

    block := vdraw.DisplayGetBlock(display);   
    selected_objects = vdraw.BlockSaveSelected(block);


    function selection_changed (block, type)
    {
        if (cpa_window != nil) {
            vdraw.BlockRestoreSelected(block, selected_objects);
            vdraw.DisplayRefresh(display);
            vlEx.Throw2(vlEx.FAILURE, "Attribute Editor", 
                        vlErrSev.Error, 
                        "Object selection in ViewDraw cannot be changed \nwhile Attribute Editor box exists.");   
        }
    };
    vdraw.CallOnSelect(selection_changed);
    
    /*
       then the list of all selected objects in the viewdraw window is
       obtained. if no objects have been selected we return nil immediately.
       */
    all_obj_list := vdraw.BlockSaveSelected(block);
    if (all_obj_list == nil)
        vlEx.Throw2(vlEx.FAILURE, "Attribute Editor", 
                    vlErrSev.Note, 
                    "No object selected. \nAt least one component, net or pin should be selected");



    /*
       we then iterate through each selected object adding it to a list of
       selected components, nets, component pins or others depending on its
       type.  thus we end up with four lists of selected objects of four
       types. three of these are valid object lists. "others" are invalid 
       objects. 
       */    
    declare sel_comp_list, sel_net_list, sel_comp_pin_list, sel_others_list;
    foreach (curr_obj; vscript.list_iter(all_obj_list)) 
    {
        curr_obj_type := vdraw.ObjGetType (block, curr_obj);
        if (curr_obj_type == vdraw.vqType.Component)
            sel_comp_list = cons (curr_obj, sel_comp_list);
        else 
            if (curr_obj_type == vdraw.vqType.Net)
                sel_net_list = cons (curr_obj, sel_net_list);
            else 
                if (curr_obj_type == vdraw.vqType.ComponentPin)
                    sel_comp_pin_list = cons (curr_obj, sel_comp_pin_list);
                else 
                    sel_others_list = cons (curr_obj, sel_others_list); 
    }
    
    /*
       the length of these object lists are then determined to find the
       number of objects in each list. for every non-empty list the number of
       selected object types (num_obj_types) is incremented and obj_list,
       obj_type and type_string variables are set. type_string is a string
       representing the object type. this is used later to match the entries
       in the user config files since we cannot expect the user to specify
       the types such as "vdraw.vqType.Net" in the user config files. it is
       much easier for the user to say simply "Net".
       */
    declare obj_type, obj_list, type_string;
    num_obj_types := 0;
    if ((num_comps := length (sel_comp_list)) != 0)
    {
        ++num_obj_types;
        obj_type = vdraw.vqType.Component;
        type_string = "Comp";
        obj_list = sel_comp_list;
    }
    if ((num_nets := length (sel_net_list)) != 0)
    {
        ++num_obj_types;
        obj_type = vdraw.vqType.Net;
        type_string = "Net";
        obj_list = sel_net_list;
    }
    if ((num_comp_pins := length (sel_comp_pin_list)) != 0)
    {
        ++num_obj_types;
        obj_type = vdraw.vqType.ComponentPin;
        type_string = "Comp_Pin";
        obj_list = sel_comp_pin_list;
    }
    num_others := length (sel_others_list);
    
    declare multi_radio;
    
    










    /*action function for the command change_pcb_attrs */
    
    function change_pcb_attrs(display, event)
    {
        /*
           the change_pcb_attrs function first checks to see if a
           multi_radio region exists. if it does then it gets the value of
           the radio box region and depending on the value retrieved the
           obj_list variable is set to the one of the lists of selected
           components, nets or component pins which was earlier built up. if
           only one type of object had been selected then the radio box
           region will not exist and the obj_list will already be set
           correctly.
           */
        if (multi_radio != nil)
        {
            type_string = vcRegion.Get(multi_radio, vlStringVT);
            if (string_eq(type_string, "Comp"))
                obj_list = sel_comp_list;
            else if (string_eq(type_string, "Net"))
                obj_list = sel_net_list;
            else if (string_eq(type_string, "Comp_Pin"))
                obj_list = sel_comp_pin_list;
            if (length (obj_list) <= 0)
            {
                vlEx.Throw2(vlEx.FAILURE, "Attribute Editor", 
                            vlErrSev.Note, 
                            "No selected objects of indicated type");
            }
        }
        vcWin.Busy (vcEvent.Window(event), TRUE); 

        cpa_table := vcTable.Create ("Attribute Editor for Selected Objects", 
                                     2, 1);
        
        /*
           we now want to build up a merged list of all attributes on the
           selected object(s). this part of the code is in transition and in
           it's present state is not worth describing. it can be explained
           verbally if necessary. suffice to say that the output from this
           section is a existing_all_attr_list variable which has the names
           and values of all the attributes and oats on the object, and the
           object's symbol if the object is a component.
           */
        /*************************************************************/
        /*************************************************************/
        oats_val := vdraw.ParamGetMode(block, vdraw.vqMode.Oats);
        existing_all_attr_list := nil;
        




        existing_all_attr_table := vlSym.StrCreate (sae_hash_slots);

        /* go thru the list of selected objects and build up a list of
           existing attrs on each obj. including symbol attrs for
           components, obj attrs and oats */
        
        foreach (obj; vscript.list_iter(obj_list)) 
        {
            declare value0, value1, value2, value_list, name, value; 
            declare num_hits0, num_hits1, num_hits2;

            existing_obj_attr_table := vlSym.StrCreate (sae_hash_slots);
            
            /* go through all the occurrence attrs on the object and 
               add them to the existing_all_attr_list. 
               */
            if (oats_val == vlOnOff.On)
            {
                foreach (oat; vdraw.ObjIterOat(block, obj))
                {
                    name = vdraw.AttrGetName(block, oat);
                    value = vdraw.AttrGetValue(block, oat);
                    value_list = vlSym.Fetch (existing_all_attr_table,
                                              name);
                    if (value_list != nil)
                    {
                        /* the attribute was found in the all_attr_list
                           so check if it's value is different
                           */
                        value0 = list_ref (value_list, 0);
                        value1 = list_ref (value_list, 1);
                        value2 = list_ref (value_list, 2);

                        num_hits2 = list_ref (value_list, 5);
                        ++num_hits2;
                        list_set (value_list, 5, num_hits2); 

                        /* if value2 is "" set new value
                         */
                        if (string_eq(value2, ""))
                            list_set (value_list, 2, value); 
                        else
                        {
                            /* if value2 is not "" and not same as value
                               mark conflict
                               */
                            if (!(string_eq(value2, value)))
                                list_set (value_list, 2, "****Various****"); 
                        }  
                    }
                    else
                    {
                        /* the attribute was not already on the list
                           so add to the lists as a new obj attribute
                           */
                        value_list = list("", "", value, 0, 0, 1);
                        vlSym.Store (existing_obj_attr_table, 
                                     name, value_list);
                        vlSym.Store (existing_all_attr_table, 
                                     name, value_list);
                    }
                }
            }



            foreach (attr; vdraw.ObjIterAttr(block, obj))
            {
                name = vdraw.AttrGetName(block, attr);
                value = vdraw.AttrGetValue(block, attr);
                value_list = vlSym.Fetch (existing_all_attr_table,
                                          name);
                if (value_list != nil)
                {
                    /* the attribute was found in the all_attr_list
                       so check if it's value is different
                       */
                    value0 = list_ref (value_list, 0);
                    value1 = list_ref (value_list, 1);
                    value2 = list_ref (value_list, 2);
                    num_hits1 = list_ref (value_list, 4);
                    ++num_hits1;
                    list_set (value_list, 4, num_hits1); 
                    /* if value1 is "" set new value
                     */
                    if (string_eq(value1, ""))
                        list_set (value_list, 1, value);
                    else
                    {
                        /* if value1 is not "" and and not same as value
                           mark conflict
                           */
                        if (!(string_eq(value1, value)))
                            list_set (value_list, 1, "****Various****");
                    }
                }
                else
                {
                    /* the attribute was not already on the list
                       and it was not the first object so mark
                       it as a value conflict. 
                       */
                    value_list = list("", value, "", 0, 1, 0);
                    vlSym.Store (existing_obj_attr_table, 
                                 name, value_list);
                    vlSym.Store (existing_all_attr_table, 
                                 name, value_list);
                }
            }
            

            /* find the # (i.e. pinnumber) attribute on the comp
               pin and add it to the existing_all_attr_list 
               this is treated specially since vdraw.ObjIterAttr
               doesn't return this attribute with all the others.
               */

            if (string_eq(type_string, "Comp_Pin"))
            {
                name  = "#";
                value = vdraw.CompPinGetPinNumber(block, obj);
                value_list = vlSym.Fetch (existing_all_attr_table,
                                          name);
                if (value_list != nil)
                {
                    /* the attribute was found in the all_attr_list
                       so check if it's value is different
                       */
                    value0 = list_ref (value_list, 0);
                    value1 = list_ref (value_list, 1);
                    value2 = list_ref (value_list, 2);
                    num_hits1 = list_ref (value_list, 4);
                    ++num_hits1;
                    list_set (value_list, 4, num_hits1); 
                    /* if value1 is "" set new value
                     */
                    if (string_eq(value1, ""))
                        list_set (value_list, 1, value);
                    else
                    {
                        /* if value1 is not "" and and not same as value
                           mark conflict
                           */
                        if (!(string_eq(value1, value)))
                            list_set (value_list, 1, "****Various****");
                    }
                }
                else
                {
                    /* the attribute was not already on the list
                       and it was not the first object so mark
                       it as a value conflict. 
                       */
                    value_list = list("", value, "", 0, 1, 0);
                    vlSym.Store (existing_obj_attr_table, 
                                 name, value_list);
                    vlSym.Store (existing_all_attr_table, 
                                 name, value_list);
                }
            }



        
        
        



            /* if it a component pin then go through all the
               attributes on the component pin's symbol and add them
               to the existing_all_attr_list */
            if (string_eq(type_string, "Comp_Pin"))
            {                
                existing_sym_p_attr_table := vlSym.StrCreate (sae_hash_slots);
                symbol_block := block;
                symbol_pin := vdraw.CompPinGetPin(symbol_block, obj);
                foreach (attr; vdraw.ObjIterAttr(symbol_block, symbol_pin))
                {
                    name = vdraw.AttrGetName(symbol_block, attr);
                    value = vdraw.AttrGetValue(symbol_block, attr);

                    value_list = vlSym.Fetch (existing_all_attr_table,
                                              name);
                    if (value_list != nil)
                    {
                        /* the attribute was found in the all_attr_list
                           so check if it's value is different
                           */
                        value0 = list_ref (value_list, 0);
                        value1 = list_ref (value_list, 1);
                        value2 = list_ref (value_list, 2);
                        num_hits0 = list_ref (value_list, 3);
                        ++num_hits0;
                        list_set (value_list, 3, num_hits0); 
                        /* if value0 is "" set new value
                         */
                        if (string_eq(value0, ""))
                            list_set (value_list, 0, value);
                        else
                        {
                            /* if value0 is not "" and not same as value
                               mark conflict
                               */
                            if (!(string_eq(value0, value)))
                                list_set (value_list,0,"****Various****");
                        }
                    }
                    else
                    {
                        /* the attribute was not already on the list
                           and it was not the first object so mark
                           it as a value conflict. 
                           */
                        value_list = list(value, "", "", 1, 0, 0);
                        vlSym.Store (existing_obj_attr_table, 
                                     name, value_list);
                        vlSym.Store (existing_all_attr_table, 
                                     name, value_list);
                        
                    }
                }
            } /* end if (string_eq(type_string, "Comp_Pin")) */
            






            /* if it a component then go through all the
               attributes on the component's symbol and add them
               to the existing_all_attr_list */
            if (string_eq(type_string, "Comp"))
            {                
                existing_sym_attr_table := vlSym.StrCreate (sae_hash_slots);
                symbol_block := vdraw.CompGetBlock(block, obj);
                symbol_obj := symbol_block;
                foreach (attr; vdraw.ObjIterAttr(symbol_block, symbol_obj))
                {
                    name = vdraw.AttrGetName(symbol_block, attr);
                    value = vdraw.AttrGetValue(symbol_block, attr);

                    value_list = vlSym.Fetch (existing_all_attr_table,
                                              name);
                    if (value_list != nil)
                    {
                        /* the attribute was found in the all_attr_list
                           so check if it's value is different
                           */
                        value0 = list_ref (value_list, 0);
                        value1 = list_ref (value_list, 1);
                        value2 = list_ref (value_list, 2);
                        num_hits0 = list_ref (value_list, 3);
                        ++num_hits0;
                        list_set (value_list, 3, num_hits0); 
                        /* if value0 is "" set new value
                         */
                        if (string_eq(value0, ""))
                            list_set (value_list, 0, value);
                        else
                        {
                            /* if value0 is not "" and not same as value
                               mark conflict
                               */
                            if (!(string_eq(value0, value)))
                                list_set (value_list,0,"****Various****");
                        }
                    }
                    else
                    {
                        
                        /* the attribute was not already on the list
                           and it was not the first object so mark
                           it as a value conflict. 
                           */
                        value_list = list(value, "", "", 1, 0, 0);
                        vlSym.Store (existing_obj_attr_table, 
                                     name, value_list);
                        vlSym.Store (existing_all_attr_table, 
                                     name, value_list);
                    }
                }
            } /* end if (string_eq(type_string, "Comp")) */

        } /*end foreach (obj; vscript.list_iter(obj_list)) */
        

        /*************************************************************/
        /*************************************************************/
        /* we now have the required existing_all_attr_list */
        

        foreach (sym, val; vlSym.Loop (existing_all_attr_table))

        
        /*
           the atribute editor dialog box is then built. this consists of a
           vcTable region called cpa_table containing a vcNotebook region
           called cpa_note. cpa is an acronym for change_pcb_attrs. each
           entry (or tab) in the notebook is a region of the AttrEd
           facility. the AttrEd facility takes a four element vector
           'init_data' as initialization data. the first three elements of
           'init_data' are the display, obj_list and type_string.
           */

        num_categories := length (sae_attr_categories) + 1;
        tab_list := nil;
        num_objs := length (obj_list); 

        
        attr_notify_table := vlSym.StrCreate (sae_hash_slots);

        init_data := make_vector(6);
        init_data[0] = display;
        init_data[1] = obj_list; 
        init_data[2] = type_string;
        init_data[3] = attr_notify_table;
        init_data[5] = selected_objects;

        cpa_note := vcRegion.Create ("notebook", vcNotebook.fac, 
                                     vgAlign.UpperCenter,
                                     macro_on <- TRUE);
        vcFac.Create ("AttrEd", vscmVT);



        /*
           the fourth element is calculated and the notebook is built as
           follows.
           
           we iterate thru the sae_attr_categories vector specified in the
           user_attr_vector.vs file. this vector has the format...

           sae_attr_categories := [
           ["entry_name", vector_name, object_type],
           ["entry_name", vector_name, object_type],
           .
           .
           .
           ["entry_name", vector_name, object_type]
           ];
           
           where each vector_name is in the format...
           
           vector_name := [
           ["attribute_name","value",check_func, help_string,"entry_editor_type"],
           ["attribute_name","value", check_func, help_string, "entry_editor_type"],
           .
           .
           .
           ["attribute_name","value", check_func, help_string, "entry_editor_type"]
           ];
           
           the sae_attr_categories define the entries in the notebook. 
           the vector_name defines each attribute in an entry.
           */


        /*
           for each vector_name in sae_attr_categories that has an object_type
           matching the object type selected in viewdraw a single notebook
           entry is created. for each vector_name that matches we iterate
           thru the elements assigning each element in turn to
           entry_attr_vector. if the element's attribute_name element is
           found in our existing_all_attr_list then its value is retreived
           from the existing_all_attr_list and entered in the "value"
           element of the entry_attr_vector.
           */

        /*
           this entry_attr_vector is the fourth element of the init_data
           vector. once this has had its values filled (if possible) then
           the a region controlled by the AttrEd facility can be created and
           added as an entry to the notebook. thus each entry in the
           notebook is a AttrEd region which has a list of attributes
           specified with one entry in the sae_attr_categories vector.
           */



        attr_vector := make_vector(vlSym.Size(existing_all_attr_table));

        index := 0;
        foreach (name, value_list; vlSym.Loop (existing_all_attr_table))
        {
            attr := vlSym.Fetch (sae_attr_details_table,
                                 name);
            if (attr != nil)
            {

                if ((list_ref (value_list, 3) == num_objs) ||
                    (list_ref (value_list, 3) == 0))
                    attr[1] = list_ref (value_list, 0);
                else 
                    attr[1] = "****Various****";
                if ((list_ref (value_list, 4) == num_objs) ||
                    (list_ref (value_list, 4) == 0))
                    attr[2] = list_ref (value_list, 1);
                else 
                    attr[2] = "****Various****";
                if ((list_ref (value_list, 5) == num_objs) ||
                    (list_ref (value_list, 5) == 0))
                    attr[3] = list_ref (value_list, 2);
                else 
                    attr[3] = "****Various****";
            }
            else 
            {

                attr = make_vector(8);
                attr[0] = name;

                if ((list_ref (value_list, 3) == num_objs) ||
                    (list_ref (value_list, 3) == 0))
                    attr[1] = list_ref (value_list, 0);
                else 
                    attr[1] = "****Various****";
                if ((list_ref (value_list, 4) == num_objs) ||
                    (list_ref (value_list, 4) == 0))
                    attr[2] = list_ref (value_list, 1);
                else 
                    attr[2] = "****Various****";
                if ((list_ref (value_list, 5) == num_objs) ||
                    (list_ref (value_list, 5) == 0))
                    attr[3] = list_ref (value_list, 2);
                else 
                    attr[3] = "****Various****";

                attr[4] = sae_check_no_check;
                attr[5] = nil;
                attr[6] = sae_help_no_help;
                attr[7] = "";
            }
            attr_vector[index] = attr;
            ++index;
        }
        init_data[4] = attr_vector; 

        entry_region := vcRegion.Create ("All Existing", 
                                         AttrEd.fac, init_data);
        vcNotebook.AddEntry (cpa_note, 
                             "All Existing", entry_region); 
        if (sae_selected_category == nil)
            sae_selected_category = vcRegion.Name(entry_region);

        tab_list = cons (entry_region, tab_list);
        
        function add_entries(category_vector)
        {
            foreach (entry_attr_vector; vscript.vect_iter (category_vector))
                if (string_eq(type_string, entry_attr_vector[2]))
                {
                    foreach (attr; vscript.vect_iter(entry_attr_vector[1]))
                    {
                        attr[1] = "";
                        attr[2] = "";
                        attr[3] = "";
                        value_list := vlSym.Fetch (existing_all_attr_table,
                                                   attr[0]);

                        if (value_list != nil)
                        {
                            if ((list_ref (value_list, 3) == num_objs) ||
                                (list_ref (value_list, 3) == 0))
                                attr[1] = list_ref (value_list, 0);
                            else 
                                attr[1] = "****Various****";
                            if ((list_ref (value_list, 4) == num_objs) ||
                                (list_ref (value_list, 4) == 0))
                                attr[2] = list_ref (value_list, 1);
                            else 
                                attr[2] = "****Various****";
                            if ((list_ref (value_list, 5) == num_objs) ||
                                (list_ref (value_list, 5) == 0))
                                attr[3] = list_ref (value_list, 2);
                            else 
                                attr[3] = "****Various****";
                        }
                    }
                    init_data[4] = entry_attr_vector[1]; 
                    
                    entry_region := vcRegion.Create (entry_attr_vector[0], 
                                                     AttrEd.fac, init_data);
                    vcNotebook.AddEntry (cpa_note, 
                                         entry_attr_vector[0], entry_region); 
                    tab_list = cons (entry_region, tab_list);
                    
                }       
        }

        add_entries (sae_attr_categories);


        /* go through the list of categories that will be displayed 
           and see if any of them matches the last selected category 
           in the attribute editor's last invocation. if that category
           is found select it in the notebook overriding the default
           selection - the 'All Existing' category. 
           */
        foreach (region; vscript.list_iter(tab_list))
            if (string_eq(sae_selected_category, vcRegion.Name(region)))
                vcNoteTab.SelectByString (cpa_note, sae_selected_category);

        /* every time a new category is selected in the notebook 
           mark it as the selected category.
           */
        function category_changed (category_region)
            sae_selected_category = vcRegion.Name(category_region);

        vcNoteTab.CallOnSelect(cpa_note, category_changed);


        vcTable.Add (cpa_table, cpa_note);
        
        function accept_attrs (data, event)
        {
            vcWin.Busy (vcEvent.Window(event), TRUE); 
            foreach (region; vscript.list_iter(tab_list))
            {
                region_data := vcRegion.GetData(region);
                if (region_data.attr_ed_touched == TRUE)
                    vcCmd.Run (AttrEd.accept_cmd, region_data, 
                               event, nil, TRUE); 
            }
            vdraw.DisplayRefresh(display);
            vcWin.Busy (vcEvent.Window(event), FALSE);

        }
        
        accept_cmd := vcWv.Cmd(vdraw.fac, accept_attrs, "Accept");


        button_row := vcRegion.Create ("button_row", vcButnRow.fac,
                                       list (list ("Accept", "Accept",
                                                   accept_cmd,
                                                   list (close_window <- TRUE)),
                                             list ("Cancel", "Cancel", 
                                                   func(e) nil;,
                                                   list (close_window <- TRUE))));
        
        vcTable.Add (cpa_table, button_row);
        cpa_window = vcWin.Create(vcEvent.Window(event), cpa_table);
        vcWin.Busy (vcEvent.Window(event), FALSE);

        vcWin.DestroyNotify (cpa_window, func (win) cpa_window = nil;); 
    } /* function change_pcb_attrs */
    
    sae_cmd := vcWv.Cmd(vdraw.fac, change_pcb_attrs, "sae");
    
    
    
    /*
       if only one of the valid object lists is non-empty the user has
       selected only one type of object and we proceed to pop-up the editor
       for this single type of object using the change_pcb_attrs. in this
       case the obj_list, obj_type and type_string variables were set only
       once to the single selected object type.  if, however, we find that
       the num_obj_types is greater than one, then multiple types of objects
       have been selected. the attribute editor does not handle multiple
       objects of multiple types simultaneously, therefore we then need to
       ask the user to choose one of the types to proceed with.
       */

    if (num_obj_types == 0)
        vlEx.Throw2(vlEx.FAILURE, "Attribute Editor", 
                    vlErrSev.Note, 
                    "No VALID object selected. \nAt least one component, net or pin should be selected");
    if (num_obj_types == 1)
            vcCmd.Run (sae_cmd, display, event, nil, TRUE);
    else
    {
        /*
           this is accomplished by popping up a dialog box with three radio
           buttons in a 'multi_radio' radio box region. alongside each
           button is an object type and the number of objects of that type
           that have been selected. the user can then choose one of the
           types and accept his selection to bring up the atribute editor
           using the change_pcb_attrs action function or cancel the
           check_selection_cmd command.
           */
        multi_warning_string := "You have chosen objects of multiple types.\nChoose one of the following object types.\n";        
        multi_text := vcRegion.Create ("multi_text", 
                                       vcStaticText.fac, multi_warning_string,
                                       align <- vgAlign.MiddleCenter
                                       );
        

        num_comps_string := number2string(num_comps);
        num_nets_string := number2string(num_nets);
        num_comp_pins_string := number2string(num_comp_pins);
        
        multi_list := nil;
        if (num_comp_pins != 0)
            multi_list = cons (list (num_comp_pins_string+" Component Pins", 
                                     "Comp_Pin"),
                               multi_list);
        if (num_nets != 0)
            multi_list = cons (list (num_nets_string+" Nets", "Net"),
                               multi_list);
        if (num_comps != 0)
            multi_list = cons (list (num_comps_string+" Components", "Comp"),
                               multi_list);

/*        
        multi_list := list (list (num_comps_string+" Components", "Comp"),
                            list (num_nets_string+" Nets", "Net"),
                            list (num_comp_pins_string+" Component Pins", 
                                  "Comp_Pin"));        
*/
        multi_radio = vcRegion.Create ("multi_radio", vcRadioBox.fac, 
                                       "Comp", data <- multi_list);
        
        
        /* change_pcb_attrs command definition */
        multi_cancel_cmd := vcWv.Cmd(vdraw.fac, func (d, e) nil;, "Cancel");
        
        multi_button_row := vcRegion.Create ("multi_button_row", vcButnRow.fac,
                                             list (list ("Accept", "Accept",
                                                         sae_cmd,
                                                         list (close_window <- TRUE)),
                                                   list ("Cancel", "Cancel", 
                                                         multi_cancel_cmd, 
                                                         list (close_window <- TRUE))));
        
        multi_warning := vcTable.Make ("Object Type Selection Box", 3, 1,
                                       multi_text, 
                                       multi_radio,
                                       multi_button_row);
        vcTable.Col(multi_warning, 0, vcTable.Border.Invisible, 
                    3, 3, 3, vgAlign.UpperCenter);
        multi_window := vcWin.Create(vcEvent.Window(event), multi_warning, 
                                     vcWin.NoFlags);
        vcWin.Forward(vcEvent.Window(event), multi_window);
    }
}

/* check_selection command definition */
check_selection_cmd := vcWv.Cmd(vdraw.fac, check_selection, "cpa");
vcBind.Set (vdraw.bindings, '\^P', check_selection_cmd);
