/* ST - 12/27/93, functions SetByString and IsInPicklist
   are modified according to the changes in 52 */ 
/*\vscmuserFunction vcPicklist.SetByString -- Set an picklist entry by specifyin
g its string.

DESCRIPTION
     Searches a picklist with string entries for a label entry whose
     string matches the argument "str", and calls vcPicklist.SetPick
     on that entry.
*/
function SetByString(picklist_region, str) {
    declare n_rows, n_cols, r, c, entry_str;
    vcPicklist.Dimensions (picklist_region, &n_rows, &n_cols);
    for (r = 0; r < n_rows; ++r)
        for (c = 0; c < n_cols; ++c) {
            entry_str = car (vcPicklist.Get (picklist_region, r, c));
            if (string_eq (entry_str, str)) {
                    vcPicklist.SetPick (picklist_region, c + r * n_cols);
                    return (TRUE);
                } /* if */
        } /* for */

    return(FALSE);
} /* function SetByString */

function IsInPicklist(picklist_region, str) {
    declare n_rows, n_cols, r, c, entry_str;
    vcPicklist.Dimensions (picklist_region, &n_rows, &n_cols);
    for (r = 0; r < n_rows; ++r)
        for (c = 0; c < n_cols; ++c) {
            entry_str = car (vcPicklist.Get (picklist_region, r, c));
            if (string_eq (entry_str, str)) {
                return (TRUE); }
        } /* for */
    return(FALSE);
}


