declare vqIsAbel;

function FindAttr(block, comp, attrname) {
  declare attr;

  attr = ObjFindAttr(block, comp, attrname);
  if (attr == nil)
    attr = ObjFindAttr(block, CompGetBlock(block, comp), attrname);
  
  attr;
} /* function FindAttr */

function push_sch(display, event, attr, attval, data, ext, editor) {
  vcWin.RunCmdline(vcEvent.Window(event), "psch", event);
} /* function push_sch */


function push_sym(display, event, attr, attval, data, ext, editor) {
  vcWin.RunCmdline(vcEvent.Window(event), "psym", event);
} /* function push_sym */

function psh_sheet(display, event, attr, attval, data, ext, editor) {
  vcWin.RunCmdline(vcEvent.Window(event), "psheet", event);
} /* function psh_sheet */

function push_vhdl(display, event, attr, attval, data, ext, editor) {
  path := nil;
  alias := data.alias;

  file := string_lower(attval);

  if (DataObjExists (alias, file, ext, vqObjClass.VHDL))
    path = DataObjGetPath(alias, file, ext, vqObjClass.VHDL);
  else if (DataObjExists(alias, file, ext, vqObjClass.FirstFile))
    path = DataObjGetPath(alias, file, ext, vqObjClass.FirstFile);
  else if ((file != nil) && !string_eq (file, ""))
    path = file + "." + ext;
  else
    error("Missing value for attribute", attr);

  vcWin.RunCmdline(vcEvent.Window(event), editor + " " + path, event);

} /* function push_vhdl */

/*
   Spice models are found via viewdraw.ini search order, they
   may be in megafile form
*/
function push_spice(display, event, attr, attval, data, ext, editor) {

  file := string_lower(attval);
  found := FALSE;

  foreach(type, alias, path; IniIterLibInfo()) {
      if (DataObjIsMega (alias, file, ext, vqObjClass.Spice)) {
	  vtxr := vcRegion.Create("Spice Model For " + attval,
				  vtx.fac, "Spice Model For " + attval);
	  foreach(line; MegaObjIterLine(alias, file, ext, vqObjClass.Spice)) {
	      vtx.AddString(vtxr, line);
	  } /* foreach */
	  vtx.ReadOnly(vtxr, TRUE);
	  vtx.BeginningOfBuffer(vtxr);
	  vcWin.Create(vtxr);
	  found = TRUE;
	  break;
      } else if (DataObjExists (alias, file, ext, vqObjClass.Spice)) {
	  path = DataObjGetPath(alias, file, ext, vqObjClass.Spice);
	  vcWin.RunCmdline(vcEvent.Window(event), editor + " " + path, event);
	  found = TRUE;
	  break;
      } /* } else if */
  } /* foreach */

  if (!found)
      error("No Spice model can be located for", attval); 

} /* function push_spice */

function is_abel(display, event, attval, data, ext) {
  file := string_lower(data.symname);
  path := nil;
  alias := data.alias;

  if (!vqIsAbel) {		/* EJF 20-Dec-93 11:21:45 Bug Fix: 10227 */
      if (DataObjExists (alias, file, ext, "Project"))
	  path = DataObjGetPath(alias, file, ext, "Project");
      else if (DataObjExists(nil, file, ext, "Project"))
	  path = DataObjGetPath(nil, file, ext, "Project");
      
      vqIsAbel = (path != nil);
      return(path != nil);
  } /* if */

  FALSE;
} /* function is_abel */

function push_abel(display, event, attr, attval, data, ext, editor) {

  file := string_lower(attval);
  path := nil;
  alias := data.alias;

  if (DataObjExists (alias, file, ext, "Project"))
    path = DataObjGetPath(alias, file, ext, "Project");
  else if (DataObjExists(nil, file, ext, "Project"))
    path = DataObjGetPath(nil, file, ext, "Project");
  else if ((file != nil) && !string_eq (file, ""))
    path = file + "." + ext;
  else
    error("Missing value for attribute", attr);

  vcWin.RunCmdline(vcEvent.Window(event), editor + " " + path, event);

} /* function push_abel */

function push_verilog(display, event, attr, attval, data, ext, editor) {
  alias := data.alias;
  path := nil;
  file := string_lower(attval);
  userExt := cadddr(vscript.vsParse(file));

  /* If a file by the given name exists then use it */
  if (DataObjExists(alias, file, "", vqObjClass.FirstFile))
    path = DataObjGetPath(alias, file, "", vqObjClass.FirstFile);

  /* else if a file with the default extension exists then use that */
  else if (DataObjExists(alias, file, ext, vqObjClass.FirstFile))
    path = DataObjGetPath(alias, file, ext, vqObjClass.FirstFile);

  /* else if a file extension exists on the file name which is not empty
     then open it */
  else if ((userExt != nil) && (!string_eq (userExt, "")) && (file != nil) && (!string_eq (file, "")))
    path = file;

  /* else if the file name is not empty then open it with the default 
     extension */
  else if ((file != nil) && !string_eq (file, ""))
    path = file + "." + ext;

  else 
    error("Missing value for attribute", attr);

  vcWin.RunCmdline(vcEvent.Window(event), editor + " " + path, event);

} /* function push_verilog */

function levelpush(display, event) {
  declare buffer;
  declare symlist;
  declare comp;
  declare symbol;
  declare alias;
  declare sheet;
  declare symname;
  declare popup;

  vqIsAbel = FALSE;

  win := vcEvent.Window(event);

  count := numselobj(display, vqObject.Component);

  block := DisplayGetBlock(display);

  if (count == 1) {
      comp = BlockGetSelObj(block, "Component");
      symbol = CompGetBlock(block, comp);
      alias = BlockGetLibName(symbol);
      sheet = BlockGetSheet(symbol);
      /* TRUE below is to strip hierarchal path */
      symname = ObjGetName(symbol, symbol, TRUE); 
  }

  data := struct {
    block = block;
    comp = comp;
    symbol = symbol;
    alias = alias;
    sheet = sheet;
    symname = symname
  };
  
  table := vcTable.Create("Push", 3, 1);
  
  button := vcRegion.Create ("Buttons", vcButnRow.fac,
                             list (list ("Cancel", "Cancel",
                                         func() vcWin.Close (popup);,
                                         list (macro_on <- TRUE,
                                               close_window <- TRUE))));

  vcTable.Set(table, 2, 0, button);

  p := vcRegion.Create("Push", vcPicklist.fac,
                       nil, exclusive <- TRUE, columns <- 1);
  
  if (count == 1) {
      type := BlockGetType(symbol);
  
      if (type == vqBlockType.Composite) 
          vcPicklist.Add(p, "SCHEMATIC", 
             list(push_sch, nil, "SCHEMATIC", display, event, data, nil, nil));
      
  }

  if (BlockGetDataType (block) == vqDataType.Symbol) {
      type := BlockGetType(block);
      if (type == vqBlockType.Composite) 
          vcPicklist.Add(p, "SCHEMATIC", 
             list(push_sch, nil, "SCHEMATIC", display, event, data, nil, nil));
  } /* if */

  if (BlockGetDataType (block) == vqDataType.Schematic)
      vcPicklist.Add(p, "SYMBOL", 
              list(push_sym, nil,  "SYMBOL", display, event, data, nil, nil)); 

  vcPicklist.Add(p, "SHEET", 
             list(psh_sheet, nil, "SHEET", display, event, data, nil, nil));

  if (count == 1) {
      foreach(item; vscript.list_iter(LevelPushItems)) {
          target_attr := item.target;
          
          attr := FindAttr(block, comp, target_attr);
          
	  function EvalParamAtt(block, comp, attname) {
	      declare rval;
	      
	      foreach(b; BlockIterPath(block)) {
		  if (BlockGetDataType(b) == vqDataType.Symbol)
		      break;

		  c := BlockGetSelObj(b, vqFlag.Component);
		  if (c == nil)
		      error("No selected components on", b);
		  
		  a := FindAttr(b, c, attname);
		  if (a != nil) {
		      v := AttrGetValue(b, a);
		      if (string_ref(v, 0) != '@') {
			  rval = v;
			  break;
		      } /* if */
		  } /* if */
	      } /* foreach */
	      rval;
	  } /* function EvalParamAtt */

          if (attr != nil || string_eq(target_attr, "*")) {
              valid_func := item.verify_func;
              push_func := item.push_func;
              prompt := item.prompt;
              if (attr != nil) {
                  value := AttrGetValue(block, attr);
		  if (string_ref(value, 0) == '@') {
		      value := EvalParamAtt(block, comp, value);
		      if (value == nil)
			  error("Unable to resolve parameterized attribute for", attr);
		  } /* if */
              } else
                  value := data.symname;
              
              editor := item.editor;
              ext := item.extension;
              
              if (isprocedure(valid_func)) { 
                  if (value != nil && valid_func (display, event, 
                                                  value, data, ext))
                      vcPicklist.Add(p, prompt, list(push_func, attr, value, 
                                        display, event, data, ext, editor));
              } else if (value !=nil && valid_func == nil) {
                  vcPicklist.Add(p, prompt, list(push_func, attr, value, 
                                           display, event, data, ext, editor));
              } else
                  error("Validity function for target " + target_attr + 
                        " not found", valid_func);
          } /* if */
      } /* foreach */
  }

  vcRegion.Align(p, vgAlign.MiddleCenter);
    
  vcTable.Set(table, 0, 0, p);
    
  flags := vcWin.NoStatus + vcWin.NoMenus;
  popup = vcWin.Popup (vcEvent.Window (event), table, p, flags);
  
  vcPicklist.Notify(p,
		    func(data_in, on) {
		      if (on == vlOnOff.On) {
			f := car(data_in);
			a := cadr(data_in);
			v := caddr(data_in);
			d := cadddr(data_in);
			e := list_ref(data_in, 4);
			data := list_ref(data_in, 5);
			ext := list_ref(data_in, 6);
			editor := list_ref(data_in, 7);
			if (isprocedure(f)) {
			  f(d,e,a,v,data,ext,editor);
			} else {
			  v = string_lower(v);
			  vcWin.RunCmdline(vcEvent.Window(e), editor + " " + v + "." + ext, e);
			} /* } else */
			vcWin.Destroy(popup);
		      } /* if */
		    });		/* func */
} /* function levelpush */


levelpush_cmd := vcWv.Cmd(fac, levelpush, "levelpush");
vcCmd.SetHelp(levelpush_cmd, "Level Push Command");

declare LevelPushItems;

LevelPushItems = nil;

load ("vhdlpush.vs");

function AddLevelPushItem(target, prompt, extension, editor, verify_func, push_func){
  e := struct {
    target = target;
    prompt = prompt;
    extension = extension;
    editor = editor;
    verify_func = verify_func;
    push_func = push_func
  };

  LevelPushItems = cons(e, LevelPushItems);
}

/*
                 Key Attr   Prompt  Exten  Editor   Validity  PushFunc
*/
AddLevelPushItem("VHDL",   "VHDL",    "vhd", "wtext", not_vantage, push_vhdl);
AddLevelPushItem("VFILE",  "VERILOG", "v",   "wtext", nil, push_verilog);
AddLevelPushItem("VFILES", "VERILOG", "v",   "wtext", nil, push_verilog);
AddLevelPushItem("MODEL",  "SPICE",   "mod", "wtext", nil, push_spice);
AddLevelPushItem("*",      "ABEL",    "abl", "wtext", is_abel, push_abel);
AddLevelPushItem("ABEL",   "ABEL",    "abl", "wtext", is_abel, push_abel);

AddLevelPushItem("ACCEL",  "VHDL Entity", nil, nil, is_vhdl, show_entity);
AddLevelPushItem("ACCEL",  "VHDL Architecture", nil, nil, is_vhdl, show_arch);
AddLevelPushItem("ACCEL",  "VHDL Configuration", nil, nil, is_vhdl_cfg,
                 show_cfg);
