/***
* VFRAMEMN.VS
*
* Facility:  
*    Viewframe
*
* Functional Description:
*     Viewscript module for viewframe menus
*
* Environment:
*    SUNOS 4.1.1
*
* Author:
* 
*
* Modified by:
* Who            Version   When     What
* SAL            5.0       12/19/91 Changed SearchPath to SearchOrder
*
* Copyright (c) 1991 by Viewlogic Systems, Inc.
***/

/* Menus */
plot_menu :=
    vcWv.MakeMenu ("Project Plot",
/*                    vcWv.Pin (), */
                    list ("Schematic...",pltsch),
                    list ("Schematic w Oat...",pltoat),
                    list ("Symbol...",pltsym),
                    list ("Board...",pltboa));

/*
show_lib_menu :=
    vcWv.MakeMenu ("Show Library",
                    vcWv.Pin (), 
                    list ("Viewdraw",drawlib),
                    list ("Viewplace",placelib));
*/

prjcreate_menu :=
    vcWv.MakeMenu ("Project Create",
/*                    vcWv.Pin (),*/
                    list ("Viewdraw...",pdcreate),
                    list ("Viewplace...",ppcreate));

show_proj_menu :=
    vcWv.MakeMenu ("Show",
/*                    vcWv.Pin (),*/
/*                    list ("Library",show_lib_menu),*/
                    list ("Library",projlib),
                    list ("Hierarchy",phierarchy),
                    list ("Schematic",pdirsch),
                    list ("Symbol",pdirsym),
                    list ("Board",pdirboa),
                    list ("Shape",pdirsha),
                    list ("Other",pdiroth));

sp_menu :=
    vcWv.MakeMenu ("SearchOrder",
/*                    vcWv.Pin (),*/
                    list ("Viewdraw",psdraw),
                    list ("Viewplace",psplace));

proj_del_menu :=
    vcWv.MakeMenu ("Delete",
/*                    vcWv.Pin (),*/
                    list ("Project...",pdelete),
                    list ("Schematic...",schdelete),
                    list ("Symbol...",symdelete));

project_menu :=
    vcWv.MakeMenu ("Project",
/*                   vcWv.Pin (),*/
                    list ("Browse", browseproj),
                    list ("Show", show_proj_menu),
                    list ("SearchOrder", psearch),
                    list ("Create", pcreate),
                    list ("Set Current...", project),
                    list ("Remove...", premove),
                    list ("Delete", proj_del_menu),
                    list ("Archive...", parchive),
                    list ("Copy...", pcopy),
                    list ("Move...", pmove),
                    list ("Restore...", prestore),
                    list ("Plot", plot_menu));

lib_show_menu := 
    vcWv.MakeMenu ("Show Library",
/*                    vcWv.Pin(),*/
                    list ("Schematic",ldirsch),
                    list ("Symbol",ldirsym),
                    list ("Board",ldirboa),
                    list ("Shape",ldirsha));

library_menu :=
    vcWv.MakeMenu ("Library",
/*                    vcWv.Pin(),*/
/*                    list ("Backup", "backup_cmd"),*/
/*                    list ("Restore", "restore_cmd"),*/
/*                    list ("Delete", "ldelete"),*/
                    list ("Set Current...", library),
                    list ("Copy...", lcopy),
                    list ("Show", lib_show_menu));

cfilog_menu :=
    vcWv.MakeMenu ("CFI Log",
/*                   vcWv.Pin(),*/
                   list ("On", startcfilog),
                   list ("Off", stopcfilog));

config_menu :=
    vcWv.MakeMenu ("Config",
/*                    vcWv.Pin (),*/
                    list ("Init Toolboxes", initreg),
/*                  list ("Edit Config...", editcfg), */
/*                    list ("Edit TEF...", edittes),   */
                    list ("Edit Env Vars...", editenv));  
/*                    list ("Save Config", savecfg),*/
/*                  list ("Set WDIR...", ""),*/
/*                  list ("Colors...", "")),*/
/*                  list ("Toolboxes", tool_menu),*/
/*                    list ("CFI Log", cfilog_menu));*/

/*
admin_menu :=
    vcWv.MakeMenu ("Admin",
                    vcWv.Pin (),
                    list ("Lock", ""),
                    list ("Unlock", ""),
                    list ("Lockinfo", ""),
                    list ("ShowLocks", ""),
                    list ("HideLocks", ""));
*/

/*start_tool_menu :=
    vcWv.MakeMenu ("Process",
                    list ("Normal", startcurtool),
                    list ("Force Prompt", startprompt),
                    list ("No Prompt", startnoprompt));
*/

process_menu :=
    vcWv.MakeMenu ("Process",
/*                    vcWv.Pin (),*/
                    list ("Start Tool", startcurtool),
/*                    list ("Start Tool", start_tool_menu),*/
                    list ("Stop Tool", stopcurtool),
                    list ("Stop All Tools", stopalltools),
                    list ("Active Tools ...", selactivetool),
                    list ("Which TEF", whichtef), 
                    list ("Edit TEF", edittef), 
                    list ("Tool Help", helpcurtool), 
                    list ("Tool Descr", desccurtool));

/*
dm_menu := vcWv.MakeMenu ("Data Management",
                    list ("Browse Storage Data", browsepf),
                    list ("Checkpoint", checkPoint),
                    list ("Restore Checkpoint", restoreCheckPoint),
                    list ("List Checkpoint", listCheckPoint),
                    list ("Checkout", checkoutcmd),
                    list ("Checkin", checkincmd),
                    list ("Fetch - Read Only", fetchcmd),
                    list ("Cancel Checkout", cancelcheckoutcmd),
                    list ("Set Default", setdefcmd),
                    list ("Set Current", setcurcmd));
*/

main_menu =
    vcWv.MakeMenu ("Vframe",
                    vcWin.RedSquareEntry,
                    list ("Project", project_menu),
                    list ("Library", library_menu),
                    list ("Process", process_menu),
                    list ("Config", config_menu));
/*                    list ("Data Management", dm_menu));*/

vcFac.SetMenus (fac, main_menu);

function popup(e)
    vcMenuPop.create(process_menu,e);




