/* ------------------------------------------------------------------------ *\
 * $Id: vnav.vs,v 1.14 1994/02/04 16:17:49 dave Stab $
 * navigator viewscript stuff.
 *
 * Author: Bob Davis for George Deak
 * Just ask George.
 *
 * Copyright (c) 1992 by Viewlogic Systems, Inc.
 * Change log omitted to avoid huge comments.
\* ------------------------------------------------------------------------ */

/* Setup interrupt keys for display cancellation */
vcWv.interrupts(fac,
                '\e', '\^C', '\_\^C',
                '\F4', '\F5', '\F6', '\F7', '\F8', '\F9', '\F0',
                '\pgup', '\pgdn', '\home', '\end', '\up', '\down');

DesignCmd := vcWv.Cmd(fac, LoadDesign,
                      "Design", "Design",
                      vcWv.Param("Name", string, vcWv.Dynamic, Design),
                      vcWv.Param("Level", string, vcWv.Dynamic,
                                 DefaultLevel, vcWv.Secondary));

TrackCmd := vcWin.ReadErrorFileCmd;
DEBUG := printf;

function Prefs(nav, event)
{
    /* To load the preference code...*/
    if (!isbound(`EditPrefs, vcWin))
        load("vcPref.vs", vcWin);
    /* to open your facility preferences...*/
    vcWin.OpenPrefs(vnav.fac, vcEvent.Window(event), event);
} /* Prefs */
/*vcWv.Cmd(fac, Prefs, "Prefs", "Prefs");*/

PrefsCmd := vcWin.PrefsCmd;

PcbCmd := vcWv.Cmd(fac, SetPcb,
                   "PcbMode", "Pcb Mode",
                   vcWv.Param("Pcb Mode", vlOnOffVT, vcWv.Dynamic, Pcb));

function SearchForNet(nav, event, SearchType, Str)
{
    declare MatchStrs;
    win := vcEvent.Window(event);

    if (SearchType == vlnSearchType.Attribute)
        title := "Nets having attr's matching \"" + Str + "\"";
    else
        title := "Net " + convert(string, SearchType)
                 + "s matching \"" + Str + "\"";

    MatchStrs = MatchNetString(nav, Str, SearchType, win);

    if (MatchStrs != nil)
    {    
        PickIt(title, win, nav, MatchStrs, vlnFindType.Net);
        vcWin.ClearStatus(win);
    }
    else 
    {
        vcWin.ClearStatus(win);
        vcWin.AddStatus(win, "No matches found");
    } /* else */

    vcWin.Busy(win, FALSE);
} /* SearchForNet */

SearchForNetCmd := vcWv.Cmd(fac, SearchForNet,
                            "SearchForNet", "SearchForNet",
                            vcWv.Param("Search for:", vlnSearchTypeVT,
                                       vcWv.Sticky, vlnSearchType.Name),
                            vcWv.Param("Match String:",
                                       string, vcWv.Sticky, ""));
vcCmd.EnableApply(SearchForNetCmd, vlOnOff.On);

function SearchForComponent(nav, event, SearchType, Str)
{
    declare MatchStrs;
    win := vcEvent.Window(event);

    vcWin.Busy(win, TRUE);

    if (SearchType == vlnSearchType.Attribute)
        title := "Comps having attr's matching \"" + Str + "\"";
    else
        title := "Comp " + convert(string, SearchType)
                 + "s matching \"" + Str + "\"";

    MatchStrs = MatchCompString(nav, Str, SearchType, win);

    if (MatchStrs != nil)
    {
        PickIt(title, win, nav, MatchStrs, vlnFindType.Component);
        vcWin.ClearStatus(win);
    }
    else 
    {
        vcWin.ClearStatus(win);
        vcWin.AddStatus(win, "No matches found");
    } /* else */

    vcWin.Busy(win, FALSE);
} /* SearchForComponent */

SearchForComponentCmd := vcWv.Cmd(fac, SearchForComponent,
                                  "SearchForComponent", "SearchForComponent",
                                  vcWv.Param("Search for:", vlnSearchTypeVT,
                                             vcWv.Sticky, vlnSearchType.Name),
                                  vcWv.Param("Match String:",
                                             string, vcWv.Sticky, ""));
vcCmd.EnableApply(SearchForComponentCmd, vlOnOff.On);

function SearchForRefDes(nav, event, Str)
{
    declare MatchStrs;
    win := vcEvent.Window(event);

    vcWin.Busy(win, TRUE);

    title := "RefDes's matching \"" + Str + "\"";

    MatchStrs = MatchRefDesString(nav, Str, win);

    if (MatchStrs != nil)
    {
        PickIt(title, win, nav, MatchStrs, vlnFindType.RefDes);
        vcWin.ClearStatus(win);
    } 
    else 
    {
        vcWin.ClearStatus(win);
        vcWin.AddStatus(win, "No matches found");
    } /* else */

    vcWin.Busy(win, FALSE);
} /* SearchForRefDes */

SearchForRefDesCmd := vcWv.Cmd(fac, SearchForRefDes,
                               "SearchForRefDes", "SearchForRefDes",
                               vcWv.Param("Match String:",
                                          string, vcWv.Sticky, ""));
vcCmd.EnableApply(SearchForRefDesCmd, vlOnOff.On);

function SearchForPin(nav, event, Str)
{
    declare MatchStrs;
    win := vcEvent.Window(event);

    vcWin.Busy(win, TRUE);

    title := "Pins having attr's matching \"" + Str + "\"";

    MatchStrs = MatchPinAttribute(nav, Str, win);

    if (MatchStrs != nil)
    {
      
        PickIt(title, win, nav, MatchStrs,
               (Pcb(nav)
                ? vlnFindType.RefDes_PinNumber
                : vlnFindType.Component_PinName));
        vcWin.ClearStatus(win);
    }
    else {
        vcWin.ClearStatus(win);
        vcWin.AddStatus(win, "No matches found");
    } /* else */

    vcWin.Busy(win, FALSE);
} /* SearchForPin */

SearchForPinCmd := vcWv.Cmd(fac, SearchForPin,
                            "SearchForPin", "SearchForPin",
                            vcWv.Param("Attr Match String:",
                                       string, vcWv.Sticky, ""));
vcCmd.EnableApply(SearchForPinCmd, vlOnOff.On);

function PickIt(title, win, nav, strings, type)
{
    /* the facility */
    region := vcRegion.Create("vnavpick", vnavpick.fac,
                              list(title, nav, strings, type));
    vcRegion.Align(region, vgAlign.UpperCenter);
    /* the window */
/*    ListWin := vcWin.Popup(win, region, region, vcWin.NoBindings);*/
    ListWin := vcWin.Create(win, region, vcWin.NoBindings);
    
    vcWin.SetTitle(ListWin, title);
} /* PickIt */

/* 
** functions called by the selection/picklist facilities
*/
function AttachedFcn(nav, win, FindType, String)
{
    declare title;
    declare typestring;
    declare AttachedType;
    declare AttachedStrings;
    typestring = vnav.FindType2String(FindType);

    if (FindType == vnav.vlnFindType.Net) {
        title = "Pins attached to " + typestring + " \"" + String + "\"";
        if (vnav.Pcb(nav))
            AttachedType = vnav.vlnFindType.RefDes_PinNumber;
        else
            AttachedType = vnav.vlnFindType.Component_PinName;

        AttachedStrings = vnav.AttachedToNet(nav, String, win);
    } /* if */
    else if (FindType == vnav.vlnFindType.Component) {
        title = "Nets attached to " + typestring + " \"" + String + "\"";
        AttachedType = vnav.vlnFindType.Net;
        AttachedStrings = vnav.AttachedToComponent(nav, String);
    } /* else if */
    else if (FindType == vnav.vlnFindType.Component_PinName) {
        title = "Nets attached to Comp of Pin \"" + String + "\"";
        AttachedType = vnav.vlnFindType.Net;
        AttachedStrings = vnav.AttachedToComponentPinName(nav, String);
    } /* else if */
    else if (FindType == vnav.vlnFindType.RefDes) {
        title = "Nets attached to " + typestring + " \"" + String + "\"";
        AttachedType = vnav.vlnFindType.Net;
        AttachedStrings = vnav.AttachedToRefDes(nav, String);
    } /* else if */
    else if (FindType == vnav.vlnFindType.RefDes_PinNumber) {
        title = "Nets attached to RefDes of Pin \"" + String + "\"";
        AttachedType = vnav.vlnFindType.Net;
        AttachedStrings = vnav.AttachedToRefDesPinNumber(nav, String);
    } /* else if */

    if (AttachedStrings != nil)
        PickIt(title, win, nav, AttachedStrings, AttachedType);
} /* AttachedFcn */

function EquivalentFcn(nav, win, String)
{
    EquivStrings := vnav.EquivToNet(nav, String, win);

    if (EquivStrings != nil)
        PickIt("Nets equivalent to net \"" + String + "\"",
               win, nav, EquivStrings, vnav.vlnFindType.Net);
} /* EquivalentFcn */

function SheetsFcn(nav, win, String)
{
    SheetStrs := vnav.SheetsContainingNet(nav, String);

    if (SheetStrs != nil)
        PickIt("Sheets containing net \"" + String + "\"",
               win, nav, SheetStrs, vnav.vlnFindType.Sheet);
} /* SheetsFcn */

function ContentsFcn(nav, win, String)
{
    CompStrs := vnav.ComponentsOfRefDes(nav, String);

    if (CompStrs != nil)
        PickIt("Components of RefDes \"" + String + "\"",
               win, nav, CompStrs, vnav.vlnFindType.Component);
} /* ContentsFcn */

function VisitFcn(nav, event, design_name, location_str)
{
/*DEBUG("nav %s\n", nav);*/
/*DEBUG("design_name %s\n", design_name);*/
/*DEBUG("location_str %s\n", location_str);*/

    declare FindType;
    declare token;

    astr := string_token(location_str, &token, " ");
    str := StringLower(token);
/*DEBUG("astr %s\n", astr);*/
/*DEBUG("token %s\n", token);*/

    if (string_eq(str, "net"))
        FindType = vlnFindType.Net;
    else if (string_eq(str, "com"))
        FindType = vlnFindType.Component;
    else if (string_eq(str, "pkg"))
        FindType = vlnFindType.RefDes;
    else if (string_eq(str, "pin"))
        FindType = vlnFindType.Component_PinName;
    else if (string_eq(str, "ppn"))
        FindType = vlnFindType.RefDes_PinNumber;
    else if (string_eq(str, "sheet"))
        FindType = vlnFindType.Sheet;
    else if (string_eq(str, "sym"))
        FindType = vlnFindType.Symbol;
    else if (string_eq(str, "object"))
        FindType = vlnFindType.Object;
    else
        error("Undefined item type", str);

    astr := string_token(astr, &token, " ");
/*DEBUG("astr %s\n", astr);*/
/*DEBUG("token %s\n", token);*/
/*DEBUG("FindType %s\n", FindType);*/
/*DEBUG("Design(nav) %s\n", Design(nav));*/

    if (   design_name == nil
        || string_eq(design_name, "")
        || string_eq(design_name, Design(nav)))
        DoVisit(nav, FindType, token);
    else
        /* Load the proper design, since it's not the current one, */
        /* but only after getting confirmation from the user       */
        vcWv.OkOrCancel(vcEvent.Window (event),
"In order to visit this error location, the Navigator needs
to load a new design, discarding the old one.

OK to load new file?",
                        func() {
                            LoadDesign(nav, event,
                                       design_name, DefaultLevel(nav));
                            DoVisit(nav, FindType, token);
                        },
                        func(););
    nil; /* return value for use when called directly from "vcAlert.vs" */
} /* VisitFcn */

VisitCmd := vcWv.Cmd(fac, VisitFcn,
                     "visit", "visit",
                     vcWv.Param("Design", vlStringVT, vcWv.Dynamic, Design),
                     vcWv.Param("Item", vlStringRestOfLineVT,
                                vcWv.Sticky, ""));

function
EnableCommands(Loaded,          /* loaded a design or not */
               Pcb)             /* pcb mode */
{
    vcCmd.Enable(DesignCmd, TRUE);
    vcCmd.Enable(PrefsCmd, TRUE);
    vcCmd.Enable(PcbCmd, TRUE);

    vcCmd.Enable(TrackCmd, Loaded);

    vcCmd.Enable(SearchForNetCmd, Loaded);
    vcCmd.Enable(SearchForComponentCmd, Loaded);
    vcCmd.Enable(SearchForRefDesCmd, Loaded && Pcb);
    vcCmd.Enable(SearchForPinCmd, Loaded);

    vcCmd.Enable(VisitCmd, Loaded);
} /* EnableCommands */

/* Set the ini file name for prefs */
IniFileName := vcFac.Name(fac) + ".ini";

/* Include other navigator viewscript files. */

/* navigator selection/picklist facilities */
vcFac.Create("vnavpick", vscmVT);

load("vnavmn.vs");              /* menus */
load("vnavbt.vs");              /* bindings */
load("vnavht.vs");              /* help text */
