/***
 * Menus
 ***/
prop_menu := vcWv.MakeMenu("properties",
                            list ("Modes",cmodes_cmd),
                            list ("Values",cvalues_cmd));

select_menu := vcWv.MakeMenu ("select",
/*                               list ("Unselect",unselect_cmd), */
                               list ("Distance",sdist_cmd),
                               list ("Attr",satt_cmd),
                               list ("Net",snet_cmd),  
                               list ("RefDes", sref_cmd),
                               list ("DevType",stype_cmd));

view_menu := vcWv.MakeMenu ("view",
                             list ("Full",full_cmd),  
                             list ("Zoom",zoom_cmd),
                             list ("In",in_cmd),
                             list ("Out",out_cmd),
                             list ("Pan",pan_cmd),  
                             list ("Scroll",scroll_cmd),  
                             list ("Select",zselect_cmd),  
                             list ("Refresh", refresh_cmd));

parray_menu := vcWv.MakeMenu ("array",
                               list ("RefDes",refary_cmd),  
                               list ("CompType",typary_cmd),
                               list ("Net",netary_cmd));

style_menu := vcWv.MakeMenu ("style",
                              list ("Color",color_cmd),  
                              list ("Fill",fstyle_cmd),
                              list ("Line",lstyle_cmd));
/*                              list ("Join",jstyle_cmd),
                              list ("Cap",cstyle_cmd),
                              list ("Thickness",thick_cmd)); */

board_menu := vcWv.MakeMenu("board",
                             list ("Side",brdside_cmd),  
                             list ("Orientation",rotate_ol_cmd),  
                             list ("Outline",cbrd_cmd));

symbol_menu := vcWv.MakeMenu ("symbol",
                               list ("Size", bsize_cmd),
                               list ("Type", btype_cmd));

text_menu := vcWv.MakeMenu ("text",
                             list ("Font", font_cmd),
                             list ("Origin",origin_cmd),  
                             list ("Size",size_cmd),  
                             list ("String",string_cmd));

change_menu := vcWv.MakeMenu("change",
                              list ("Board",board_menu),
                              list ("Symbol",symbol_menu),
                              list ("AttrVis",attrvis_cmd),
                              list ("Text", text_menu));

xform_menu := vcWv.MakeMenu("xform",
/*                             list ("Reflect", reflect_cmd), */
                             list ("Rotate",rotate_cmd),  
                             list ("Scale",scale_cmd));

place_menu := vcWv.MakeMenu("place",
                             list ("Array", parray_menu),
                             list ("By RefDes",rman_cmd),  
                             list ("Next One",plcall_cmd),  
                             list ("XY",xyplc_cmd),
                             list ("Swap",swap_cmd),  
                             list ("Swap Side",swpside_cmd));

edit_menu := vcWv.MakeMenu ("edit",
                             list ("Move",move_cmd),  
                             list ("Delete",delete_cmd),  
                             list ("Undo",undo_cmd),  
                             list ("Copy",copy_cmd),  
                             list ("Stretch",stretch_cmd),  
                             list ("Xform",xform_menu),
                             list ("Array",array_cmd),  
                             list ("Style",style_menu),
                             list ("Attrs",cattr_cmd),
                             vcWv.Separator(),
                             list ("Rmv Rnst",rrmv_cmd),  
                             list ("SymOrigin",symorg_cmd));

util_menu := vcWv.MakeMenu ("util",
                             list ("Check", check_cmd),
/*                             list ("Read Attrs", rdatt_cmd), */
                             list ("SaveLog", savelog_cmd),
                             list ("Create Board", create_cmd),
                             list ("Update Board", update_cmd));

graphics_menu := vcWv.MakeMenu ("graphics",
                                 vcWv.Pin(),
                                 list ("Arc", arc_cmd),
                                 list ("Box", box_cmd),
                                 list ("Circle", circle_cmd),
                                 list ("Line", line_cmd),
                                 list ("Text", text_cmd));

add_menu := vcWv.MakeMenu ("add",
                            vcWv.Pin(),
                            list ("Attr",attr_cmd),
                            list ("Comp",comp_cmd),
                            list ("Label",label_cmd),
                            list ("Net",net_cmd),
                            list ("Pin",pin_cmd),
                            list ("Symbol",crdsym_cmd),
                            list ("Graphics",graphics_menu));

info_menu := vcWv.MakeMenu ("info",
                             list ("Boards",dbrd_cmd),
                             list ("Symbols",dsym_cmd),
                             list ("DirMem",dir_cmd),
                             list ("RefDes",rlist_cmd),
                             list ("Objects",odetail_cmd),
                             list ("Count",ocount_cmd),
                             list ("Nets",nlist_cmd),
                             list ("Status",status_cmd));

open_menu := vcWv.MakeMenu ("open",
                             list ("Board",vpbrd_cmd),  
                             list ("Symbol",vpsym_cmd));

file_menu := vcWv.MakeMenu ("file",
                             list ("Open",open_cmd),
/*                             list ("Close",close_cmd), */
                             list ("Read",read_cmd),  
                             list ("Write",write_cmd),  
                             list ("WriteTo",writeto_cmd),  
                             list ("Restore",restore_cmd));  
/*                             list ("Exit",quit_cmd)); */


main_menu := vcWv.MakeMenu ("vplace",
                             vcWin.RedSquareEntry,
                             list ("File",file_menu),
                             list ("View",view_menu),
                             list ("Edit",edit_menu),
                             list ("Place", place_menu),
                             list ("Change",change_menu),
                             list ("Add",add_menu),
                             list ("Select",select_menu),
                             list ("Info",info_menu),
                             list ("Props",prop_menu),
                             list ("Utils",util_menu));

vcFac.SetMenus (fac, main_menu);

/*-*/
/* Main pop-up menus */
add_popup_menu := vcWv.MakeMenu("add",
                                 vcWv.Pin(),
                                 list("Pin",pin_cmd),
                                 list("Box",box_cmd),
                                 list("Circle",circle_cmd),
                                 list("Label",label_cmd),
                                 list("Attribute",attr_cmd),
                                 list("Text",text_cmd));

board_popup_menu := vcWv.MakeMenu("board",
                                   vcWv.Pin(),
                                   list("Move",move_cmd),
                                   list("Delete",delete_cmd),
                                   list("Undo",undo_cmd),
                                   list("Remove Rats",rrmv_cmd),
                                   list("Place By Refdes",rman_cmd),
                                   list("Place Next",plcall_cmd),
                                   list("Net",net_cmd),
                                   list("Area View",zoom_cmd),
                                   list("Full View",full_cmd),
                                   list("Add",add_popup_menu));

symbol_popup_menu := vcWv.MakeMenu("symbol",
                                    vcWv.Pin(),
                                    list("Move",move_cmd),
                                    list("Delete",delete_cmd),
                                    list("Undo",undo_cmd),
                                    list("Copy",copy_cmd),
                                    list("Stretch",stretch_cmd),
                                    list("Area View",zoom_cmd),
                                    list("Full View",full_cmd),
                                    list("Add",add_popup_menu));

