/*
 * $Revision: 1.55.2.2 $
 */

max_buffer_size := 2048;
load ("vst_vsim.vs");

cmd_list := list (
    "saber",
    "sab",
    "time_measurement",
    "tm",
    "log_vectors",
    "lv",
    "restart",
    "continue",
    "radix",
    "pfg",
    "report",
    "type",
    "break",
    "b",
    "help",
    "statistics",
    "stats",
    "network",
    "net",
    "check",
    "(",
    "vector",
    "v",
    "pattern",
    "pat",
    "path",
    "activity",
    "act",
    "assign",
    "a",
    "changes",
    "ch",
    "execute",
    "ex",
    "logfile",
    "log",
    "d",
    "display",
    "x",
    "h",
    "l",
    "r",
    "watch",
    "w",
    "trace",
    "t",
    "wave",
    "inputs",
    "stepsize",
    "step",
    "wfm",
    "sim",
    "s",
    "info",
    "clock",
    "ck",
    "run",
    "cycle",
    "c",
    "echo",
    "debug",
    "save",
    "restore",
    "rest",
    "delay",
    "defaults",
    "dflts",
    "print",
    "every",
    "after",
    "af",
    "loadm",
    "loadmem",
    "loads",
    "loadstate",
    "wavexfer",
    "ticksize",
    "dumpm",
    "flush",
    "exit",
    "quit",
    "q",
    "probe",
    "fault",
    "list",
    "testpoints",
    "tp",
    "toggle",
    "threshold",
    "dictionary",
    "ffs_debug",
    "sched_debug",
    "show",
    "sh",
    "strace",
    "sdisplay",
    "stop",
    "delete",
    "accel",
    "noaccel",
    "monitor",
    "activate",
    "vsimsys",
    "source");

function build_cmd(str)
    vcWv.Cmd (fac,
              func(d,e,line) SendCmd (str + " " + convert (vlStringVT, line));,
              str, str,
              vcWv.Param ("", vlStringRestOfLineVT, vcWv.Constant, ""));

for (; cmd_list != nil; cmd_list = cdr (cmd_list))
    build_cmd (car (cmd_list));






declare command_text;  /* make global so we don't have to get it everytime */

function echo_cmd(cmd, event)
{
    if (command_text == nil)
       command_text = GetCmdVtx();
    
    if (event == nil) {
        a := vcRegion.VisibleArea (command_text);
        event = vcEvent.Create ((vgRect.Xmin (a) + vgRect.Xmax (a)) / 2,
                                (vgRect.Ymin (a) + vgRect.Ymax (a)) / 2,
                                '\0',
                                cmd,
                                vcRegion.Window (command_text),
                                command_text,
                                nil);
    } /* if */

    vcTxShell.TypeIn (command_text, cmd, TRUE, event);
}




function cmd(cmdname, abbrev, params) {
    function send_strings (args...) {
        declare str, st, e, a;

        st  = car (args); args = cdr (args);
        e   = car (args); args = cdr (args);
        for (str = abbrev; !null(args); args = cdr (args)) {
            a = car (args);
	    if (istype (a, non_null_stringVT)) a = convert (vlStringVT, a);
            str = string_append (str, " ",
                                 (istype (a, vlStringVT) ? (a) :
                number2string (a)));
        } /* for */


        /* insert the string into the viewtext buffer */
        echo_cmd(str, e);

    }
    vcCmd.Create (fac, send_strings, cmdname, abbrev, params);
}


function foreach_cmd_1 (cmdname, abbrev, params)
{
    function foreach_send_strings (args...)
    {
        declare str, st, e, a;

        st  = car (args); args = cdr (args);
        e   = car (args); args = cdr (args);

	a = car (args);
	if (istype (a, non_null_stringVT)) a = convert (vlStringVT, a);
	a = istype (a, vlStringVT) ? (a) : number2string(a);

	str = "( ";
	foreach (tok;  string_loop (a, "\" "))
            str = str + abbrev + " " + tok + "; ";
	str = str + ")";

        /* insert the string into the viewtext buffer */
        echo_cmd(str, e);
    }
    vcCmd.Create (fac, foreach_send_strings, cmdname, abbrev, params);
}


function foreach_cmd_2 (cmdname, abbrev, params)
{
    function foreach_send_strings (args...)
    {
        declare str, st, e, a, b;

        st = car (args); args = cdr (args);

        e = car (args); args = cdr (args);
	a = car (args); args = cdr (args);
	a = convert (vlStringVT, a);
	a = istype (a, vlStringVT) ? (a) : number2string(a);

	b = car (args); args = cdr (args);
	b = convert (vlStringVT, b);
	b = istype (b, vlStringVT) ? (b) : number2string(b);

	str = "( ";
	foreach (tok;  string_loop (a, "\" ")) {
            str = str + abbrev + " " + tok + " " + b + "; ";
	    /*
	    foreach (val;  string_loop (b, "\" "))
		str = str + " " + val;
	    str = str + " ; ";
	    */
	}
	str = str + ")";

        /* insert the string into the viewtext buffer */
        echo_cmd(str, e);
    }
    vcCmd.Create (fac, foreach_send_strings, cmdname, abbrev, params);
}


function foreach_cmd_3 (cmdname, abbrev, params)
{
    function foreach_send_strings (args...)
    {
        declare str, st, e, a, b, c;

        st = car (args); args = cdr (args);

        e = car (args); args = cdr (args);
	a = car (args); args = cdr (args);
	if (istype (a, non_null_stringVT)) a = convert (vlStringVT, a);
	a = istype (a, vlStringVT) ? (a) : number2string(a);

	b = car (args); args = cdr (args);
	if (istype (b, non_null_stringVT)) b = convert (vlStringVT, b);
	b = istype (b, vlStringVT) ? (b) : number2string(b);

	c = car (args); args = cdr (args);
	if (istype (c, non_null_stringVT)) c = convert (vlStringVT, c);
	c = istype (c, vlStringVT) ? (c) : number2string(c);

	str = "( ";
	foreach (tok;  string_loop (a, "\" ")) {
            str = str + abbrev + " " + tok + " " + b + " " + c + "; ";
	    /*
	    foreach (val;  string_loop (b, "\" "))
		str = str + " " + val;
	    str = str + " ; ";
	    */
	}
	str = str + ")";

        /* insert the string into the viewtext buffer */
        echo_cmd(str, e);
    }
    vcCmd.Create (fac, foreach_send_strings, cmdname, abbrev, params);
}


function cmd_bool (cmdname, abbrev, true_str, false_str, params) {
    function send_strings_bool (args...) {
        declare str, st, e, a;

        st  = car (args); args = cdr (args);
        e   = car (args); args = cdr (args);
        for (str = abbrev; !null(args); args = cdr (args)) {
            a = car (args);
	    if (istype (a, vlOnOffVT)) {
		if (equal (a, vlOnOff.On)) {
		    a = true_str;
		} else {
		    a = false_str;
		}
	    } else if (istype (a, non_null_stringVT)) {
		a = convert (vlStringVT, a);
	    }
            str = string_append (str, " ",
                                 (istype (a, vlStringVT) ? (a) :
                number2string (a)));
        } /* for */


        /* insert the string into the viewtext buffer */
        echo_cmd(str, e);

    }
    vcCmd.Create (fac, send_strings_bool, cmdname, abbrev, params);
}


function del_foreach_cmd_1 (cmdname, abbrev, params)
{
    function foreach_send_strings (args...)
    {
        declare str, st, e, a;

        st  = car (args); args = cdr (args);
        e   = car (args); args = cdr (args);

	a = car (args);
	if (istype (a, non_null_stringVT)) a = convert (vlStringVT, a);
	a = istype (a, vlStringVT) ? (a) : number2string(a);

	str = "( ";
	foreach (tok;  string_loop (a, "\" "))
            str = str + abbrev + " -" + tok + "; ";
	str = str + ")";

        /* insert the string into the viewtext buffer */
        echo_cmd(str, e);
    }
    vcCmd.Create (fac, foreach_send_strings, cmdname, abbrev, params);
}

function del_cmd(cmdname, abbrev, params) {
    function send_strings (args...) {
        declare str;

        str = string_append (abbrev, " -", caddr (args));
        echo_cmd(str, cadr (args));
    }
    vcCmd.Create(fac, send_strings, cmdname, cmdname , params);
}


function GetNodeSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(2);

    /* RSM - 10/25/91 Then check for selected nets in Veiwdraw */
    if(string_eq(str,""))
        str = GetItcSelect();

    /* then check X cut buffer */
/*    if (string_eq(str,""))
         str = vcWv.FetchCutBuffer(wv);
*/
    return(str);
}

function get_wdesign() {
    design := vscript.getenv ("WDESIGN");
    if (design == nil)
        design = GetNetName ();
    if (string_eq (design, "viewsim") || (design == nil))
        design = vcWv.NoDefault;
    design;
} /* function get_wdesign */

function make_get_wdesign(ext) {
    func(sim_data) {
        design := get_wdesign ();
        if (design != vcWv.NoDefault)
            design += ext;
        design;
    };
} /* function make_get_wdesign */


function GetVariableSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(2);

    if(string_eq(str,""))
        str = GetNavSelect(32);

    /* RSM - 10/25/91 Then check for selected nets in Veiwdraw */
    if(string_eq(str,""))
        str = GetItcSelect();

    /* then check X cut buffer */
/*    if (string_eq(str,""))
         str = vcWv.FetchCutBuffer(wv);
*/
    return(str);
}

function GetSourceSelection(vs) {
    str := GetNavSelect(16);

    if(string_eq(str,""))
        str = GetNavSelect(64);

    if(string_eq(str,""))
        str = GetNavSelect(8);

    return(str);
}

function GetProcessSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(16);

    if(string_eq(str,""))
        str = GetNavSelect(64);

    return(str);
}

function GetSubprogramSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(8);

    return(str);
}


function GetBreakSelection(vs) {
    /* first check in navigator window */
    str := GetNavSelect(4);

    return(str);
}






function GetSelection(vs) {
    vcWv.FetchCutBuffer(wv);

}
s_run := 	cmd ("s_run", "run", nil);
s_sim := 	cmd ("s_sim", "sim", nil);
s_cycle := 	cmd ("s_cycle", "c", nil);

s_continue := 	cmd ("s_continue", "continue", nil);

s_stop := 	vcWv.Cmd(fac, NotifyStop);

s_restart := 	cmd ("s_restart", "restart", nil);
s_activate := 	vcWv.Cmd(fac, ActivateProc);


s_sstep := 	cmd ("sim step", "sim step", nil);
s_sphase := 	cmd ("sim phase", "sim phase", nil);
s_sprocess := 	cmd ("sim process", "sim process", nil);
s_sdelta := 	cmd ("sim delta", "sim delta", nil);
s_send := 	cmd ("sim end", "sim end", nil);
s_snext := 	cmd ("sim snext", "sim next", nil);
s_sover := 	cmd ("sim over", "sim over", nil);


s_bline := 	vcWv.Cmd(fac, BreakAtLine);

s_bsubp := 	vcWv.Cmd(fac, BreakAtSubp);
s_bsignal := 	vcWv.Cmd(fac, BreakAtSignal);
s_bprocess := 	vcWv.Cmd(fac, BreakAtProcess);
s_bdelete := 	vcWv.Cmd(fac, BreakDelete);
s_bshow :=  	vcWv.Cmd(fac, BreakShow);


s_d := 		cmd ("s_display", "d", 
           		list(	vcWv.Param("Node:", vlStringVT, 
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_d, vlOnOff.On);

s_d_sch := 		cmd ("s_display_sch", "sdisplay", 
           		list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));

vcCmd.EnableApply(s_d_sch, vlOnOff.On);

s_d_all := 	cmd ("s_display_all", "d *", nil);
s_d_all_sch := 	cmd ("s_display_all_sch", "sdisplay *", nil);



s_dsource := 		cmd ("s_dsource", "source ", 
			list(	vcWv.Param("arguments:" , vlStringVT, 
					vcWv.Dynamic, GetSourceSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_dsource, vlOnOff.On);

s_devents := 	vcWv.Cmd(fac, DisplayEvents);
s_dactives := 	vcWv.Cmd(fac, DisplayActives);
s_display := 	cmd ("s_display_", "d", nil);
s_inputs := 	cmd ("s_inputs", "inputs", nil);
s_path := 	cmd ("s_path", "path",
    			list(	vcWv.Param("Nodes/Vectors:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_path, vlOnOff.On);

s_stats := 	cmd ("s_stats", "stats", nil);
s_info := 	cmd ("s_info", "info",
    			list(vcWv.Param("Nodes/Vectors:" , vlStringVT, 
				vcWv.Dynamic, GetNodeSelection,
				vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_info, vlOnOff.On);

s_stepsize := 	cmd ("s_stepsize", "stepsize", nil);
s_changes := 	cmd ("s_changes", "changes",
    			list(	vcWv.Param("From Time", vlStringVT,  
					vcWv.Sticky, 0),
         			vcWv.Param("To Time", vlStringVT,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_changes, vlOnOff.On);

s_time := 	cmd ("s_echo", "echo Simulation time = %time", nil);
s_defaults := 	cmd ("s_defaults", "defaults", nil);
s_report := 	cmd ("s_report", "report", nil);


s_l := 		cmd ("s_l", "l", 
			list(	vcWv.Param("Nodes:" , vlStringVT, 
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_l, vlOnOff.On);


s_h := 		cmd ("s_h", "h", 
			list(	vcWv.Param("Nodes:" , vlStringVT, 
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_h, vlOnOff.On);

s_x := 		cmd ("s_x", "x", 
			list(	vcWv.Param("Nodes:" , vlStringVT, 
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_x, vlOnOff.On);


s_assign := 	cmd ("s_assign", "a",
    			list(	vcWv.Param("Node/Vector", vlStringVT,  
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size),
         			vcWv.Param("Value", vlStringVT,  vcWv.Constant, "",
				vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_assign, vlOnOff.On);

s_r := 		cmd ("s_r", "r",  
			list(	vcWv.Param("Nodes:" , vlStringVT, 
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));

vcCmd.EnableApply(s_r, vlOnOff.On);


s_oqueue := 	vcWv.Cmd(fac,DbgQueueHandler);
s_omonitor := 	vcWv.Cmd(fac,DbgRegsHandler);
/* nav_cmd := 	vcWv.Cmd(fac,vsimNav.vsimNavCreate); */
nav_cmd := 	vcWv.Cmd(fac,DbgNavHandler);
s_oanalyzer := 	vcWv.Cmd(fac, DbgAnalyzerHandler);


s_wave := 	cmd_bool ("s_wave", "wave", "", "noitc",
			/*  SS -- [noitc] option for the wave command
			 */
			list (	vcWv.Param ("ITC:", vlOnOffVT,
                                      vcWv.Sticky, TRUE),
				vcWv.Param("Stream:" , non_null_stringVT,
                                      vcWv.Dynamic, make_get_wdesign (".wfm")),
         			vcWv.Param("Nodes/Vectors:" , vlStringVT,
				      vcWv.Dynamic, GetVariableSelection,
				      vcCmdline.fac, max_size <- max_buffer_size)));



s_setwfm := 	cmd("s_setwfm", "wfm",
    			list(	vcWv.Param("Nodes/Vectors:" , vlStringVT,
					 vcWv.Dynamic, GetNodeSelection,
					 vcCmdline.fac, max_size <- max_buffer_size),
				vcWv.Param("Pattern:" , vlStringVT, 
					vcWv.Constant, "")));
vcCmd.EnableApply(s_setwfm, vlOnOff.On);


s_trace := 	cmd("s_trace", "trace",
    			list(	vcWv.Param("Node:" , vlStringVT, 
				vcWv.Dynamic, GetVariableSelection,
				vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_trace, vlOnOff.On);

s_monitor := 	foreach_cmd_1 ("s_monitor", "monitor",
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_monitor, vlOnOff.On);

s_monitor_sch := 	cmd("s_monitor_sch", "strace",
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_monitor_sch, vlOnOff.On);


/* Don't change the name s_net for the net command, is referenced
   in C routine */

vcWv.RequireFac (wv, "vanEAC");

function default_design_name(sim_data) {
    design := get_wdesign ();
    if ((design != vcWv.NoDefault) && fexists (design + ".vsm"))
        design + ".vsm";
    else
        design;
} /* function default_design_name */

s_mnunet := cmd ("s_net", "net",
                 list( vcWv.Param ("Design Name" , vlStringVT,  
                                   vcWv.Dynamic, default_design_name,
                                   vanEAC.fac)));
vcCmd.EnableApply(s_mnunet, vlOnOff.On); /* ????? */

s_cmd := 	cmd ("s_cmd", "execute", 
    			list(	vcWv.Param("Filename:" , vlStringVT,  
					vcWv.Dynamic, make_get_wdesign(".cmd"),
					vcFilePop.fac, filter <- "*.cmd")));
vcCmd.EnableApply(s_cmd, vlOnOff.On);

s_log := 	cmd ("s_log", "execute",
    			list(	vcWv.Param("Filename:" , vlStringVT,  
					vcWv.Dynamic, make_get_wdesign(".log"),
					vcFilePop.fac, filter <- "*.log")));
vcCmd.EnableApply(s_log, vlOnOff.On);

s_type := 	cmd ("s_type", "type",
    			list(	vcWv.Param("Filename:" , vlStringVT,  
					vcWv.Sticky, "",
					vcFilePop.fac, filter <- "*.log")));
vcCmd.EnableApply(s_type, vlOnOff.On);

s_help := 	cmd ("s_help", "help", 
    			list(	vcWv.Param("Topic:" , vlStringVT,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_help, vlOnOff.On);


s_dtrace := 	del_foreach_cmd_1 ("s_dtrace", "trace",
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_dtrace, vlOnOff.On);

s_dtrace_all := cmd ("s_dtrace_all", "t -*", nil);


s_brkpnt := 	cmd ("s_brkpnt", "break",
    			list(	vcWv.Param("Nodes" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_brkpnt, vlOnOff.On);

s_brkpnt_all :=	cmd ("s_brkpnt_all", "break", nil);
s_set_brkpnt :=	foreach_cmd_3 ("s_break", "break", 
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size),
				vcWv.Param("Circuit Event:" , vlStringVT,  
					vcWv.Sticky, "?"),
				vcWv.Param("Do Commands" , vlStringVT,  
					vcWv.Sticky, " do (print)")));

vcCmd.EnableApply(s_set_brkpnt, vlOnOff.On);

s_set_brkpnt_line :=	cmd ("s_break_line", "stop at ", 
    			list(   vcWv.Param("File Name:" , vlStringVT,  
					vcWv.Sticky, ""),
				vcWv.Param("Line Number" , vlStringVT,  
					vcWv.Sticky, "")));

vcCmd.EnableApply(s_set_brkpnt_line, vlOnOff.On);


s_set_brkpnt_process :=	cmd ("s_break_process", "stop in ", 
    			list(   vcWv.Param("Process Instance Name:" , vlStringVT,  
					vcWv.Dynamic, GetProcessSelection)));

vcCmd.EnableApply(s_set_brkpnt_process, vlOnOff.On);

s_set_brkpnt_subprogram :=	cmd ("s_break_subprogram", "stop in ", 
    			list(   vcWv.Param("Subprogram Name:" , vlStringVT,  
					vcWv.Dynamic, GetSubprogramSelection)));

vcCmd.EnableApply(s_set_brkpnt_subprogram, vlOnOff.On);


s_set_brkpnt_signal :=	foreach_cmd_2 ("s_break_signal", "break", 
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size),
				vcWv.Param("Circuit Event:" , vlStringVT,  
					vcWv.Sticky, "?")));


vcCmd.EnableApply(s_set_brkpnt_signal, vlOnOff.On);





s_delete_brkpnt :=	cmd("s_delete_brkpnt", "delete", 
    			list(	vcWv.Param("Breakpoint id:" , vlStringVT,  
					vcWv.Dynamic, GetBreakSelection)));


vcCmd.EnableApply(s_delete_brkpnt, vlOnOff.On);








s_ck := 	foreach_cmd_1 ("s_ck", "clock",
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_ck, vlOnOff.On);


s_ck_all :=	cmd ("s_ck_all", "clock", nil);



s_reporttiming :=	cmd ("s_reporttiming", "report timing", nil);
s_report_timing := 	cmd ("s_report-timing", "report -timing", nil);

s_reportstability :=	cmd ("reportstability", "report stability", nil);
s_report_stability := 	cmd ("report-stability", "report -stability", nil);


s_reportspikes :=	cmd ("report spikes", "report spikes", nil);
s_report_spikes := 	cmd ("report -spikes", "report -spikes", nil);

s_reportall := 		cmd ("report spikes timing stability memerrs hwmx",
			"report spikes timing stability memerrs hwmx", nil);
s_report_all := 	cmd ("report -spikes -timing -stability -memerrs -hwmx",
			"report -spikes -timing -stability -memerrs -hwmx", nil);


s_defaultbignet :=	cmd ("defaults bignet", "defaults bignet", nil);
s_default_bignet := 	cmd ("defaults -bignet", "defaults -bignet", nil);


s_defaultcmdfile :=	cmd ("defaults cmdfile", "defaults cmdfile", nil);
s_default_cmdfile := 	cmd ("defaults -cmdfile", "defaults -cmdfile", nil);

s_defaultwatch :=	cmd ("defaults watch", "defaults watch", nil);
s_default_watch := 	cmd ("defaults -watch", "defaults -watch", nil);

s_defaulttime :=	cmd ("defaults time", "defaults time", nil);
s_default_time := 	cmd ("defaults -time", "defaults -time", nil);



s_mindelay :=		cmd ("s_mindelay", "delay min", nil);
s_maxdelay :=		cmd ("s_maxdelay", "delay max", nil);
s_typdelay :=		cmd ("s_typdelay", "delay typ", nil);
s_transportdelay :=	cmd ("s_transportdelay", "delay transport", nil);
s_inertialdelay :=	cmd ("s_inertialdelay", "delay inertial", nil);
s_fixedvaldelay :=	cmd ("s_fixedvaldelay", "delay", 
    			list(	vcWv.Param("Value:" , vlStringVT,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_fixedvaldelay, vlOnOff.On);

s_scaledelay :=		cmd ("delay scale", "delay scale", 
    			list(	vcWv.Param("Value:" , vlStringVT,  
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_scaledelay, vlOnOff.On);

s_delay := 		cmd ("s_delay", "delay", nil);

s_v := 		cmd ("s_vector", "vector",
    			list(	vcWv.Param("Vector name:" ,non_null_stringVT, 
					vcWv.Sticky, "XXX"),
         			vcWv.Param("Nodes/Vectors:" , vlStringVT,
					 vcWv.Dynamic, GetNodeSelection,
					 vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_v, vlOnOff.On);

s_setpat := 	cmd ("s_setpattern", "pattern",
    			list(	vcWv.Param("Node/Vector:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size),
         			vcWv.Param("Pattern sequence:" , vlStringVT,
					vcWv.Constant, "")));
vcCmd.EnableApply(s_setpat, vlOnOff.On);

s_clock := 	cmd ("s_clock", "clock",
    			list(	vcWv.Param("Node/Vector:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size),
        			vcWv.Param("Transition sequence:" , vlStringVT,
					 vcWv.Constant, "")));
vcCmd.EnableApply(s_clock, vlOnOff.On);

s_step := 	cmd ("s_step", "stepsize",
    			list(	vcWv.Param("Stepsize:" , vlStringVT, 
					vcWv.Sticky, "")));
vcCmd.EnableApply(s_step, vlOnOff.On);


vcWv.MakeEnum ("BaseVT", list ("bin", "dec", "hex", "oct", "vhd"));

s_radix := 	foreach_cmd_2 ("s_radix", "radix",
		    list(vcWv.Param("Base:", BaseVT, vcWv.Sticky,Base.hex),
			 vcWv.Param("Vector:", vlStringVT, 
				    vcWv.Dynamic, GetVariableSelection,
				    vcCmdline.fac, max_size <- max_buffer_size)));

/* HACK!  need enum here; bin, hex, oct, dec */
/*
s_radix := 	cmd ("s_radix", "radix", 
    			list(	
				vcWv.Param("Base[hex/dec/bin/oct]" , vlStringVT,
					 vcWv.Sticky, "hex"),

				vcWv.Param("Vector:" , vlStringVT, 
					vcWv.Sticky, "")));
*/
vcCmd.EnableApply(s_radix, vlOnOff.On);

s_w := 		cmd ("s_w", "w",
    			list(	vcWv.Param("Nodes/Vectors:" , vlStringVT,
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_w, vlOnOff.On);

s_t :=		cmd ("s_t", "t",
    			list(	vcWv.Param("Nodes/Vectors:" , vlStringVT,
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_t, vlOnOff.On);

s_print := 	cmd ("s_print", "print", nil);
s_act := 	cmd ("s_activity", "activity",
    			list(	vcWv.Param("Start time:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size),
         			vcWv.Param("End time:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_act, vlOnOff.On);

s_logfile := 	cmd ("s_logfile", "logfile",
    			list(	vcWv.Param("Filename:" , vlStringVT, 
					vcWv.Sticky, "",  vcFilePop.fac, filter <- "*.log")));
vcCmd.EnableApply(s_logfile, vlOnOff.On);

s_watch := 	del_foreach_cmd_1 ("s_watch", "watch",
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_watch, vlOnOff.On);

s_watch_all := 	cmd ("s_watch_all", "w -*", nil);
s_wfm := 	foreach_cmd_1 ("s_wfm", "wfm",
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_wfm, vlOnOff.On);

s_wfm_all := 	cmd ("s_wfm_all", "wfm", nil);
s_pat := 	foreach_cmd_1 ("s_pat", "pattern",
    			list(	vcWv.Param("Node:" , vlStringVT, 
					vcWv.Dynamic, GetNodeSelection,
					vcCmdline.fac, max_size <- max_buffer_size)));
vcCmd.EnableApply(s_pat, vlOnOff.On);

s_pattern := 	cmd ("s_pattern", "pattern", nil);

function run_vansetup(s, event) {
    vcWin.WithBusy (vcEvent.Window (event), func() {
        vcWv.RequireFac (wv, "vansetup");
        vansetup.Run ();
    });
} /* function run_vansetup */

s_vansetup := vcWv.Cmd (fac, run_vansetup, "run_vansetup");

function run_vananalyze(s, event) {
    vcWin.WithBusy (vcEvent.Window (event), func() {
        vcWv.RequireFac (wv, "vansetup");
        vcCmd.Run (vananalz.analyze_without_setup_cmd, vcEvent.Window (event),
                   event, nil, TRUE);
    });
} /* function run_vananalyze */

s_vananalyze := vcWv.Cmd (fac, run_vananalyze, "run_vananalyze");


function edit_val(d, e, signal_name, cmd_filename) {

    /*  print_item -- is a convenience function for printing out individual
     *  items as well as detecting end of printable line, putting newline, etc.
     */
    function print_item (item, indent_level, item_num, max_items, delimiter, vt)
    {
	if (item_num >= max_items)
	{
	    vtx.AppendString (vt, sprintf ("%s%s +\n", item, delimiter));
	    item_num = 0;
	}
	else
	    vtx.AppendString (vt, sprintf ("%s%s", item, delimiter));
	item_num;
    }

    /*  how we do it ?
     *
     *  the callback "vsim.GetObjValue()" gets the value string of the 
     *  given signal_name;
     *  it is then pretty printed onto a viewtext window,
     *  after the user has done editing, she/he presses assign/dismiss
     *  upon which teh contents of the viewtext is dumped in the given
     *  cmd_filename (if given, else into a temp file) and it is executed
     *  which results in the assignment...
     */
    declare s;

    signal_name   = string_trim (signal_name);

    vt           := vcRegion.Create ("", vtx.fac, "", load_file <- FALSE);
    item         := "";
    item_num     := 0;
    max_items    := 8;
    num_spaces   := 0;
    indent_level := "";
    inside_quote := FALSE;

    val_buf      := vsim.GetObjValue (signal_name);
    val_len      := string_length (val_buf);

    if (val_len < 70)
    {
	vtx.AppendString (vt, sprintf ("assign %s \"%s", signal_name,
				       string_trim (val_buf)));
    }
    else
    {
	vtx.AppendString (vt, sprintf ("assign %s \"", signal_name));

	/*  indent the string to present a more -editable- value
	 *
	 *  the heuristic for pretty printing the string is:-
	 *  for every open-paren, increase the indent_level by id_space (4)
	 *  for every close-paren, decrease the indent_level by id_spacw (4)
	 *  do not print more than max_items (8) per line for readbility
	 *  item is defined as anything between commas, parentheses, etc
	 *  also, anything between quotes is not-parsed and added to item
	 */

	val_buf  = string_trim (val_buf);
	s        = val_buf;

	for (i := 0;  i < val_len;  ++i)
	{
	    ch := s[i];

	    if (ch == '\''  &&  inside_quote)
	    {
		/*  end of quote
		 */
		item += string_var (ch);
		inside_quote = FALSE;
	    }
	    else if (ch == '\''  &&  ! inside_quote)
	    {
		/*  beginning of quote
		 */
		inside_quote = TRUE;
		item = string_var (ch);
	    }
	    else if (inside_quote)
		/*  just add char to item if quoted
		 */
		item += string_var (ch);
	    else if (ch == ',')
	    {
		/*  this indicates end of item/array/record...
		 *  this is the right time to print the accumalated item
		 */
		if (item_num == 0  &&  string_eq (item, ""))
		    /*  dont' print anything if there is nothing to print
		     *  just add "," to viewtext window
		     */
		    vtx.AppendString (vt, ", +\n");
		else
		{
		    /*  indent if this is the first element being printed
		     *  for this line
		     */
		    if (item_num == 0)
			vtx.AppendString (vt, indent_level);

		    ++item_num;
		    item_num = print_item (item, indent_level, item_num,
					   max_items, ",", vt);
		    item = "";
		}
	    }
	    else if (ch == '(')
	    {
		/*  a left parentheses, opening of a new level
		 */
		if (item_num == 0  &&  string_eq (item, ""))
		    /*  if nothing was accumlated, don't terminate the line
		     */
		    vtx.AppendString (vt, sprintf ("%s( +\n",indent_level));
		else
		    /*  terminate the line and then print '('
		     */
		    vtx.AppendString (vt, sprintf (" +\n%s( +\n",indent_level));

		/*  increase indent_level/space
		 */
		indent_level += "    ";
		num_spaces   += 4;
		item     = "";
		item_num = 0;
	    }
	    else if (ch == ')')
	    {
		/*  right parentheses, end of a level
		 */

		/*  if some thing has been accumalated, then print it
		 */
		if (item_num != 0  ||  ! string_eq (item, ""))
		{

		    /*  if first element of the line, do indentation
		     */
		    if (item_num == 0)
			vtx.AppendString (vt, indent_level);

		    item_num = print_item (item, indent_level, item_num,
					   max_items, " ", vt);
		}
		item = "";

		/*  if line is not yet terminated, terminate it
		 */
		if (item_num > 0)
		    vtx.AppendString (vt, " +\n");

		/*  decrease the indent_level
		 */
		if (num_spaces >= 4)
		{
		    indent_level = substring (indent_level, 0, num_spaces - 4);
		    num_spaces  -= 4;
		}

		/*  print right paren
		 */
		vtx.AppendString (vt, sprintf ("%s)", indent_level));
		item_num = 0;
	    }
	    else if (ch != '\n'  &&  ch != '\t')
		item += string_var (ch);
	}
    } /* while */

    if (val_len == 0)
    {
        vcRegion.Destroy (vt);
    } /* if */
    else
    {
        vtx.AppendString (vt, "\"\n");

        function do_assign()
	{
            if (string_eq (cmd_filename, ""))
	    {
                fname := vsUnique (".");
                vtx.Writeto (vt, fname);
                echo_cmd ("execute " + fname, e);
                /* vsDelete (fname, vsAttr.File); */
            }
            else
	    {
                vtx.Writeto (vt, cmd_filename);
                echo_cmd ("execute " + cmd_filename, e);
            }

	    vcWin.Close (win);

        } /* function do_assign */

        button_row := vcRegion.Create ("", vcButnRow.fac,
                                       list (list ("assign", "Assign",
                                                   do_assign, nil),
                                             list ("dismiss", "Dismiss",
                                                   vcWin.wclose, nil)));
        win := vcWin.Create (vcEvent.Window (e),
                      vcTable.Make ("Edit Value of " + signal_name,
                                      2, 1, vt, button_row));
    } /* else */
} /* function edit_val */

editval_cmd := vcWv.Cmd (fac, edit_val, "editval", "Edit Value",
                         vcWv.Param ("Signal name", vlStringVT,
					vcWv.Dynamic, GetVariableSelection,
					vcCmdline.fac, max_size <- max_buffer_size),
                         vcWv.Param ("Cmd Filename", vlStringRestOfLineVT,
                                     vcWv.Sticky, "", vcWv.Secondary,
                                     "If specified, the completed assign command is left in this file"));

load("vsimmn.vs");
load("vsimbt.vs");

function vsEnableCmds(on_off) {
    vcCmd.Enable (s_monitor, on_off);
    vcCmd.Enable (s_oqueue, on_off);
    vcCmd.Enable (s_omonitor, on_off);
    vcCmd.Enable (nav_cmd, on_off);
    vcCmd.Enable (s_oanalyzer, on_off);

    vcCmd.Enable (s_sstep, on_off);
    vcCmd.Enable (s_sphase, on_off);
    vcCmd.Enable (s_sprocess, on_off);
    vcCmd.Enable (s_sdelta, on_off);
    vcCmd.Enable (s_send, on_off);
    vcCmd.Enable (s_snext, on_off);
    vcCmd.Enable (s_sover, on_off);
    vcCmd.Enable (s_bdelete, on_off);
    vcCmd.Enable (s_bshow, on_off);
    vcCmd.Enable (s_bline, on_off);
    vcCmd.Enable (s_bsubp, on_off);
    vcCmd.Enable (s_bsignal, on_off);
    vcCmd.Enable (s_bprocess, on_off);

}

function vsEnableCmdsDesignLoaded(on_off) {
 ;
}

function vsEnableCmdsSubsetVHDLLoaded(on_off) {

    vcCmd.Enable (s_bsubp, on_off);
    vcCmd.Enable (s_bprocess, on_off);
    vcCmd.Enable (s_set_brkpnt_process, on_off);
    vcCmd.Enable (s_set_brkpnt_subprogram, on_off);

    vcCmd.Enable (s_activate, on_off);
}

function vsEnableCmdsVantageLoaded(on_off) {
    if(on_off){
        vcCmd.Enable (s_mnunet, FALSE);

    }
}
function vsEnableCmdsSchematiclessLoaded(on_off) {
    if(on_off){

        vcCmd.Enable (s_v, FALSE);
        vcCmd.Enable (s_path, FALSE);
        vcCmd.Enable (s_act, FALSE);
        vcCmd.Enable (s_changes, FALSE);
        vcCmd.Enable (s_inputs, FALSE);

        vcCmd.Enable (s_r, FALSE);

        vcCmd.Enable (s_set_brkpnt_process, FALSE);
        vcCmd.Enable (s_set_brkpnt_subprogram, FALSE);
        vcCmd.Enable (s_d_sch, FALSE);
        vcCmd.Enable (s_d_all_sch, FALSE);
        vcCmd.Enable (s_devents, FALSE);

                      
    }else{
        vcCmd.Enable (s_v, TRUE);
        vcCmd.Enable (s_path, TRUE);
        vcCmd.Enable (s_act, TRUE);
        vcCmd.Enable (s_changes, TRUE);
        vcCmd.Enable (s_inputs, TRUE);

        vcCmd.Enable (s_r, TRUE);
        vcCmd.Enable (s_display, TRUE);

        vcCmd.Enable (s_d_sch, TRUE);
        vcCmd.Enable (s_d_all_sch, TRUE);
        vcCmd.Enable (s_devents, TRUE);

    }
}


/*
 * Claim that Viewsim's data is "modified" so that when the user tries
 * to close the Viewsim window, it will print this message.  There is
 * no need to do this if Viewsim is the only window, since then Core
 * will print 
 */
function _Modified(vs, region) {
    viewsim_window := vcRegion.Window (region);
    other_window_string := "";
    foreach (w; vcWin.Loop ()) {
        if ((w != viewsim_window) &&
            (vcWin.Parent (w) == nil) &&
            vcWin.IsDecorated (w) &&
            vcWin.IsMapped (w))
        {
            f := vcRegion.Fac (vcWin.OwnerRegion (w));
            other_window_string +=
                sprintf ("    %s (%s)  \n", vcWin.Title (w), vcFac.Name (f));
        } /* if */
    } /* foreach */

    if (string_eq (other_window_string, ""))
        FALSE;
    else {
        msg :=
"
  Closing the Viewsim window will terminate the simulator.  
  It will also close down other windows associated with the  
  Viewsim process, including:  

" + other_window_string + "
";

        vcWin.SetConfirmMessage (vcRegion.Window (region), msg);
        TRUE;
    } /* else */
} /* function _Modified */

load ("vsimhelp.vs");

/*\vscmuserFunction vsim.SigTraceCancel -- Cancel a SigTrace

DESCRIPTION
     Deletes the breakpoint creaed with vsim.SigTrace.  The second argument,
     log_action, indicates whether the deletion of this breakpoint should
     be logged in viewsim.log.
*/
function SigTraceCancel(sig_cell, log_flag) {
    sig := car (sig_cell);
    set_car (sig_cell, nil);
    vsim.SigCancel (sig, log_flag);
} /* function SigTraceCancel */

/*\vscmuserFunction vsim.SigTrace -- Call a function whenever signals change value

DESCRIPTION
     This allows the user to specify a function to be called whenever
     a Viewsim value, or list of values, changes.  It is preferable to
     use a list of values than to use this routine repeatedly for efficiency
     reasons.  For example, if you wish to check to see if a signal X is
     high at the rising edge of the clock CLK, you would register one routine
     for changes in both X and CLK.

     The vsim_exec command may be used from the called function to change
     values while simulation is in progress, but the simulation commands
     should not be used.
     
     vsim.SigTrace differs from vsim.SigWatch in that the user can't
     accidently cancel the breakpoint by doing a restart or the menu
     "Delete Breakpoints".  vsim.SigTrace automatically will re-establish
     the low-level breakpoint when the user does this.  Reading a new
     network ("net" command), however, will cancel the breakpoint
     and cause the user's call_on_cancel function to be called.

     signals names either one signal string or a list of signals strings.

     call_on_sig_change is called with no arguments, whenever any of the
     signals listed changes.  The function is expected to return
     TRUE if the simulation should be stopped, FALSE if it should be
     allowed to continue.

     call_on_cancel is called with no arguments whenever the breakpoint is
     cancelled.  

SEE ALSO
     vsim_val
     vsim.SigTraceCancel
     vsim.SigWatch

SYNOPSIS
     vsimBreakpointVT SigWatch (signal_or_list_of_signals,
     				call_on_sig_change, call_on_cancel);
*/
function SigTrace(signals, call_on_change, call_on_cancel) {
    sig_cell := cons (nil, nil);

    function establish_breakpoint() {
        set_car (sig_cell, vsim.SigWatch (signals, call_on_change, func() {
            if (car (sig_cell) == nil)
                call_on_cancel ();
            else {
                vcWv.Delay (wv, func() {
                    catch (vlEx.FAILURE)
                        establish_breakpoint ();
                    exception {
                        DEBUG ("Could not re-establish: %s",
                                vlErr.String (vlErr.CurrentError (),
                                              vlErr.Stderr));
                        call_on_cancel ();
                    } /* exception */
                });
            } /* else */
        }));
    } /* function establish_breakpoint */

    establish_breakpoint ();
    sig_cell;
} /* function SigTrace */

/*\vscmuserFunction vsim.AbortSim -- Stop the simulation in progress

DESCRIPTION
     This function will attempt to stop the simulation in progress.
*/
function AbortSim() {
    foreach (w; vcWin.Loop ()) {
        r := vcWin.OwnerRegion (w);
        if (vcRegion.Fac (r) == vsim.fac) {
            event := vcEvent.Create (0, 0, '\0', nil, w, r, nil);
            vcCmd.Run (s_stop, vcRegion.GetData (r), event, nil, FALSE);
            break;
        } /* if */
    } /* foreach */
} /* function AbortSim */
