/* vsimNav.vs -- contains facility definition creation of 
 * the graphical navigator for ViewSim Debugger environment.
 *
 * $Log: vsimNav.vs,v $
Revision 1.26.1.2  1995/03/03  21:59:36  dahan
Add fcs_vsim531 label

Revision 1.25  1994/09/05  16:11:50  sridhar
added key binding for edit_value_cmd

Revision 1.24  1994/09/05  15:19:57  sridhar
Following functionality added for 53
Remove Bookmark, Edit Value, Show Net In Schematics.
Also did some code cleanup.

Revision 1.22  1994/08/07  18:33:56  sridhar
bug fix; bug id# 15464

Revision 1.21  1994/08/05  19:58:58  sridhar
proper bug fix for bugid# 15435

Revision 1.20  1994/08/05  17:18:29  sridhar
bug fix; bugid# 15435

Revision 1.19  1994/08/05  14:53:37  sridhar
bug fix; bugid# ????? removed vcRegion.Reframe() from icon_box...()
stops the segfault

Revision 1.18  1994/08/05  00:22:57  sridhar
bug fix; bug id# 15178, 15151, 15287

Revision 1.17  1994/08/01  20:37:28  sridhar
bug fix: bugid# 15270

Revision 1.16  1994/07/29  20:54:42  sridhar
updates to the UI like help messages and other stuff to make it more "slick"

Revision 1.15  1994/07/28  20:28:29  sridhar
bug fix: bug_id: 15229, bug fix: bug_id: 15223

Revision 1.14  1994/07/26  22:25:17  sridhar
bug fix for bug-id: 15165

Revision 1.13  1994/07/26  22:14:20  sridhar
bug fix for bug id: 15165

Revision 1.12  1994/07/25  21:05:40  sridhar
made "refresh_flag" for vcTree.SetFocusVrtx() TRUE

Revision 1.11  1994/07/21  14:53:55  sridhar
modified the defaults;
added "FollowSim" & "HideSheet" functionality
added "SelectInViewdraw" functionality
added "DeselectAll" functionality
updated the UI (scope label)

Revision 1.10  94/07/14  12:34:38  sridhar
fixed a vcEvent.Create problem.....

Revision 1.9  94/07/14  11:05:26  sridhar
fixed the "double-click" on node and no-spreadsheet bug
fixed the spreadsheet not occupying full area bug

Revision 1.8  94/07/11  15:46:29  sridhar
general bug fixes... added "savable" pref for spreadsheet

Revision 1.7  94/07/06  17:03:45  sridhar
changed "context" to "bookmark" fixed some ui problems

Revision 1.6  94/07/05  16:52:34  sridhar
General changes...

Revision 1.5  94/07/01  11:53:08  sridhar
*** empty log message ***

 * Revision 1.4  94/06/17  16:38:47  sridhar
 * Fixed a filter-rubber bug
 *
 * Revision 1.3  94/06/17  14:48:54  sridhar
 * Added ability to save/store preferences
 *
 * Revision 1.2  94/06/14  11:08:01  sridhar
 * Added an API func to be called by vsimList for updating cutbuffer for 
 * any spreadsheet selection/deselection
 *
 * Revision 1.1  94/06/13  16:30:15  sridhar
 * Initial revision
 *
 * Revision 1.5  94/06/09  15:53:57  sridhar
 * type in scope string feature added,
 * save bookmark bug (selection node being incorrect) fixed
 *
 * Revision 1.4  94/06/08  16:03:00  sridhar
 * added ability to handle vantage scope inside viewsim hierarchy
 * preference sheet for setting color for design hierarchy nodes
 *
 * Revision 1.3  94/06/02  11:29:48  sridhar
 * Design browser has a picklist for large designs
 *
 * Revision 1.2  94/05/26  10:23:04  sridhar
 * Moved all viewscript based ADTs to 'C' (in vsn_adt.c)
 *
 * Revision 1.1  94/04/22  14:25:55  sridhar
 * Initial revision after integrating with viewsim
 *
 * Revision 1.4  94/03/27  18:48:48  sridhar
 * included bookmark switching of design browser.
 *
 * Revision 1.3  94/03/25  09:09:40  sridhar
 * added caching of design hiererachy to save time on query + vctree_vrtx
 * creation time.
 *
 * Revision 1.2  94/03/24  09:20:43  sridhar
 * Initial revision
 */

/*set_stdout(TRUE);*/


function deep_copy(x) {
    if (x == nil)
        nil;
    else if (istype (x, consVT))
        cons (deep_copy (car (x)), deep_copy (cdr (x)));
    else if (istype (x, vectorVT)) {
        l := vector_length (x);
        v := make_vector (l);
        for (i := 0; i < l; ++i)
            v[i] = deep_copy (x[i]);
        v;
    } /* else if */
    else
        x;
} /* function deep_copy */


/*  this is used in "grey_out...._cmds()" 
 */
SchematicsLess := FALSE;


/*  create_vctree_vrtx_from_design_item -- create a vctree_vrtx corr. to the
 *  design_item
 */
design_browser_attrib_alist := list (
    list ("VHDL Component",     vgColor.LightMagenta, "vstree"),
    list ("VHDL Process",       vgColor.Yellow,       "vsleaf"),
    list ("SUBSET VHDL Comp",   vgColor.LightGreen,   "vstree"),
    list ("SUBSET VHDL Proc",   vgColor.LightRed,     "vsleaf"),
    list ("VIEWSIM Component",  vgColor.LightGreen,   "vstree"),
    list ("LAI Model",          vgColor.Magenta,      "vsleaf"),
    list ("C Model",            vgColor.LightGrey,    "vsleaf"),
    list ("HARDWARE Model",     vgColor.White,        "vsleaf"),
    list ("MISC Model",         vgColor.LightCyan,    "vsleaf")
);


function get_vertex_attributes (typename)
{
    sublist := assoc (typename, design_browser_attrib_alist);
    color   := sublist[1];
    icon    := sublist[2];
    [icon, color];
}


function show_message (win, msg)
{
    vcWin.ClearStatus (win);
    vcWin.AddStatus   (win, msg);
}


/* ---------------------------------------------------------------------- */

/*  spreadsheet_value_action_func -- is called by a vsimlist region,
 *  when its cmdline region has been activated by a carriage return
 */
function spreadsheet_value_action_func (vsimlist, record, region, event)
{
    this := vcRegion.GetData (region);
    vsimlist_structs := this.spreadsheets;

    /*  get the vsimlist_struct (object_name)  which holds vsimlist 
     */
    foreach (vsimlist_struct;  vscript.iter (vsimlist_structs))
	if (vsimlist_struct.vsimlist == vsimlist) {

	    node := this.selected_node;

	    if (node != nil) {
		/*  use the scope string of the selected node 
		 */
		/*  call a vsim facility's function to execute a :-
		 *  vsim> command args 
		 */
		value	:= cadr (assoc ("Value", record));
		name	:= cadr (assoc (vsimlist_struct.object_name, record));

		node	:= this.selected_node;
		design_item := design_cache_get_design_item (node);
		type := design_item_get_type (design_item);
		vsimlist_type := vsimList.GetType (vsimlist);

		if (string_eq (vsimlist_type, "SIGNAL")  &&
		    string_eq (type, "PROCESS"))
		{
		    parent_node := design_cache_get_parent (node);
		    arg	:= design_cache_get_scope (parent_node) + name;

		}
		else
		    arg	:= design_cache_get_scope (node) + name;

		vsim.echo_cmd ("assign " + arg + " \"" + value + "\"", event);

		if (string_eq (vsimlist_type, "SIGNAL"))
		{
		    /*  update the status window to indicate that the
		     *  value is scheduled in the simulator
		     */
		    msg := "Signal value: The new value has been scheduled in the simulator";
		    show_message (vcRegion.Window (region), msg);
		}
	    }
	}
}


/*  for each design_item type , 
 *      define the set of detailed design objects to be queried
 */

signal_template := list (
list ("SIGNAL",	vcStaticText.fac,	list (width <- 8,  max_width <- 20)),
list ("Type",	vcStaticText.fac,	list (width <- 10, max_width <- 18)),
/*
*/
list ("Value",	vcCmdline.fac,	        list (width <- 32, max_width <- 128,
                                              max_size <- 2048,
					      font_id <- vgFont.small),
					spreadsheet_value_action_func));

variable_template := list (
list ("VARIABLE", vcStaticText.fac,	list (width <- 8,  max_width <- 20)),
list ("Type",	  vcStaticText.fac,	list (width <- 10, max_width <- 18)),
/*
*/
list ("Value",	  vcCmdline.fac,        list (width <- 32, max_width <- 128,
                                              max_size <- 2048,
					      font_id <- vgFont.small),
					spreadsheet_value_action_func));

template_list := list (signal_template, variable_template);


/*  spreadsheet column ordering -- specifies the ordering of the columns
 */
spreadsheet_col_order := list (
    cons ("SIGNAL",         list (
	list ("SIGNAL",   TRUE, 0),
	list ("Type",     TRUE, 1),
	/*
	*/
	list ("Value",    TRUE, 2))),

    cons ("VARIABLE",       list (
	list ("VARIABLE", TRUE, 0),
	list ("Type",     TRUE, 1),
	/*
	*/
	list ("Value",    TRUE, 2))));



/*  remove_all_spreadsheet_entries -- delete all the entries of all vsimList 
 *  regions representing the spreadsheet
 */
function remove_all_spreadsheet_entries (region)
{
    this := vcRegion.GetData (region);
    spreadsheets := this.spreadsheets;

    foreach (vsimlist_struct;  vscript.iter (spreadsheets))
	if (vsimlist_struct.visible)
	    vsimList.DelAllRecords (vsimlist_struct.vsimlist);
}


/*  set_spreadsheet_data_fast -- set spreadsheet data for the given vsimNav
 *  region. the spreadsheet consists of a bunch of vsimLists, whose set
 *  functions are invoked.
 */
function set_spreadsheet_data_fast (region, force_flag)
{

    this          := vcRegion.GetData (region);
    table         := this.spreadsheet_table;
    selected_node := this.selected_node;
    scope         := design_cache_get_scope (selected_node);
    design_item   := design_cache_get_design_item (selected_node);
    type          := design_item_get_type (design_item);
    changed       := FALSE;

    vsimlist_structs := this.spreadsheets;
    foreach (vsimlist_struct;  vscript.iter (vsimlist_structs))
    {
	/*  if the selected_node is of PROCESS type, then
	 *  query signals from its parent and display them in 
	 *  signal spreadsheet
	 */
	if (string_eq (vsimlist_struct.object_name, "SIGNAL")  &&
	    string_eq (type, "PROCESS"))
	{
	    /*  query SIGNALs from a level above the current scope
	     */
	    parent_node  := design_cache_get_parent (selected_node);
	    parent_scope := design_cache_get_scope (parent_node);

	    ret_val := vsimList.QueryAndAddRecords  (vsimlist_struct.vsimlist,
						parent_scope,
						vsimlist_struct.object_name,
						force_flag);
	}
	else
	    /*  display sometype in spreadsheet
	     */
	    ret_val := vsimList.QueryAndAddRecords  (vsimlist_struct.vsimlist,
						scope,
						vsimlist_struct.object_name,
						force_flag);

	/*  if the SIGNAL/VARIABLE/.. was successfully queried, then
	 *  show the vsimList region
	 */
	if (ret_val)
	{
	    if (vsimlist_struct.visible == FALSE)
	    {
		changed = TRUE;

		vcTable.Set (table, vsimlist_struct.row_num, 0,
			     vsimlist_struct.vsimlist);
		vsimlist_struct.visible = TRUE;
	    }
	}
	/*  replace vsimList region by a vcRubber region
	 */
	else
	{
	    if (vsimlist_struct.visible == TRUE)
	    {
		vcTable.Set (table, vsimlist_struct.row_num, 0,
			     vsimlist_struct.rubber);
		vsimlist_struct.visible = FALSE;

		changed = TRUE;
	    }
	}
    }

    if (changed)
	vcTable.Row (table, vcTable.All, vcTable.Border.Adjustable, 3, 3, 3,
		     vgAlign.MiddleCenter);
}



/*  update_spreadsheet_data_fast -- for the regions's spreadsheet, it updates
 *  the given data assigning them to their corr. vsimList regions
 */
function update_spreadsheet_data_fast (region, update_label)
{
    this  := vcRegion.GetData (region);
    table := this.spreadsheet_table;
    node  := this.selected_node;
    type  := design_item_get_type (design_cache_get_design_item (node));
    scope := design_cache_get_scope (node);
    spreadsheets := this.spreadsheets;

    foreach (vsimlist_sct;  vscript.iter (spreadsheets))
	if (vsimlist_sct.visible == TRUE)
	{

	    if (string_eq (type, "PROCESS")  &&
		string_eq (vsimlist_sct.object_name, "SIGNAL"))
	    {
		parent_node  := design_cache_get_parent (node);
		parent_scope := design_cache_get_scope (parent_node);
		vsimList.QueryValueAndUpdateRecords (vsimlist_sct.vsimlist,
			parent_scope, vsimlist_sct.object_name, update_label);
	    }
	    else
		vsimList.QueryValueAndUpdateRecords (vsimlist_sct.vsimlist,
				scope, vsimlist_sct.object_name, update_label);
	}
}


/*  hide_current_bookmark -- removes all the nodes in the "current_bookmark" from
 *  the vctree, thus hiding it in the design browser
 */
function hide_current_bookmark (region)
{
    declare	this;
    declare	root;
    declare	bookmark;
    declare	design_item;

    this	= vcRegion.GetData (region);
    bookmark	= this.bookmark;
    root	= bookmark_get_root_dc_node (bookmark);
    design_item = design_cache_get_design_item (root);

    /*  Note: the -1 for bookmark_id is to prevent removal of bookmark_id
     *  from the design_cache_nodes.
     */
    remove_children_vctree_vertices_from_tree (root, -1);

    /*  remove the root from the tree region
     */
    vrtx := design_cache_get_vrtx (root);
    vcTree.VrtxRemove (vrtx);
    design_item_set_is_expanded (design_item, 0);

    /*	hide the spreadsheet window
     */
    remove_all_spreadsheet_entries (region);
    this.selected_node = nil;
}



/*  show_current_bookmark -- adds all the nodes in the "current_bookmark" to
 *  the vctree, thus displaying a hierarchy  in the design browser
 */
function show_current_bookmark (region)
{
    this	:= vcRegion.GetData (region);
    tree	:= this.tree_region;
    bookmark	:= this.bookmark;
    root	:= bookmark_get_root_dc_node (bookmark);
    design_item := design_cache_get_design_item (root);

    vrtx := design_cache_get_vrtx (root);
    vcTree.SetRoot (tree, vrtx);

    bookmark_id := bookmark_get_id (bookmark);
    design_item_set_is_expanded (design_item,
	recursive_add_children_vctree_vertices_to_tree (root, bookmark_id));

    /*  set the current selection node in the design browser
     *  set the spreadsheet window corr. to the selected node
     *  set the scope string 
     *
     *  all of the above can be acheived by doing the vcTreeVrtx selection
     */
    selected_node := bookmark_get_selected_dc_node (bookmark);
    if (selected_node != nil)
    {
	root_dc_node := bookmark_get_root_dc_node (bookmark);
	scope := get_unique_viewsim_scope (root_dc_node);
	reset_scope_string (region, scope);
	vrtx := design_cache_get_vrtx (selected_node);
	vcTree.SelectVrtx (tree, vrtx);
	vcTree.SetFocusVrtx (tree, vrtx, TRUE);
    }
}


/*  update the status of "show_VHDL_source_cmd" and
 *  "show_comp_schematics_cmd" depending on the type of the node
 */
function grey_out_source_and_schematics_cmds (dc_node)
{
    design_item := design_cache_get_design_item (dc_node);
    typename    := design_item_get_item_type    (design_item);

    /*  determine if the "typename" contains VHDL as one of the words
     */
    is_vhdl     := FALSE;
    foreach (tok;  string_loop (typename, " "))
	if (string_eq (tok, "VHDL"))
	    is_vhdl = TRUE;
	    
    if (is_vhdl)
    {
	/*  enable the "show_VHDL_source" cmd
	 */
	vcCmd.Enable (show_VHDL_source_cmd,vlOnOff.On);
	vcCmd.Enable (show_net_schematics_cmd,  vlOnOff.Off);

	/*  if parent of the VHDL component is a viewsim component
	 *  then enable "show_comp_schematics_cmd"
	 *  else disable it
	 */
	if (SchematicsLess)
	    vcCmd.Enable (show_comp_schematics_cmd, vlOnOff.Off);
	else
	{
	    p_node := design_cache_get_parent (dc_node);
	    if (p_node != nil)
	    {
		parent_di := design_cache_get_design_item (p_node);
		if (design_item_get_delimiter (parent_di) != '/')
		    vcCmd.Enable (show_comp_schematics_cmd, vlOnOff.On);
		else
		    vcCmd.Enable (show_comp_schematics_cmd, vlOnOff.Off);
	    }
	    else
		vcCmd.Enable (show_comp_schematics_cmd, vlOnOff.Off);
	}

    }
    else
    {
	if (SchematicsLess)
	{
	    /*  disable the "show_comp_schematics_cmd" and enable the
	     *  "show_VHDL_source" cmd
	     */
	    vcCmd.Enable (show_VHDL_source_cmd,vlOnOff.On);
	    vcCmd.Enable (show_comp_schematics_cmd, vlOnOff.Off);
	    vcCmd.Enable (show_net_schematics_cmd,  vlOnOff.Off);
	}
	else
	{
	    /*  enable the "show_comp_schematics_cmd" and disable the
	     *  "show_VHDL_source" cmd
	     */
	    vcCmd.Enable (show_VHDL_source_cmd,vlOnOff.Off);
	    vcCmd.Enable (show_comp_schematics_cmd, vlOnOff.On);
	    vcCmd.Enable (show_net_schematics_cmd,  vlOnOff.On);
	}
    }
}


vertex_selection_being_executed  := FALSE;
vertex_activation_to_be_executed := FALSE;

/*  register_vertex_selection -- registers a selection function for a vcTree 
 *  region. some extra info is also suppied, which are used in vertex_selection;
 */
function register_vertex_selection (region, tree)
{
    declare dummy_event;

    /*  vertex_selection -- is called for a mouse-click event on a vertex in the
     *  design browser. a vertex selection is associated with displaying the
     *  selected design object's details in the spreadsheet.
     */
    function vertex_selection (vertex, flag)
    {
	vertex_selection_being_executed = TRUE;

	this := vcRegion.GetData (region);
	selected_node := vcTree.VrtxGetItem (vertex);
	if (selected_node == nil)
	{
	    vertex_selection_being_executed = FALSE;
	    return (nil);
	}

	/*  if selected some other node and not the
	 *  currently selected node, then
	 */
	if (this.selected_node != selected_node)
	{
	    if (this.selected_node == nil)
		force_flag := TRUE;
	    else
		force_flag := FALSE;

	    this.selected_node = selected_node;
	    if (vcRegion.Window (region) != nil)
		vcWin.Busy (vcRegion.Window (region), TRUE);

	    /*  update the selected node in the current bookmark
	     */
	    if (selected_node != nil)
	    {
		cur_bookmark := this.bookmark;
		bookmark_set_selected_dc_node (cur_bookmark,this.selected_node);

		/*  update the status of "show_VHDL_source_cmd" and
		 *  "show_comp_schematics_cmd" depending on the type of the node
		 */
		grey_out_source_and_schematics_cmds (selected_node); 
	    }

	    /*  if the hide_spreadsheet flag is set, then
	     *  do not update the spreadsheet
	     */
	    if (! this.hide_spreadsheet)
	    {
		remove_all_spreadsheet_entries (region);
		set_spreadsheet_data_fast (region, force_flag);
	    }
	    else
	    {
		/*  update the "old" navigator's scope
		 */
		scope       := design_cache_get_scope (selected_node);
		design_item := design_cache_get_design_item (selected_node);
		type        := design_item_get_type_int (design_item);
		vsnav.DbgNavUpdateScope (scope, type);
	    }

	    scope := get_unique_viewsim_scope (selected_node);
	    set_scope_string (region, scope);

	    if (vcRegion.Window (region) != nil)
		vcWin.Busy (vcRegion.Window (region), FALSE);
	}

	vertex_selection_being_executed = FALSE;
	if (vertex_activation_to_be_executed)
	{
	    if (dummy_event == nil)
		dummy_event = vcEvent.Create (0, 0, 'x', "a",
				    vcRegion.Window (region),
				    tree, vgRect.Create (0, 0, 0, 0));
	    vcTree.VrtxActivate (vertex, dummy_event);
	}
    }

    vcTree.CallOnSelect (tree, vertex_selection);
}


/*  register_vertex_activation -- registers a activation function for a vcTree 
 *  region. some extra info is also suppied, which are used in vertex_activation
 */
function register_vertex_activation (region, tree)
{
    declare being_executed;

    /*  vertex_activation -- is called for double mouse-click event on a vertex
     *  in the design browser. a vertex activation is associated expanding or
     *  collapsing the subtree of a design object vertex in the browser.
     */
    function vertex_activation (event, parent)
    {
	if (vertex_selection_being_executed)
	{
	    vertex_activation_to_be_executed = TRUE;
	    return (nil);
	}

	if (vertex_activation_to_be_executed)
	    vertex_activation_to_be_executed = FALSE;

	this	:= vcRegion.GetData (region);
	bookmark:= this.bookmark;
	id	:= bookmark_get_id (bookmark);

	design_cache_node := vcTree.VrtxGetItem (parent);

	if (design_cache_node == nil)
	{
	    return (nil);
	}

	design_item := design_cache_get_design_item (design_cache_node);

	if (vcRegion.Window (region) != nil)
	    vcWin.Busy (vcRegion.Window (region), TRUE);

	/*  if expanded, collapse the subtree
	 *  else expand the subtree
	 */
	is_leaf := design_item_get_is_leaf (design_item);
	is_expanded := design_item_get_is_expanded (design_item);

	if ((is_leaf == FALSE) && (is_expanded > 0))
	{
	    remove_children_vctree_vertices_from_tree (design_cache_node, id);
	    vcRegion.PrefSet (tree, list (bounds <- vgRect.Create (0,0,0,0)));
	    design_item_set_is_expanded (design_item, 0);
	}
	else if (is_leaf == FALSE)
	{
	    design_cache_query_children (design_cache_node, tree);
	    add_children_vctree_vertices_to_tree (design_cache_node, id);
	    design_item_set_is_expanded (design_item, id+1);
	}
	else if (is_leaf == TRUE)
	{
	    /*  pop up a source window, if node is a leaf node
	     */
	    scope := design_cache_get_scope (design_cache_node);
	    vsim.LoadSource (scope);
	}

	/*  select the parent vertex
	 */
	vcTree.SelectVrtx (tree, parent);
	vcTree.SetFocusVrtx (tree, parent, TRUE);

	vcRegion.Refresh (tree, vcRegion.Area (tree));
	if (vcRegion.Window (region) != nil)
	    vcWin.Busy (vcRegion.Window (region), FALSE);
    }

    vcTree.CallOnVrtxActivate (tree, vertex_activation);
}


/*  register_vertex_altactivation -- registers an alt-activation function for
 *  a vcTree region. some extra info is also suppied, which are used in
 *  vertex_altactivation
 */
function register_vertex_altactivation (region, tree)
{
    declare popupmenu;

    /*  vertex_altactivation -- is called for rightbutton-down event on a vertex
     *  in the design browser. the vertex is "homed" in the design browser
     *  and its bookmark is also added in the icon-box
     */
    function vertex_altactivation (event, parent)
    {
	/*  select the parent vertex
	 */
	vcTree.SelectVrtx   (tree, parent);
	vcTree.SetFocusVrtx (tree, parent, TRUE);

	/*  pop up a background menu;
	 */
	vcMenuPop.Create (popupmenu, event);
    }

    popupmenu = vcWv.MakeMenu ("tree-popup", 
	list ("Show VHDL Source", show_VHDL_source_cmd ),
	list ("Create Bookmark",  create_bookmark_cmd  ),
	list ("Show Schematics",  show_comp_schematics_cmd  ));

    vcTree.CallOnVrtxAltActivate (tree, vertex_altactivation);
}


/* create_vctree -- create vcTree region for the design browser
 */
function create_vctree (region, root)
{
    desc := vcTree.EdgeDescriptorCreate (color <- vgColor.Black,thickness <- 1);
    tree := vcRegion.Create ("design browser", vcTree.fac, nil,
		   root		<- root,
		   align	<- vgAlign.UpperLeft,
		   anchor_root	<- TRUE,
		   scalable	<- FALSE,
		   interactive	<- TRUE,
		   background	<- vgAllColor.Base,
		   layout 	<- vcTree.Layout.Narrow,
		   compass	<- vgCompass.East,
		   level_space	<- 20,
		   sibling_space<- 10,
		   even_indent	<- TRUE,
		   edge_indent	<- 5,
		   follow_focus <- TRUE,
		   scrollbars	<- TRUE,
		   exclusive	<- TRUE,
		   bounds	<- vgRect.Create (0, 0, 0, 0),
		   size		<- vgSize.Create (150, 350, 150, 350,8000,8000),
		   default_edge_descriptor <- desc);

    register_vertex_selection  (region, tree);
    register_vertex_activation (region, tree);
    register_vertex_altactivation (region, tree);

    tree;
}


/*  returns a unique "viewsim" scope for the given node
 */
function get_unique_viewsim_scope (dc_node)
{
    scope := design_cache_get_scope (dc_node);

    /*  if the new_scope is a vantage VHDL scope, then convert it to vsim scope
     */
    if (lindex (scope, '/') != FALSE)
    {
	/*  if the vantage scope is at the top-level, then change the delimiter
	 */
	pnode  := design_cache_get_parent (dc_node);
	pscope := design_cache_get_scope (pnode);
	if (string_eq (pscope, ""))
	{
	    new_scope := "";
	    foreach (token;  string_loop (scope, "/"))
		new_scope = new_scope + token + "\\";

	    if (! string_eq (new_scope, ""))
	    {
		len := string_length (new_scope);
		new_scope = substring (new_scope, 0, len-1);
	    }
	}
	else
	    /*  the dc_node is deep inside a viewsim/vantage hierarchy
	     *  get the unique path to the dc_node.  
	     */
	    new_scope := convert_vantage_to_viewsim_scope (scope);
    }
    else
	new_scope := scope;

    new_scope;
}


/*  returns a the uidname of the given vantage component
 */
function get_viewsim_only_scope (dc_node)
{
    scope := design_cache_get_scope (dc_node);

    /*  if the new_scope is a vantage VHDL scope, then convert it to vsim scope
     */
    if (lindex (scope, '/') != FALSE)
	/*  the dc_node is deep inside a viewsim/vantage hierarchy
	 *  get the unique path to the dc_node.  
	 */
	new_scope := convert_vantage_scope_to_uidname (scope);
    else
	new_scope := scope;

    new_scope;
}



/* scope command line
 */
function create_scope (region)
{
    declare	scope_tab;
    declare	scope_name;
    declare	scope_line;

    /*  action function for a return on scope cmdline
     */
    function scope_notify_func (event, cmdline_str)
    {
	declare		token;

	/*  concat scope_name + scope_line's contents 
	 *  and set the hierarchy to the new scope str
	 */
	cmdline_str = string_token (cmdline_str, &token, " ");
	if (! isstring (token)) token = "";

	expand_viewsim_scope (region, token);
    }

    scope_tab  = vcTable.Create  ("scope table", 1, 2);
    vcTable.Col (scope_tab, vcTable.All, vcTable.Border.Invisible, 3, 3, 3,
		 vgAlign.MiddleCenter);
    vcTable.Row (scope_tab, vcTable.All, vcTable.Border.Invisible, 3, 3, 3,
		 vgAlign.MiddleCenter);

    scope_name = vcRegion.Create ("scope name", vcLabel.fac, " Scope: ");
    vcRegion.Font (scope_name, vgFont.mediumb);
    scope_line = vcRegion.Create ("scope line", vcCmdline.fac, " ",
			      max_width <- 200, width <- 30, history <- 900);

    /*  register a callback function to handle "type-in-scope-strings"
     */
    vcCmdline.CallOnReturn (scope_line, scope_notify_func);

    vcTable.Set (scope_tab, 0, 1, scope_line);
    vcTable.Set (scope_tab, 0, 0, scope_name);

    [scope_line, scope_tab];
}


/*  reset the scope string for the given navigator region
 */
function reset_scope_string (region, scope_str)
{
    if (! isstring (scope_str))
	scope_str = "";

    this       := vcRegion.GetData (region);
    scope_tab  := this.scope_table;

    scope_line := vcTable.Get (scope_tab, 0, 1);

    /*  set the scope_name to scope_str and clear the scope_line
     */
    this.scope_prefix = scope_str;
    vcCmdline.Set (scope_line, "");
}


/*  set the scope string for the given navigator region
 */
function set_scope_string (region, scope_str)
{
    if (! isstring (scope_str))
	scope_str = "";

    this       := vcRegion.GetData (region);
    scope_tab  := this.scope_table;

    scope_line := vcTable.Get (scope_tab, 0, 1);
    scope_prefix := this.scope_prefix;

    /*  if the scope_str's prefix matches the scope_name, then
     *  set the scope_line to the suffix of scope_str
     */
    if (string_eq (scope_prefix, ""))
	vcCmdline.Set (scope_line, scope_str);
    else if (string_length (scope_prefix) < string_length (scope_str))
    {
	prefix := substring (scope_str, 0, string_length (scope_prefix));

	if (string_eq (scope_prefix, prefix))
	{
	    suffix := substring (scope_str, string_length (scope_prefix), 0);
	    vcCmdline.Set (scope_line, suffix);
	}
    }
}


/*  creates the main table for spreadsheet
 */
function make_vsimlist_struct (vsimlist, rubber, row_num, object_name)
{
    this := struct {
	vsimlist;
	rubber;
	row_num;
	visible;
	object_name
    };

    this.vsimlist = vsimlist;
    this.rubber   = rubber;
    this.row_num  = row_num;
    this.visible  = FALSE;
    this.object_name = object_name;
    this;
}


function create_spreadsheet (region)
{
    tab := vcTable.Create ("Spreadsheet", length (template_list), 1); 
    vl_structs := nil;

    i := 0;
    foreach (template;  vscript.iter (template_list))
    {
	vsimlist:= vcRegion.Create ("VS", vsimList.fac, nil, format <- template,
			       arg <- region,
			       notify_func <- spreadsheet_value_action_func);
	rubber     := vcSteel.Create ("Rub", 0, 0);
	vl_struct  := make_vsimlist_struct (vsimlist, rubber, i,caar(template));
	vl_structs = cons (vl_struct, vl_structs);
	vcTable.Set (tab, i, 0, rubber);
	++i;
    }

    vl_structs = reverse (vl_structs);
    vcTable.Row (tab, vcTable.All, vcTable.Border.Adjustable, 3, 3, 3,
		 vgAlign.UpperLeft);
    [tab, vl_structs];
}


/*  set_filter_notify_func -- called by create_filter(), for attaching 
 *  filter_notify_func() to the filter region...
 */
function set_filter_notify_func (region, filter_line)
{
    function filter_notify_func (event, cmdline_str)
    {
	declare		token;

	win          := vcRegion.Window (region);
	this         := vcRegion.GetData (region);
	spreadsheets := this.spreadsheets;
	table        := this.spreadsheet_table;
	object_name  := get_filter_sel (region);
	cmdline_str   = string_token (cmdline_str, &token, " ");

	/*  get the vsimlist region matching the object_name,
	 */
	foreach (vsimlist_sct;  vscript.iter (spreadsheets))
	    if (string_eq (object_name, vsimlist_sct.object_name))
	    {
		ret_val := vsimList.SetRegExp (vsimlist_sct.vsimlist,
				    object_name, token);

		if (ret_val == nil)
		{
		    if (vsimList.GetMaxItems (vsimlist_sct.vsimlist) <= 0)
			msg := "No " + object_name + "S found!";
		    else
			msg := "Match string for \"" +string_lower(object_name)+
			       "\" was same or invalid";
		    show_message (win, msg);
		    return (nil);
		}

		/*  if the SIGNAL/VARIABLE/.. was successfully queried, then
		 *  show the vsimList region
		 */
		if (ret_val)
		{
		    vcTable.Set (table, vsimlist_sct.row_num, 0,
				 vsimlist_sct.vsimlist);
		    vsimlist_sct.visible = TRUE;

		    /*  update the action in the cmdline
		     */
		    msg := "Match for \"" + string_lower(object_name) +
			   "\" was successful";
		    show_message (win, msg);
		}

		/*  replace vsimList region by a vcRubber region
		 */
		else
		{
		    vcTable.Set (table, vsimlist_sct.row_num, 0,
				 vsimlist_sct.rubber);
		    vsimlist_sct.visible = FALSE;

		    /*  update the action in the cmdline
		     */
		    msg := "Match for \"" + string_lower (object_name) +
			   "\" was not successful";
		    show_message (win, msg);
		}
	    }
    }
    vcCmdline.CallOnReturn (filter_line, filter_notify_func);
}


/*  returns the spreadsheet name, on which the filter string is to be applied
 *  given the vsimNav region
 */
function get_filter_sel (region)
{
    declare	rows, cols;

    this := vcRegion.GetData (region);
    picklist := vcTable.Get (this.filter_table, 0, 1);

    vcPicklist.Dimensions (picklist, &rows, &cols);

    for (--cols;  cols >= 0;  --cols)
	if (vcPicklist.IsSet (picklist, cols))
	    return (cdr (vcPicklist.Get (picklist, 0, cols)));
    "SIGNAL";
}


/*  creates a pulldown menu which is a list of spreadsheets available; the
 *  menu selection updates the "spreadsheet" on which the filter string will
 *  be applied
 */
function create_filter_combo_box  ()
{

    picklist := vcRegion.Create ("fp", vcPicklist.fac, nil,
				rows <- 1,
				columns <- length (template_list),
				will_scroll <- FALSE,
				exclusive <- TRUE);
    /*  construct picklist data
     */
    foreach (template;  vscript.iter (template_list))
	vcPicklist.Add (picklist, caar (template), caar (template));

    vcPicklist.SetPick (picklist, 0);

    picklist;
}


/* filter command line
 */
function create_filter (region)
{
    filter_tab  := vcTable.Create  ("filter table", 1, 3);

    label       := vcRegion.Create ("ll", vcLabel.fac, " Filter: ");
    vcRegion.Font (label, vgFont.mediumb);

    filter_sel  := create_filter_combo_box ();

    filter_line := vcRegion.Create ("filter line", vcCmdline.fac, "*",
				max_width <- 20, width <- 20, history <- 900);
    set_filter_notify_func (region, filter_line);

    vcTable.Set (filter_tab, 0, 0, label);
    vcTable.Set (filter_tab, 0, 1, filter_sel);
    vcTable.Set (filter_tab, 0, 2, filter_line);

    [filter_line, filter_tab];
}


function add_icon_selection_func (region, picklist)
{
    /*  the action func changes the bookmark of design browser
     */
    function switch_bookmark (entry_data, on_or_off)
    {
	this := vcRegion.GetData (region);
	cur_bookmark := this.bookmark;
	new_bookmark := entry_data;

	if (equal (on_or_off, vlOnOff.On)  &&
	    not (equal (new_bookmark, cur_bookmark)))
	{
	    if (vcRegion.Window (region) != nil)
		vcWin.Busy (vcRegion.Window (region), TRUE);

	    /*  save the currently selected node in the current_bookamrk
	     *  hide the tree nodes corr. to the current bookmark
	     */
	    tree := this.tree_region;
	    if (this.selected_node != nil)
		bookmark_set_selected_dc_node (cur_bookmark,this.selected_node);
	    hide_current_bookmark (region);

	    /*  flip to the new bookmark and update the navigator with the 
	     *  tree corr. to the new bookmark and select the approp. node
	     */
	    this.bookmark = new_bookmark;
	    vcRegion.PrefSet (tree, list (anchor_root <- FALSE));
	    vcRegion.PrefSet (tree, list (bounds <- vgRect.Create (0,0,0,0)));

	    show_current_bookmark (region);
	    if (vcRegion.Window (region) != nil)
		vcWin.Busy (vcRegion.Window (region), FALSE);

	    /*  disable the "delete_bookmark" command, if the new_bookamrk
	     *  is the "main" bookmark
	     */
	    node  := bookmark_get_root_dc_node (new_bookmark);
	    scope := design_cache_get_scope (node);
	    if (string_eq (scope, ""))
		vcCmd.Enable  (delete_bookmark_cmd, vlOnOff.Off);
	    else
		vcCmd.Enable  (delete_bookmark_cmd, vlOnOff.On);

	    vcRegion.Refresh (tree, vcRegion.Area (tree));
	    vcRegion.PrefSet (tree, list (anchor_root <- TRUE));
	}
    }

    vcPicklist.Notify (picklist, switch_bookmark);
}


function icon_box_modify_icon (this)
{
    declare	rows, cols;

    picklist := this.icon_box;

    /*  get the icon which corresponds to the scope_str
     *  and select it.
     */
    vcPicklist.Dimensions (picklist, &rows, &cols);
    for (i := 0;  i < rows;  ++i)
	for (j := 0;  j < cols;  ++j)
	{
	    entry := vcPicklist.Get (picklist, i, j);

	    if (iscons (entry))
	    {
		table   := car (entry);
		bookmark := cdr (entry);
		node    := bookmark_get_root_dc_node (bookmark);
		design_item := design_cache_get_design_item (node);

		typename      := design_item_get_item_type (design_item);
		<icon, color> := get_vertex_attributes (typename);

		vcTable.Set (table, 0, 0, vcRegion.Create ("i", vsimIcon.fac,
					    list (icon, color, vgColor.Black)));
	    }
	}

    vcRegion.Refresh (picklist, vcRegion.Area (picklist));
}


function icon_box_get_bookmark (region, scope_str)
{
    declare	rows, cols;

    this     := vcRegion.GetData (region);
    picklist := this.icon_box;

    /*  get the icon which corresponds to the scope_str
     *  and select it.
     */
    vcPicklist.Dimensions (picklist, &rows, &cols);
    entry_no := 0;

    for (i := 0;  i < rows;  ++i)
	for (j := 0;  j < cols;  ++j)
	{
	    entry := vcPicklist.Get (picklist, i, j);

	    if (iscons (entry))
	    {
		bookmark := cdr (entry);
		node     := bookmark_get_root_dc_node (bookmark);
		scope    := design_cache_get_scope (node);

		if (string_eq (scope, scope_str))
		    return (entry_no);
		++entry_no;
	    }
	}
    return (-1);
}


/*  selects the icon, with the given "scope_str" in the icon_box
 *  selection-means: switching bookmark to the approp. bookmark/icon
 */
function icon_box_select (region, scope_str)
{
    this := vcRegion.GetData (region);
    picklist := this.icon_box;

    /*  check if the given scope string is *not* the current bookmark icon
     */
    node  := bookmark_get_root_dc_node (this.bookmark);
    scope := design_cache_get_scope (node);
    if (! string_eq (scope_str, scope))
    {
	entry_no := icon_box_get_bookmark (region, scope_str);
	if (entry_no >= 0)
	    vcPicklist.SetPick (picklist, entry_no);
    }
}


function create_icon_box (region)
{
    table := vcTable.Create ("icon table", 1, 2);

    label := vcRegion.Create ("x", vcLabel.fac, " Bookmarks: ");
    vcRegion.Font (label, vgFont.mediumb);
    vcTable.Add (table, label);

    picklist := vcRegion.Create ("icon picklist", vcPicklist.fac, nil,
				rows        <- 1,
				columns     <- 4,
				will_scroll <- FALSE,
				exclusive   <- TRUE);
    vcTable.Add (table, picklist);

    vcRegion.Align (picklist, vgAlign.UpperLeft);
    add_icon_selection_func (region, picklist);

    vcTable.Col (table, vcTable.All, vcTable.Border.Invisible, 3, 3, 3,
		 vgAlign.MiddleLeft);
    vcTable.Row (table, vcTable.All, vcTable.Border.Invisible, 3, 3, 3,
		 vgAlign.MiddleLeft);

    [picklist, table];
}


/*  picklist_num_entries -- there is no vcPicklist.NumEntries;
 *  hence this function
 */
function picklist_num_entries (picklist)
{
    declare	rows, cols;

    vcPicklist.Dimensions (picklist, &rows, &cols);
    num_entries := 0;
    for (i := 0;  i < rows;  ++i)
	for (j := 0;  j < cols;  ++j)
	    if (iscons (vcPicklist.Get (picklist, i, j)))
		++num_entries;

    num_entries;
}


/*  icon_box_add_bookmark -- adds the current bookmark to the icon_box
 *  ie., add the bookmark to the bookmark list stored as a data object of
 *  the corresponding picklist entry.
 */
function icon_box_add_bookmark (region, bookmark)
{
    this	:= vcRegion.GetData (region);
    icon_box	:= this.icon_box;

    node 	:= bookmark_get_root_dc_node (bookmark);
    design_item	:= design_cache_get_design_item (node);

    
    tab := vcTable.Create ("pt", 1, 2);
    vcTable.Col (tab, vcTable.All, vcTable.Border.Invisible, 3, 3, 3,
		 vgAlign.MiddleCenter);
    vcTable.Row (tab, vcTable.All, vcTable.Border.Invisible, 3, 3, 3,
		 vgAlign.MiddleCenter);

    typename      := design_item_get_item_type (design_item);
    <icon, color> := get_vertex_attributes (typename);

    icon_reg := vcRegion.Create("i",vsimIcon.fac,list(icon,color,vgColor.Black));
    vcTable.Set (tab, 0, 0, icon_reg);


    scope := design_cache_get_scope (node);
    text_reg := vcRegion.Create ("t", vcStaticText.fac, scope,
				width <- 8, max_width <- 8);
    vcRegion.Font (text_reg, vgFont.tiny);
    vcTable.Set (tab, 0, 1, text_reg);

    vcPicklist.Add (icon_box, tab, bookmark);
    num_entries := picklist_num_entries (icon_box);
    vcPicklist.SetPick (icon_box, num_entries-1);

    if (num_entries > 1)
	vcCmd.Enable  (delete_bookmark_cmd, vlOnOff.On);
    else
	vcCmd.Enable  (delete_bookmark_cmd, vlOnOff.Off);
    if (vcRegion.HasBeenReframed (this.main_table))
	vcRegion.Reframe (this.main_table, vcRegion.Area (this.main_table));
    vcRegion.Refresh (region, vcRegion.Area (region));
}


/*  ------------------------- menus ----------------------------------------
 *  adding some pulldown menus
 */


/*  shows the VHDL source of the selected node in the tree widget
 */
function show_source (data, event)
{
    region := vcEvent.Region (event);
    win    := vcEvent.Window (event);
    this   := vcRegion.GetData (region);


    /*  if selected node is invalid then return
     */
    design_cache_node := this.selected_node;
    if (design_cache_node == nil)
	show_message (win, " Show VHDL source: Not a valid design-item ");
    else
    {
	/*  show the VHDL source using a viewsim callvback
	 */
	scope := design_cache_get_scope (design_cache_node);
	vsim.LoadSource (scope);

	/*  update status window
	 */
	show_message (win, " Show VHDL source: Successful");
    }
}
show_VHDL_source_cmd := vcWv.Cmd (fac, show_source, "show_VHDL_source");
vcCmd.SetHelp (show_VHDL_source_cmd, "Show the VHDL source file for the selected VHDL design-item in the design browser");


/*  returns the next available "bookmark_id" which is an integer from 
 *  0 to 31. if all the bookmark_ids are used up, it returns -1
 */
function get_bookmark_id (this)
{
    bookmark_id  := -1;
    bookmark_str := this.bookmark_str;

    /*  don't allow more than 32 bookamrks
     */
    if (this.total_bookmarks < 31)
    {
	/*  get the first empty bookmark_id
	 */
	for (i := 0;  i < 32;  ++i)
	    if (bookmark_str [i] == ' ')
	    {
		bookmark_id = i;
		i = 32;
	    }

	/*  update the bookmark_str and total_bookmarks
	 */
	if (bookmark_id >= 0)
	{
	    bookmark_str [bookmark_id] = '1';
	    this.bookmark_str = bookmark_str;
	    this.total_bookmarks = this.total_bookmarks + 1;
	}
    }

    bookmark_id;
}


/*  deletes the given bookmark_id
 */
function free_bookmark_id (this, bookmark_id)
{
    if (bookmark_id >= 0  &&  bookmark_id < 32)
    {
	bookmark_str := this.bookmark_str;
	bookmark_str [bookmark_id] = ' ';
	this.total_bookmarks = this.total_bookmarks - 1;
	this.bookmark_str = bookmark_str;
    }
}



/*  create a new bookmark for the currently selected node in the tree widget
 */
function create_bookmark (data, event)
{
    region := vcEvent.Region (event);
    win    := vcEvent.Window (event);
    this   := vcRegion.GetData (region);
    tree   := this.tree_region;

    /*  return if there is no valid selected node
     */
    design_cache_node := this.selected_node;
    if (design_cache_node == nil)
    {
	show_message (win, " Unable to create bookmark: Invalid design-item");
	return (nil);
    }

    /*  create a new bookmark and update it for all the nodes
     *  present in the new bookmark subtree (which are the
     *  currently visible nodes)
     */
    if (this.total_bookmarks < 31)
    {
	/*  check if a bookmark for this design-item already exist
	 */
	scope := design_cache_get_scope (design_cache_node);
	if (icon_box_get_bookmark (region, scope) >= 0)
	{
	    /*  it is a duplicate
	     */
	    show_message (win, " Create bookmark: Cannot create duplicate bookmark");
	    return (nil);
	}

	current_bookmark := this.bookmark;
	bookmark_id      := get_bookmark_id (this);
	new_bookmark     := bookmark_create (design_cache_node, bookmark_id);
	bookmark_add_to_design_cache  (new_bookmark, current_bookmark);

	/*  hide the current bookmark, change bookmark and
	 *  show the new bookmark
	 */
	hide_current_bookmark (region);
	this.bookmark = new_bookmark;
	vcRegion.PrefSet (tree, list (anchor_root <- FALSE));
	vcRegion.PrefSet (tree, list (bounds <- vgRect.Create (0,0,0,0)));
	show_current_bookmark (region);
	icon_box_add_bookmark (region, new_bookmark);

	vcRegion.Refresh (tree, vcRegion.Area (tree));
	vcRegion.PrefSet (tree, list (anchor_root <- TRUE));

	/*  update the status area
	 */
	show_message (win, " Create bookmark: Successful");
    }
    else
	show_message (win, " Create bookmark: Cannot add more than 32 bookmarks");
}
create_bookmark_cmd := vcWv.Cmd (fac, create_bookmark, "create_bookmark");
vcCmd.SetHelp (create_bookmark_cmd, "Create bookmark for the selected design-item in the design browser");


/*  delete the current bookmark
 */
function delete_bookmark (data, event)
{
    region   := vcEvent.Region (event);
    win      := vcEvent.Window (event);
    this     := vcRegion.GetData (region);
    tree     := this.tree_region;
    picklist := this.icon_box;

    /*  deletion of a bookmark involves:
     *  deletion of the tree corr. to the bookmark, 
     *  freeing up of the bookmark_id in the "region_data -- this"(bookmark_str)
     *  deletion of the picklist entry in the icon_box picklist
     *  switching to an alternate bookmark in the icon_box picklist
     */


    old_bookmark := this.bookmark;
    node         := bookmark_get_root_dc_node (old_bookmark); 
    id           := bookmark_get_id (old_bookmark);
    scope        := design_cache_get_scope (node);

    /*  kill 2 birds with one stone --
     *
     *  we get the "picklist_index" of the bookmark to be deleted,
     *  we switch to the bookmark which was created prior to the current one,
     *  the "switch" is done by "vcPicklist.SetPick" on the icon_box picklist
     *
     *  this switch, does 2 things selects another bookmark and also
     *  removes the "tree_vertices" of the to-be-deleted-bookmark
     */
    item_index   := icon_box_get_bookmark (region, scope);
    if (item_index < 1)
	return (nil);
    vcPicklist.SetPick (picklist, item_index-1);

    /*  reset the bookmark_id in the subtree corr. the to-be-deleted-bookmark
     *  and free its bookmark_id
     */
    bookmark_remove_from_design_cache (node, id);
    free_bookmark_id (this, id);

    /*  now to the slightly tricky part....
     *  go thru the list of items in "icon_box" picklist and
     *  construct a list of [visual, data] excluding the -to-be-deleted-bookmark
     */
    bookmark_list := nil;
    foreach (row, col, index, is_set, visual, data; vcPicklist.Items (picklist))
	if (index != item_index)
	{
	    bookmark_list = cons (cons (visual, data), bookmark_list);
	    vcPicklist.Clear (picklist, row, col);
	}
    bookmark_list = reverse (bookmark_list);

    /*  we don't really delete the "bookmark-entry" from the picklist --
     *  since such a concept is still not supported by CORE.
     *
     *  workaround: we recreate a new picklist which contains the bookmark_list
     */
    icon_box_table := vcTable.Get (this.main_table, 0, 0);
    new_picklist := vcRegion.Create ("icon picklist", vcPicklist.fac, nil,
				rows        <- 1,
				columns     <- 4,
				will_scroll <- FALSE,
				exclusive   <- TRUE);
    this.icon_box = new_picklist;
    vcRegion.Align (new_picklist, vgAlign.UpperLeft);
    vcTable.Set (icon_box_table, 0, 1, new_picklist);

    /*  add the entries stored in bookmark_list to the new picklist;
     */
    foreach (item;  vscript.iter (bookmark_list))
	vcPicklist.Add (new_picklist, car (item), cdr (item));
    vcPicklist.SetPick (new_picklist, item_index-1);

    add_icon_selection_func (region, new_picklist);

    if (vcRegion.HasBeenReframed (this.main_table))
	vcRegion.Reframe (this.main_table, vcRegion.Area (this.main_table));
    vcRegion.Refresh (region, vcRegion.Area (region));

    show_message (win, " Delete bookmark: Successful");
}
delete_bookmark_cmd := vcWv.Cmd (fac, delete_bookmark, "delete_bookmark");
vcCmd.SetHelp (delete_bookmark_cmd, "Delete the current bookmark");
vcCmd.Enable  (delete_bookmark_cmd, vlOnOff.Off);


/*  select the corr. schematics sheet in viewdraw for the selected
 *  design-icon (node) in the tree widget
 */
function select_comp_in_viewdraw (data, event)
{
    region := vcEvent.Region (event);
    win    := vcEvent.Window (event);

    /*  ignore if viewdraw is not handling the same design
     */
    if (! vsim.IsViewDrawDesignSame())
    {
	show_message (win, " Unable to show schematics: Execute Viewdraw with the same design");
	return (nil);
    }

    this := vcRegion.GetData (region);
    design_cache_node := this.selected_node;

    /*  return if unable to get the slected_node in the tree widget
     */
    if (design_cache_node == nil)
    {
	show_message (win,
		" Unable to show schematics: Schematics info not available");
	return (nil);
    }

    /*  establish a communication channel
     */
    SrcIpcCntx := vipc.Init (vipc.TidVSIM);

    DrawContext := vipc.CntxCreate(vipc.GidDFLT, vipc.UidDFLT,
				vipc.FidDFLT, vipc.TidVDRAW,
				vipc.HnmANY,
				vipc.PidANY, vipc.CidANY);

    DestChannel := vipc.ChanGetServer (DrawContext, vipc.FlgNULL);

    /*  check if communication channel is established
     */
    if (DestChannel != nil)
    {
	scope := get_viewsim_only_scope (design_cache_node);

	design_name := vsim.GetNetName();

	/*  send a message to viewdraw to show the sheet
	 *  corr. to the scope
	 */

	if (string_eq (scope, ""))
	    vipc.Send(vipc.MsgCMD, SrcIpcCntx, DrawContext,
	      "selectpath " + design_name + " \\\"\\\"",vipc.FlgDIRECT);
	else
	    vipc.Send(vipc.MsgCMD, SrcIpcCntx, DrawContext,
	      "selectpath " + design_name + " " +scope, vipc.FlgDIRECT);

	/*  refresh viewdraw screen 
	 */
	vipc.Send(vipc.MsgCMD, SrcIpcCntx, DrawContext,  "refresh",
		vipc.FlgDIRECT);

	vipc.Send(vipc.MsgCMD, SrcIpcCntx, DrawContext,  "zselect",
		vipc.FlgDIRECT);

	show_message (win, " Show schematics: Successful");
    }
    else
	show_message (win,
		    " Unable to show schematics: Viewdraw is not running ");
}
show_comp_schematics_cmd := vcWv.Cmd (fac, select_comp_in_viewdraw, "show_comp_in_schematics");
vcCmd.SetHelp (show_comp_schematics_cmd, "Show the schematics sheet in Viewdraw containing the selected design-item in the design browser");


/*  select the corr. schematics sheet in viewdraw for the selected
 *  design-icon (node) in the tree widget
 */
function select_net_in_viewdraw (data, event)
{
    region := vcEvent.Region (event);
    win    := vcEvent.Window (event);

    /*  ignore if viewdraw is not handling the same design
     */
    if (! vsim.IsViewDrawDesignSame())
    {
	show_message (win, " Unable to show schematics: Execute viewdraw with the same design");
	return (nil);
    }

    this := vcRegion.GetData (region);
    design_cache_node := this.selected_node;

    /*  return if unable to get the slected_node in the tree widget
     */
    if (design_cache_node == nil)
    {
	show_message (win,
		" Unable to show schematics: Schematics info not available");
	return (nil);
    }



    /*  establish a communication channel
     */
    SrcIpcCntx := vipc.Init (vipc.TidVSIM);

    DrawContext := vipc.CntxCreate(vipc.GidDFLT, vipc.UidDFLT,
				vipc.FidDFLT, vipc.TidVDRAW,
				vipc.HnmANY,
				vipc.PidANY, vipc.CidANY);

    DestChannel := vipc.ChanGetServer (DrawContext, vipc.FlgNULL);

    /*  check if communication channel is established
     */
    if (DestChannel != nil)
    {
	scope := get_viewsim_only_scope (design_cache_node);

	/*  get all the selected signals in design spreadsheet
	 */
	spreadsheets := this.spreadsheets;

	name := "";
	foreach (vsimlist_struct;  vscript.iter (spreadsheets))
	    if (equal (vsimlist_struct.object_name, "SIGNAL")  &&
		(vsimlist_struct.visible == TRUE))
	    {
		sr := vsimList.GetSelectedRecords (vsimlist_struct.vsimlist);

		foreach (entry;  vscript.iter (sr))
		    name = cadr (assoc ("SIGNAL", entry));

		if (string_length (name) > 0)
		    break;
		else
		{
		    show_message (win,
		    " Unable to show schematics: No signals were selected");
		    return (nil);
		}
	    }

	design_name := vsim.GetNetName();

	/*  send a message to viewdraw to show the sheet
	 *  corr. to the scope
	 */

	if (! string_eq (name, ""))
	    vipc.Send(vipc.MsgCMD, SrcIpcCntx, DrawContext,
	      "selectpath " + design_name + " " + scope + name, vipc.FlgDIRECT);

	/*  refresh viewdraw screen 
	 */
	vipc.Send(vipc.MsgCMD, SrcIpcCntx, DrawContext,  "refresh",
		vipc.FlgDIRECT);

	vipc.Send(vipc.MsgCMD, SrcIpcCntx, DrawContext,  "zselect",
		vipc.FlgDIRECT);

	show_message (win, " Show schematics: Successful");
    }
    else
	show_message (win,
		    " Unable to show schematics: Viewdraw is not running ");
}
show_net_schematics_cmd := vcWv.Cmd (fac, select_net_in_viewdraw, "show_net_in_schematics");
vcCmd.SetHelp (show_net_schematics_cmd, "Show the net (selected in Design Spreadsheet) in schematics sheet in Viewdraw");


/*  these are not used but useful while adding/testing new commands
 */
function no_op (a, b) ;
no_op_cmd	:= vcWv.Cmd (fac, no_op, nil);
cancel_cmd	:= vcWv.Cmd (fac, vsimNavCancel, "close_navigator");
vcCmd.SetHelp (cancel_cmd, "Close the navigator window");


/*  update the navigator's region-data with the approp. "flag" value about
 *  whether or not to follow sim or not
 */
function update_follow_sim_flag (this, event, flag)
{
    region := vcEvent.Region (event);
    if (flag == vlOnOff.On)
	this.follow_sim = TRUE;
    else
	this.follow_sim = FALSE;
}
follow_sim_cmd := vcWv.Cmd (fac, update_follow_sim_flag,
			    "update_follow_sim_flag",
			    "Specify Follow Sim Flag",
			    vcWv.Param ("Follow Sim", vlOnOffVT,
					vcWv.Sticky, vlOnOff.Off));
vcCmd.SetHelp (follow_sim_cmd, "Enable/Disable updation of the navigator with the VHDL process being executed in the simulator");


function hide_or_show_spreadsheet (this, event, in_flag)
{
    region := vcEvent.Region (event);

    if (in_flag == vlOnOff.On)
	flag := TRUE;
    else
	flag := FALSE;

    /*  hide the spreadsheet if flag is TRUE
     */
    if (flag)
    {
	this.hide_spreadsheet = TRUE;

	/*  set the entries of the table, which holds the spreadsheet 
	 *  and the filter_region to "vcSteel"
	 */
	browser_table := this.browser_table;
	vcTable.Set (browser_table, 0, 1, vcSteel.Create ("s", 0, 0));
	vcTable.Set (browser_table, 1, 1, vcSteel.Create ("t", 0, 0));
	vcTable.Set (browser_table, 2, 1, vcSteel.Create ("s", 0, 0));

	/*  start the old navigator and update its scope
	 */
	vsim.DbgNavHandler (region, event);
	selected_node := this.selected_node;
	scope       := design_cache_get_scope (selected_node);
	design_item := design_cache_get_design_item (selected_node);
	type        := design_item_get_type_int (design_item);
	vsnav.DbgNavUpdateScope (scope, type);
    }

    /*  show the spreadsheet and hide the List Browser
     */
    else
    {
	this.hide_spreadsheet = FALSE;

	/*  add the spreadsheet & filter back into the navigator framework
	 */
	browser_table := this.browser_table;
	vcTable.Set (browser_table, 0, 1, this.label_ds);
	vcTable.Set (browser_table, 1, 1, this.spreadsheet_table);
	vcTable.Set (browser_table, 2, 1, this.filter_table);

	/*  update the contents of the spreadsheet by "Selecting" the vertex
	 */
	remove_all_spreadsheet_entries (region);
	set_spreadsheet_data_fast (region, FALSE);

	/*  close the old navigator
	 */
	vsnav.DbgNavCancel (vcEvent.Region (event), event);
    }

    vcRegion.Reframe (browser_table, vcRegion.Area (browser_table));
    vcRegion.Refresh (region, vcRegion.Area (region));
}

hide_sheet_cmd := vcWv.Cmd (fac, hide_or_show_spreadsheet,
			    "hide_or_show_spreadsheet",
			    "Hide/Show Spreadhsheet",
			    vcWv.Param ("Hide Spreadsheet", vlOnOffVT,
					vcWv.Sticky, vlOnOff.Off));
vcCmd.SetHelp (hide_sheet_cmd, "Hide/Show the spreadhsheet (Hide -- useful for faster interaction)");


/*  for the selected SIGNALS/VARIABLES, invoke a text editor to edit their
 *  current values....
 */
function edit_value (this, event)
{
    region := vcEvent.Region (event);

    if (vcRegion.Window (region) != nil)
	vcWin.Busy (vcRegion.Window (region), TRUE);

    signal_list   := get_selection (region, "SIGNAL");
    variable_list := get_selection (region, "VARIABLE");

    foreach (signal;  vscript.iter (signal_list))
	vsim.edit_val (nil, event, signal, "");

    foreach (variable;  vscript.iter (variable_list))
	vsim.edit_val (nil, event, variable, "");

    if (vcRegion.Window (region) != nil)
	vcWin.Busy (vcRegion.Window (region), FALSE);

    if (!iscons (signal_list)  &&  !iscons (variable_list))
	show_message (vcRegion.Window (region), " Edit Value: No signals/variables were selected ");
}
edit_value_cmd := vcWv.Cmd (fac, edit_value, "edit_value_cmd");
vcCmd.SetHelp (edit_value_cmd, "Edit the value of the selected SIGNAL/VARIABLE in a window");

function deselect_all_in_spreadsheet (this, event)
{
    region := vcEvent.Region (event);

    /*  for each vsimlist region, deselect all the entries
     */
    vsimlist_structs := this.spreadsheets;
    foreach (vsimlist_struct;  vscript.iter (vsimlist_structs))
    {
	vsimList.DeselectAll (vsimlist_struct.vsimlist);
	vcRegion.Refresh (vsimlist_struct.vsimlist,
			    vcRegion.Area (vsimlist_struct.vsimlist));
    }
}
deselect_all_cmd:= vcWv.Cmd (fac, deselect_all_in_spreadsheet, "deselect_all_in_spreadsheet");
vcCmd.SetHelp (deselect_all_cmd, "Deselect all the SIGNALS and VARIABLES in the navigator");


function show_pref_editor (d, event)
    vcPref.CreateSmallWindow (vcEvent.Window (event), fac, prefs);
prefs_cmd := vcWv.Cmd (fac, show_pref_editor, "show_pref_editor");
vcCmd.SetHelp (prefs_cmd, "Show the preference editor for the navigator");


/*  Main pull down menu options
 */
bookmark_menu := vcWv.MakeMenu ("bookmark_menu",
			    list ("Create",          create_bookmark_cmd),
			    list ("Delete",          delete_bookmark_cmd));

edit_menu := vcWv.MakeMenu ("edit_menu",
			    list ("Value...",     edit_value_cmd));
			    /* list ("Deselect All", deselect_all_cmd)); */

show_menu := vcWv.MakeMenu ("show_menu",
			    list ("VHDL Source...",  show_VHDL_source_cmd),
			    list ("Comp In Schematics", show_comp_schematics_cmd),
			    list ("Net  In Schematics", show_net_schematics_cmd));

options_menu := vcWv.MakeMenu ("options_menu",
		vcWv.CheckedOption ("Follow Sim", follow_sim_cmd, FALSE),
		vcWv.CheckedOption ("Hide Spreadsheet", hide_sheet_cmd, FALSE),
		list ("Preferences...",      prefs_cmd));

main_menu := vcWv.MakeMenu ("main_menu",
			    vcWin.RedSquareEntryNoPlot,
			    list ("Bookmark",      bookmark_menu),
			    list ("Edit",          edit_menu),
			    list ("Show",          show_menu),
			    list ("Options",       options_menu));

vcFac.SetMenus (fac, main_menu);

/*  ---------------------------------- end-menus ---------------------------  */


/*  ------------------------------- start-bindings -------------------------  */
vcBind.Set (bindings, vcWv.Ctrl ('b'), create_bookmark_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('e'), delete_bookmark_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('v'), edit_value_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('s'), show_VHDL_source_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('t'), show_comp_schematics_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('n'), show_net_schematics_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('f'), follow_sim_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('h'), hide_sheet_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('p'), prefs_cmd);
vcBind.Set (bindings, vcWv.Ctrl ('d'), deselect_all_cmd);
/*  -------------------------------  end-bindings  -------------------------  */


/*  ------------------------------ start preferences -----------------------  */
vcWv.RequireFac (wv, "vcPref");
vlPref.Replace (prefs, "design_browser_attributes", vscmVT,
	    "Specifies the color and icon for each design type",
	    design_browser_attrib_alist);

vcPref.SetEditor (prefs, "design_browser_attributes", vsimColor.fac);


vlPref.Replace (prefs, "spreadsheet_col_order", vscmVT,
	    "Specifies the column ordering of each spreadsheet",
	    spreadsheet_col_order);

vcPref.SetEditor (prefs, "spreadsheet_col_order", vsimPref.fac);

vlPref.Parse ("powerview.ini", wv);


function spreadsheet_pref_apply (vsimlist_structs, in_format_list)
{
    format_list := deep_copy (in_format_list);

    /*  foreach vsimlist corr. to each spreadsheet_name in format_list
     */
    foreach (item;  vscript.iter (format_list))

	/*  reorder the spreadsheet (specified by "item")
	 */
	foreach (vsimlist_struct;  vscript.iter (vsimlist_structs))
	    if (string_eq (vsimlist_struct.object_name, car (item)))
		vsimList.ReorderFormat (vsimlist_struct.vsimlist,
					cdr (item));
}


function design_browser_pref_apply (this, format_list)
{
    design_browser_attrib_alist = format_list;

    /*  update the attributes inside the 'C' module
     */
    update_design_browser_attributes (format_list);

    /*  update the design_browser's tree widget
     */
    design_cache_modify_vertex_colors (this.design_cache);
    vcRegion.Refresh (this.tree_region, vcRegion.Area (this.tree_region));

    /*  update the book mark icon colors 
     */
    icon_box_modify_icon (this);
}


first_time_Reset := TRUE;
function _Reset (this, region)
{
    if (first_time_Reset)
	first_time_Reset = FALSE;
    else
    {
	if (vlPref.Changed (prefs, "design_browser_attributes"))
	    design_browser_pref_apply (this,
			    vlPref.Val (prefs, "design_browser_attributes"));

	if (vlPref.Changed (prefs, "spreadsheet_col_order"))
	    spreadsheet_pref_apply (this.spreadsheets,
			    vlPref.Val (prefs, "spreadsheet_col_order"));
    }
}

/*  ------------------------------  end preferences  -----------------------  */



function _Create (init_data, region)
{
    /*  i am declaring every variable so that, its easier for me to
     *  convert viewscript-code to "C"
     */
    declare	i, j;
    declare	name;
    declare	main_table;
    declare	browser_table;
    declare	root;
    declare	root_item;
    declare	design_browser;
    declare	spreadsheet_table;
    declare	spreadsheets;
    declare	scope_reg;
    declare	scope_tab;
    declare	filter_reg;
    declare	filter_tab;
    declare	icon_box;
    declare	icon_box_s;
    declare	win;
    declare	this;
    declare	bookmark;
    declare	node;
    declare	design_item;
    declare	rows, cols;

    this = struct {
	design_cache;
	bookmark;
	total_bookmarks;
	bookmark_str;
	selected_node;
	follow_sim;
	hide_spreadsheet;
	main_table;
	browser_table;
	icon_box;
	label_db;
	label_ds;
	tree_region;
	scope_table;
	scope_region;
	scope_prefix;
	spreadsheet_table;
	spreadsheets;
	filter_region;
	filter_table;
	filter_sel;
	ss_pref_sheet;
	db_pref_sheet
    };


    /*  create main table, which holds:
     *
     *  +--------------+
     *  | Menu   Box   |
     *  +--------------+
     *  | Icon   Box   |
     *  +------+-------+
     *  | Tree | Sheet |
     *  +------+-------+
     *  | Scope| Filter|
     *  +------+-------+
     */
    main_table = vcTable.Create ("Navigator", 2, 1);
    browser_table = vcTable.Create ("Navigator Browser", 3, 2);

    vcTable.Row (main_table, vcTable.All, vcTable.Border.Visible, 3, 3, 3,
		 vgAlign.UpperLeft);
    vcTable.Col (main_table, vcTable.All, vcTable.Border.Visible, 3, 3, 3,
		 vgAlign.UpperLeft);

    vcTable.Row (browser_table, vcTable.All, vcTable.Border.Visible, 3, 3, 3,
		vgAlign.MiddleCenter);
    vcTable.Col (browser_table, vcTable.All, vcTable.Border.Adjustable, 9, 9, 9,
		vgAlign.MiddleCenter);

    label_db := vcRegion.Create ("db", vcLabel.fac, "Design Browser");
    vcRegion.Font (label_db, vgFont.mediumb);
    vcTable.Set (browser_table, 0, 0, label_db);

    /*  create vcTree for design browser
     */
    design_browser = create_vctree (region, nil);
    vcTable.Set (browser_table, 1, 0, design_browser);

    /* scope display
     */
    <scope_reg, scope_tab> = create_scope (region);
    vcTable.Set (browser_table, 2, 0, scope_tab);

    label_ds := vcRegion.Create ("db", vcLabel.fac, "Design Spreadsheet");
    vcRegion.Font (label_ds, vgFont.mediumb);
    vcTable.Set (browser_table, 0, 1, label_ds);

    /* spread sheet browser
     */
    <spreadsheet_table, spreadsheets> = create_spreadsheet (region);
    vcTable.Set (browser_table, 1, 1, spreadsheet_table);

    /*  filter window
     */
    <filter_reg, filter_tab> = create_filter (region);
    vcTable.Set (browser_table, 2, 1, filter_tab);

    /*  create Icon box and display root icon
     */
    icon_box_table := nil;
    <icon_box, icon_box_table> = create_icon_box (region);
    vcRegion.Align (icon_box_table, vgAlign.MiddleLeft);
    vcTable.Set (main_table, 0, 0, icon_box_table);

    vcTable.Set (main_table, 1, 0, browser_table);

    vcRegion.AddChild (region, main_table);

    /*  update the lists used for color-typing the nodes in the design_browser
     *
     */
    design_browser_attrib_alist = vcRegion.PrefGet (region,
						   "design_browser_attributes");
    update_design_browser_attributes (design_browser_attrib_alist);


    /*  update the lists used for color-typing the nodes in the design_browser
     *
     */
    spreadsheet_col_order = vcRegion.PrefGet (region, "spreadsheet_col_order");
    spreadsheet_pref_apply (spreadsheets, spreadsheet_col_order);

    this.bookmark	= bookmark;
    this.total_bookmarks= 0;
    this.bookmark_str   = make_string (32);
    this.follow_sim	= FALSE;
    this.hide_spreadsheet = FALSE;
    this.main_table	= main_table;
    this.browser_table	= browser_table;
    this.icon_box	= icon_box;
    this.label_db	= label_db;
    this.label_ds	= label_ds;
    this.tree_region	= design_browser;
    this.scope_table	= scope_tab;
    this.scope_region	= scope_reg;
    this.spreadsheets	= spreadsheets;
    this.spreadsheet_table = spreadsheet_table;
    this.filter_region	= filter_reg;
    this.filter_table	= filter_tab;
    this.filter_sel	= vcTable.Get (filter_tab, 0, 0);

    /*  inhibit the focus cursor, since vsimNav region has bindings
     */
    vcRegion.FocusInhibit (region);
    this;
}


function get_selection (region, type)
{
    declare	out_list;
    declare	name;
    declare	sr;


    this := vcRegion.GetData (region);

    if (this.design_cache == nil)
	return (nil);

    /*  get the selected vertex from vctree
     *  if the type of vertex and required type match return the 
     *  scope string corr. to the vertex
     */
    node        := this.selected_node;
    scope       := design_cache_get_scope (node);
    design_item := design_cache_get_design_item (node);
    node_type   := design_item_get_type (design_item);

    /*  special case to handle "SIGNAL"s at a "PROCESS" scope
     */
    if (string_eq (node_type, "PROCESS")  &&
	string_eq (type, "SIGNAL"))
    {
	parent_node  := design_cache_get_parent (node);
	parent_scope := design_cache_get_scope (parent_node);
    }
    else
	parent_scope := nil;

    if (node != nil)
	if (equal (node_type, type))
	    return list (scope);

    /*  get the spreadsheet corr. to the required type
     *  if not found, return nil
     *  for the corr. spreadsheet, get the set of selected entries
     *  append the scope + name and return the list of entries
     */
    foreach (vsimlist_struct;  vscript.iter (this.spreadsheets))
	if (equal (vsimlist_struct.object_name, type)  &&
	    (vsimlist_struct.visible == TRUE))
	{
	    sr = vsimList.GetSelectedRecords (vsimlist_struct.vsimlist);

	    foreach (entry;  vscript.iter (sr)) {
		if (parent_scope == nil)
		    name = scope + cadr(assoc(type, entry));
		else
		    name = parent_scope + cadr(assoc(type, entry));
		out_list = cons (name, out_list);
	    }
	    return (out_list);
	}

    nil;
}


function reselect_node (region)
    /*  get the new values of the spreadsheet and
     *  update them in the spreadsheet
     */
    update_spreadsheet_data_fast (region, "Value");


function remove_hierarchy (region)
{
    declare	this;
    declare	rows, cols;
    

    this := vcRegion.GetData (region);

    /*  reset the root of the tree
     */
    if (this.design_cache != nil) {
	node := bookmark_get_root_dc_node (this.bookmark);
	vrtx := design_cache_get_vrtx (node);
	vcTree.VrtxRemove (vrtx);
	vcRegion.PrefSet (this.tree_region,
			  list (bounds <- vgRect.Create (0,0,0,0)));
	vcRegion.Refresh  (this.tree_region, vcRegion.Area (this.tree_region));
	this.design_cache = nil;
    }
    
    /*  reset scope string
     */
    reset_scope_string (region, "");

    /*  remove all the icons in icon_box
     */
    if (this.bookmark != nil)
    {
	vcPicklist.Dimensions (this.icon_box, &rows, &cols);
	vcPicklist.DeleteRows (this.icon_box, 0, rows);
	vcRegion.Refresh      (this.icon_box, vcRegion.Area (this.icon_box));
	this.total_bookmarks = 0;
	this.bookmark_str    = make_string (32);
	this.bookmark        = nil;
    }

    /*  reset the spreadsheet area to show no data
     */
    remove_all_spreadsheet_entries (region);

    foreach (vsimlist_struct;  vscript.iter (this.spreadsheets))
	if (vsimlist_struct.visible == TRUE)
	{
	    vcTable.Set (this.spreadsheet_table, vsimlist_struct.row_num, 0,
			     vsimlist_struct.rubber);
	    vsimlist_struct.visible = FALSE;
	}

    vcTable.Row (this.spreadsheet_table, vcTable.All, vcTable.Border.Adjustable,
		3, 3, 3, vgAlign.MiddleCenter);
    vcRegion.Refresh (this.spreadsheet_table,
		vcRegion.Area (this.spreadsheet_table));
    this.selected_node = nil;
}


function set_root (region)
{
    this := vcRegion.GetData (region);
    if (this.design_cache != nil)
	return (nil);

    /*  set the PureVHDL/Mixed design status flag
     */
    design_name := vsim.GetNetName();
    if (string_eq (design_name, "schemles"))
	SchematicsLess = TRUE;
    else
	SchematicsLess = FALSE;

    /*  create a design_cache node and set its design item
     */
    node := design_cache_query_root ();
    vrtx := design_cache_get_vrtx (node);
    vcTree.SetRoot (this.tree_region, vrtx);
    vcRegion.PrefSet (this.tree_region,
		      list (bounds <- vgRect.Create (0,0,0,0)));
    vcRegion.Refresh (this.tree_region, vcRegion.Area (this.tree_region));
    this.design_cache = node;

    bookmark_id   := get_bookmark_id (this);
    bookmark      := bookmark_create (node, bookmark_id);
    this.bookmark  = bookmark;

    /*  select the root node, which triggers the spreadsheet update
     */
    icon_box_add_bookmark (region, bookmark);
    selected_node := bookmark_get_selected_dc_node (bookmark);
    scope         := get_unique_viewsim_scope (selected_node);
    reset_scope_string (region, scope);

    vrtx = design_cache_get_vrtx (selected_node);
    vcTree.SelectVrtx (this.tree_region, vrtx);

    nil;
}


function expand_viewsim_scope (region, new_scope)
{
    this := vcRegion.GetData (region);
    tree := this.tree_region;
    win  := vcRegion.Window (region);

    /*  store the scope of selected_node, incase we end up with that
     */
    selected_scope := design_cache_get_scope (this.selected_node);

    /*  if the new_scope is a vantage VHDL scope, then convert it to vsim scope
     */
    if (lindex (selected_scope, '/') != FALSE)
    {
	tmp_scope := selected_scope;
	selected_scope := convert_vantage_to_viewsim_scope (tmp_scope);
    }
    

    /*  scan the new_scope as a bunch of names for walking thru the hierarchy;
     *  start the walk from the top-level
     */
    found         := TRUE;
    bookmark      := this.bookmark;
    id            := bookmark_get_id (bookmark);
    current_node  := bookmark_get_root_dc_node (bookmark);
    current_scope := get_unique_viewsim_scope (current_node);

    /*  strip out the prefix of the "new_scope" to make it "match"
     *  "current_scope"
     */
    remaining_scope := substring (new_scope, string_length (current_scope), 
				    string_length (new_scope));

    foreach (name;  string_loop (remaining_scope, " \\"))
    {
	/*  if current_node is not expanded, expand it
	 */
	design_item := design_cache_get_design_item (current_node);
	is_expanded := design_item_get_is_expanded (design_item);
	if (is_expanded <= 0)
	{
	    design_cache_query_children (current_node, tree);
	    add_children_vctree_vertices_to_tree (current_node, id);
	    design_item_set_is_expanded (design_item, id+1);
	}

	/*  check if the "name" is a child of current_node
	 */
	children := design_cache_get_children (current_node);
	found = FALSE;
	foreach (child_node;  vscript.iter (children))
	{
	    design_item := design_cache_get_design_item (child_node);
	    child_name  := design_item_get_name (design_item);

	    if (string_eq (child_name, name))
	    {
		/*  if so, move down in the hierarchy
		 */
		current_node  = child_node;
		if (string_eq (current_scope, ""))
		    current_scope = name;
		else
		    current_scope = current_scope + "\\" + name;
		found = TRUE;
		break;
	    }
	}

	if (! found)
	    break;
    }

    if (! string_eq (selected_scope, current_scope))
    {
	/*  select the current_node's vertex
	 */
	vrtx := design_cache_get_vrtx (current_node);
	if (vrtx != nil)
	{
	    vcTree.SelectVrtx (this.tree_region, vrtx);
	    vcTree.SetFocusVrtx (tree, vrtx, TRUE);
	}
	vcRegion.Refresh (this.tree_region, vcRegion.Area (this.tree_region));
    }


    msg := " Design item selected is: \"" + current_scope + "\"";
    show_message (win, msg);
    current_scope;
}


/*  expand_to_scope -- is a part of the regression test suite;
 *  changes the bookmark back to the "root" bookmark;
 *  checks if the given scope hass already been expanded,
 *  if not, it iterates thru the expansion until the given scope has been 
 *  expanded.
 *  selects the node corr. to the scope (which also updates the spreadsheet).
 *  sets the scope string
 */
function expand_to_scope (region, new_scope)
{
    /*  set the icon selection (bookmark/bookmark) to that of the top-level
     */
    icon_box_select (region, "");

    /*  if the new_scope is a vantage VHDL scope, then convert it to vsim scope
     */
    if (lindex (new_scope, '/') != FALSE)
    {
	tmp_scope := new_scope;
	new_scope := convert_vantage_to_viewsim_scope (tmp_scope);
    }

    expand_viewsim_scope (region, new_scope);
}


/*  dump_nav -- is a part of the regression test suite;
 *  generates a string, which contains the following information
 *
 *  current-scope: <scope>
 *  children: <child0> <child1>.... <childn-1>
 *  spreadsheet-info:
 *      signals:
 *          <signal-name> <type> <value>
 *          <signal-name> <type> <value>
 *          ...........
 *      variables:
 *          ...........
 *      ...........
 */
function dump_nav (region)
{
    this := vcRegion.GetData (region);

    if (this.design_cache == nil)
	return (nil);

    selected_node := this.selected_node;
    scope := design_cache_get_scope (selected_node);

    out_string := "SCOPE: " +  scope + "\n";

    out_string = out_string + "CHILDREN:\n";
    children := design_cache_get_children (selected_node);
    foreach (child_node;  vscript.iter (children))
    {
	scope := design_cache_get_scope (child_node);
	out_string = out_string + "    " + scope + "\n";
    }
    out_string = out_string + "\n";

    out_string = out_string + "SPREADSHEET-INFO:\n";
    spreadsheets := this.spreadsheets;
    foreach (vsimlist_struct;  vscript.iter (spreadsheets))
	if (vsimlist_struct.visible)
	{
	    out_string =
	    out_string + "    " + vsimlist_struct.object_name + ":\n";

	    sr := vsimList.GetAllRecords (vsimlist_struct.vsimlist);

	    foreach (entry;  vscript.iter (sr))
	    {
		out_string = out_string + "       ";
		foreach (field;  vscript.iter (entry))
		    out_string = out_string + " " + cadr (field);
		out_string = out_string + "\n";
	    }
	    out_string = out_string + "\n";
	}

    out_string;
}


function StoreSSheetSelectionInCutBuffer (region)
{
    this := vcRegion.GetData (region);

    cut_buffer_string := "";
    string_list       := nil;

    /*  get the selected vertex from vctree
     *  if the type of vertex and required type match return the 
     *  scope string corr. to the vertex
     */
    node        := this.selected_node;
    scope       := design_cache_get_scope (node);
    design_item := design_cache_get_design_item (node);
    node_type   := design_item_get_type (design_item);

    /*  special case to handle "SIGNAL"s at a "PROCESS" scope
     */
    if (string_eq (node_type, "PROCESS"))
    {
	parent_node := design_cache_get_parent (node);
	parent_scope := design_cache_get_scope (parent_node);
    }
    else
	parent_scope := nil;

    /*  for each visible spreadsheet, get the set of selected entries
     *  append the scope + name and return the list of entries
     */
    spreadsheets := this.spreadsheets;
    foreach (vsimlist_struct;  vscript.iter (spreadsheets))
	if (vsimlist_struct.visible == TRUE)
	{
	    type := vsimlist_struct.object_name;
	    sr := vsimList.GetSelectedRecords (vsimlist_struct.vsimlist);

	    if ((parent_scope != nil)  &&  (string_eq (type, "SIGNAL")))
		foreach (entry;  vscript.iter (sr)) {
		    name := parent_scope + cadr(assoc(type, entry));
		    string_list = cons (name, string_list);
		    string_list = cons (" ",  string_list);
		    /* cut_buffer_string = cut_buffer_string + " " + name; */
		}
	    else
		foreach (entry;  vscript.iter (sr)) {
		    name := scope + cadr(assoc(type, entry));
		    string_list = cons (name, string_list);
		    string_list = cons (" ",  string_list);
		    /* cut_buffer_string = cut_buffer_string + " " + name; */
		}
	}

    cut_buffer_string := VscmStringCat (string_list);
    vcRegion.StoreCutBuffer (region, cut_buffer_string);
}


function get_tree (region)
{
    if (region == nil)
	nil;
    else
    {
	this := vcRegion.GetData (region);
	this.tree_region;
    }
}


function get_root (region)
{
    if (region == nil)
	nil;
    else
    {
	this := vcRegion.GetData (region);
	this.design_cache;
    }
}


/*  follow_sim -- updates the selected node in the tree-widget corr. to the
 *                given "new_scope"
 *
 *  follow_sim will execute if the user has "set" the "follow_sim" flag to TRUE
 *  the behaviour is:
 *  if the given scope is in the current_bookmark, then expand_scope()
 *  else switch to the "main"/"top-level" bookmark and then expand_scope()
 *  expand_scope() expands the tree to the given "scope" and highlight/selects
 *  the component/process corr. to the "scope"
 *  here: "scope" always corr. to some VHDL process
 */
function follow_sim (region, new_scope)
{
    if (! isstring (new_scope))
	return (nil);
    
    this := vcRegion.GetData (region);

    /*  if "follow_sim" flag is not enabled, then do nothing
     */
    if (! this.follow_sim)
	return (nil);

    /*  if "new_scope" is equal to "current_scope", then do nothing
     */
    current_scope := design_cache_get_scope (this.selected_node);
    if (string_eq (current_scope, new_scope))
	return (nil);

    /*  check if the "new_scope" is in the current bookmark
     *  this is done as follows:
     *  if the scope is vantage's then convert it to viewsim path
     *  check if the prefix of converted scope is equal to "this.scope_prefix"
     *  if so, then it is in the current bookmark else not
     */
    /*  if the new_scope is a vantage VHDL scope, then convert it to vsim scope
     */
    if (lindex (new_scope, '/') != FALSE)
    {
	tmp_scope := new_scope;
	new_scope := convert_vantage_to_viewsim_scope (tmp_scope);
    }

    /*  check if the prefix of converted scope is equal to "this.scope_prefix"
     */
    scope_prefix := this.scope_prefix;
    if (string_length (new_scope) >= string_length (scope_prefix))
    {
	substr := substring (new_scope, 0, string_length (scope_prefix));

	/*  change bookmark to a "main"/"toplevel" bookmark if not equal
	 */
	if (! string_eq (substr, scope_prefix))
	    icon_box_select (region, "");
    }
    else
	/*  change bookmark to a "main"/"toplevel" bookmark
	 */
	icon_box_select (region, "");


    /*  expand the tree-widget (if necessary) to select the node
     *  corr. to the "new_scope"
     */
    expand_viewsim_scope (region, new_scope);
    /* vcRegion.Refresh (region, vcRegion.Area (region)); */
}

