/*
 * $Revision: 1.3.8.1 $
 */

/* Implements the font picklist */

package vspfont (create_fontlist, apply_changes) {

declare cur_font_index;
declare font_lst;
vspFONT := "FONT";

/* Called when user selects a new font.
 */
function set_font (val, on_off) {

        if (on_off == vlOnOff.Off)
                return (nil);

        vspgraph.set_graphics_modified();
        cur_font_index = val;
}

function index_to_font (lst, index) {
        for (tlst := lst, i := 0; tlst != nil; tlst = cdr(tlst), ++i) {
                if (i == index)
                        return (caar(tlst));
        }
        return (nil);
}

function font_to_index (lst, font) {
        for (tlst := lst, i := 0; tlst != nil; tlst = cdr(tlst), ++i) {
                if (string_eqi (font, caar(tlst)))
                        return (cadr(tlst));
        }
        return (nil);
}

function create_fontlist () {

        font_lst = fac_pack.get_font_names ();
        if (font_lst == nil) {
                cur_font_index = nil;
                return (nil);
        }
        cur_font_index = fac_pack.get_def_font ();
        return (create_pklst (func () return (fac_pack.get_def_font ());,
                `vertical, vspFONT, font_lst,  set_font, FALSE));
}

/* Called when user hits "apply" button on options worksheet
 */
function apply_changes () {

        font_name := index_to_font (font_lst, cur_font_index);
        if (font_name != nil && string_length (font_name) != 0)
                fac_pack.sp_sapopt (string_append(vspFONT, " ", font_name));
}

}        









