/*
 *  $Revision: 1.2.7.1 $
 *
 *  Simple digital clock demonstration.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

/*
 * Create a static text area to show the current time.
 */
r := vcRegion.Create ("Digital Viewscript Clock", vcStaticText.fac,
                      vcWv.Time ());
vcWin.Create (r, vcWin.NoBindings + vcWin.NoStatus);

/*
 * Define a function to update the time displayed in the static text region.
 */
function update() {
    vcStaticText.Clear (r);
    vcStaticText.Add (r, vcWv.Time ());
}

/*
 * Create a timer to call the update function every second.
 */
timer := vcWv.Timer (wv, 1000, update, TRUE);

/*
 * If the user kills the window, be sure to cancel the timer, otherwise
 * errors will occur when the update function is called on the invalid
 * region.
 */
vcRegion.DestroyNotify (r, func(r) vcWv.CancelTimer (timer););
