/* 
 *  $Revision: 1.3.7.1 $
 *
 *  Colored Buttons in Core/Viewscript
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

/*
 * Builds a button region.  Note how that region is composed of the label,
 * border and the button itself.
 */
function Button(name, str, label_flags, proc, button_flags, border_flags, c) {
    label  := vcRegion.Create1 (name, vcLabel.fac, str, label_flags);
    vcRegion.Color (label, c);

    border := vcRegion.Create1 (name, vcBorder.fac, label, border_flags);
    button := vcRegion.Create1 (name, vcButton.fac, proc, button_flags);

    vcRegion.AddChild (button, border);
    vcButton.HighlightRegion (button, border);
    button;
} /* function Button */


function no_op()
    ;

t := vcTable.Create ("Color Buttons", 4, 2);

vcTable.Add (t, Button ("Normal", "Normal", nil, no_op,
                        list (macro_on <- TRUE), nil, vgAllColor.Foreground));
vcTable.Add (t, Button ("Blue", "Blue", nil, no_op, list (macro_on <- TRUE),
                        list (base      <- vgColor.LightBlue,
                              indented  <- vgColor.Blue),
                        vgColor.Black));
vcTable.Add (t, Button ("Cyan", "Cyan", nil, no_op, list (macro_on <- TRUE),
                        list (base      <- vgColor.LightCyan,
                              indented  <- vgColor.Cyan),
                        vgColor.Black));
                     
vcTable.Add (t, Button ("Red", "Red", nil, no_op, list (macro_on <- TRUE),
                        list (base      <- vgColor.LightRed,
                              indented  <- vgColor.Red),
                        vgColor.Black));
                     
vcTable.Add (t, Button ("Green", "Green", nil, no_op, list (macro_on <- TRUE),
                        list (base      <- vgColor.LightGreen,
                              indented  <- vgColor.Green),
                        vgColor.Black));
                     
vcTable.Add (t, Button ("Magenta", "Magenta", nil, no_op,
                        list (macro_on  <- TRUE),
                        list (base      <- vgColor.LightMagenta,
                              indented  <- vgColor.Magenta),
                        vgColor.Black));
vcTable.Add (t, Button ("Brown", "Brown", nil, no_op, list (macro_on <- TRUE),
                        list (base      <- vgColor.Yellow,
                              indented  <- vgColor.Brown),
                        vgColor.Black));
vcTable.Add (t, Button ("Grey", "Grey", nil, no_op, list (macro_on <- TRUE),
                        list (base      <- vgColor.LightGrey,
                              indented  <- vgColor.DarkGrey),
                        vgColor.Black));

vcWin.Create (t);
