/*
 *  $Revision: 1.4.5.1 $
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

/*
 * This file shows when some of the method routines that Core uses are
 * called.  This includes Enter, Leave, FocusIn, FocusOut, and After.
 * Note the use of lexical closures to package up the logging of different
 * commands into one block of code.
 */

function _Create(data, region)
{
    tx := vcRegion.Create1 ("log", vtx.fac, "event.log",
                            list (scratch <- TRUE, macro_on <- TRUE));
    vcRegion.AddChild (region, tx);
    vcRegion.FocusInhibit (tx);
    tx;
}

function log(str)
    func(tx, event) {
        vtx.EndOfBuffer (tx);
        vtx.InsertString (tx, sprintf ("%s: %s\n", str, event));
        vtx.Update (tx);
    }; /* func */

_Enter          := log ("Enter    ");
_Leave          := log ("Leave    ");
_FocusIn        := log ("FocusIn  ");
_FocusOut       := log ("FocusOut ");
before          := log ("Before   ");
after           := log ("After    ");
ch_handler      := log ("Character");

ch_cmd := vcWv.Cmd (fac, ch_handler, "ch_handler");

foreach (c; vcWv.AllChars ())
    if (vcBind.get (vcWv.bindings, c) == nil)
        vcBind.Set (bindings, c, ch_cmd);
