/*
 *  $Revision: 1.4.7.1 $
 *
 *  This file demonstrates dynamic insertions and deletions to a table.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

declare str, row_ed, n_ed;

t := vcTable.Create ("TestTable", 4, 4);
vcRegion.PrefSet (t, list (macro_on <- TRUE));


function ins() {
    vcTable.InsertRows (t,
                        row := vcRegion.Get (row_ed, integer),
                        n := vcRegion.Get (n_ed, integer));
    for (r := row; r < row + n; ++r)
        for (c := 0; c < 4; ++c)
        {
            str = sprintf ("New-%d:%d", r, c);
            vcTable.Add (t, vcRegion.Create1 (str, vcLabel.fac, str, nil));
        }
}

function del()
    vcTable.DeleteRows (t,
                        vcRegion.Get (row_ed, integer),
                        vcRegion.Get (n_ed, integer));

vcTable.Add (t, vcWv.LabelButtonCreate ("ins", "Insert", nil, ins, nil));
vcTable.Add (t, vcWv.LabelButtonCreate ("del", "Delete", nil, del, nil));

function add_textfield(table, prompt, val)
{
    t := vcTable.Create (prompt, 1, 2);
    vcTable.Add (t, vcRegion.Create1 ("prompt", vcLabel.fac, prompt, nil));
    cmdline := vcRegion.Create1 (prompt, vcCmdline.fac, val,
                                 list (macro_on <- TRUE));
    vcTable.Add (t, cmdline);
    vcTable.Add (table, t);
    cmdline;
}

row_ed  = add_textfield (t, "Row #:", "1");
n_ed    = add_textfield (t, "How Many:", "1");

for (r := 1; r < 4; ++r)
    for (c := 0; c < 4; ++c)
    {
        str = sprintf ("Original-%d:%d", r, c);
        vcTable.Add (t, vcRegion.Create1 (str, vcLabel.fac, str, nil));
    }

vcWin.Create (t, 0);
