/*
 *  $Revision: 1.8.7.1 $
 *
 *  This demonstration shows a table of various regions, with different
 *  alignments set.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

table := vcTable.Create ("Table Demo", 4, 4);

/*
 * By default, tables have flexible row and column spacing, with invisible
 * borders.  We're going to put labels into the top row and the left column,
 * explaining all the changes we're making to the defaults.
 */

vcTable.Col (table, 0, vcTable.Border.Visible, 3, 3, 3, vgAlign.UpperRight);
vcTable.Row (table, 0, vcTable.Border.Visible, 3, 3, 3, vgAlign.UpperRight);

function label(str)
    vcRegion.Create1 (str, vcLabel.fac, str, nil);


vcTable.Set (table, 0, 1, label ("Left Justified"));
vcTable.Col (table, 1, vcTable.Border.Visible, 3, 3, 3, vgAlign.LowerLeft);

vcTable.Set (table, 0, 2, label ("Center Justified"));
vcTable.Col (table, 2, vcTable.Border.Adjustable, 3, 3, 3, vgAlign.LowerCenter);

vcTable.Set (table, 0, 3, label ("Right Justified"));
vcTable.Col (table, 3, vcTable.Border.Adjustable, 3, 3, 3, vgAlign.LowerRight);

vcTable.Set (table, 1, 0, label ("Upper Justified"));
vcTable.Row (table, 1, vcTable.Border.Visible, 3, 3, 3, vgAlign.UpperLeft);

vcTable.Set (table, 2, 0, label ("Middle Justified"));
vcTable.Row (table, 2, vcTable.Border.Adjustable, 3, 3, 3, vgAlign.MiddleLeft);

vcTable.Set (table, 3, 0, label ("Lower Justified"));
vcTable.Row (table, 3, vcTable.Border.Adjustable, 3, 3, 3, vgAlign.LowerRight);

vcTable.Set (table, 1, 1,
             vcRegion.Create1 ("1:1", vcStaticText.fac,
                               "Now is the time for all good men
to come to the aid of their country", nil));
icon := vcScroll.Create (vcRegion.Create1 ("1:2", vcIcon.fac, "escher", nil),
                         10, 10,
                         list (cons (`horizontal, 2),
                               cons (`vertical, 2)));
vcTable.Set (table, 1, 2, icon);
vcTable.Set (table, 1, 3,
             vcRegion.Create1 ("1:3", vcPicklist.fac,
                               list (list (cons ("One", 1), cons ("Two", 2)),
                                     list (cons ("Three", 3),cons ("Four", 4)),
                                     list (cons ("Five", 5), cons ("Six", 6)),
                                     list (cons ("Seven", 7))),
                               list (macro_on <- TRUE)));

vcTable.Set (table, 2, 1,
             vcRegion.Create1 ("2:1", vcScalebar.fac, 12,
                               list (macro_on <- TRUE)));
vcTable.Set (table, 2, 2,
             vcRegion.Create1 ("2:2", vcCmdline.fac, "cmdline editor",
                               list (macro_on <- TRUE)));

vcTable.Set (table, 2, 3,
             vcRegion.Create1 ("2:3", vcColor.fac, vgColor.Blue, nil));

vcTable.Set (table, 3, 1,
             vcRegion.Create1 ("3:1", vtx.fac, "/etc/passwd",
                               list (cons (`width, 40),
                                     cons (`height, 10),
                                     cons (`macro_on, TRUE))));

vcTable.Set (table, 3, 2,
             vcRegion.Create1 ("3:2", vcFstyle.fac, vgFill.Diagup1, nil));

popup := vcWv.MakeMenu ("Popup",
                         list (list ("This", ""), list ("is", "")),
                         list (list ("a", ""), list ("popup", "")),
                         list (list ("menu", ""), list ("", "")));

vcTable.Set (table, 3, 3,
             vcWv.PullDownMenu ("3:3", "Pulldown Menu", popup));

vcWin.Create (table, vcWin.NoMenus + vcWin.NoCmdline + vcWin.NoStatus);
