|
| This command file simulates a 16 bit ALU, modeled using VHDL.
|

|
| Define input, output bit vectors
|

v a A[0:15]
v b B[0:15]
v f FUNC_SEL[0:1]
v dout DOUT[0:15]

radix hex a b dout
watch a b CIN f dout COUT

|
| Setup some data values on the A and B vectors.
|

wfm a 0=0 (1000=inc)*1000
wfm b 0=ffff\h (1000=dec by 3)*1000
wfm CIN 0=0

|
| Setup a clock with period 1000, pulse width 100.
| The rising edge of the pulse is 800 units into the period.
|

wfm CLK 0=0 (800=1 100=0 100=0)*1000

|
| On the falling edge of each clock, print all the values
|

break CLK 0 do (print)
defaults -watch -time

|
| For each data value on the A and B ALU inputs, do the AND function.
|

print pagelen 15
echo Performing ADDITION function ...
echo
wfm f 0=00


monitor "DEBUGGING ALU DESIGN" 1 25

monitor "Fuction FUNC_SEL[0:1]" 2 2 f
monitor "REGISTERS" 3 30

monitor "   A[0:15]" 4 2 a
monitor "   B[0:15]" 4 40 b
monitor "DOUT[0:15]" 5 20 dout
monitor "  Carry In" 6 2 cin
monitor " Carry Out" 6 40 cout
monitor "     Clock" 7 20 clk
